FormCalc 6.0 README file

FormCalc is a Mathematica package for the calculation of tree-level
and one-loop Feynman diagrams.  It reads diagrams generated with
FeynArts 3 and returns the results in a way well suited for further
numerical (or analytical) evaluation.

Installation notes for the impatient:

- unpack the archive FormCalc-m.n.tar.gz (presumably you did
  this already or else you wouldn't be reading this file),

- run ./compile to compile the C programs needed by FormCalc.

You can find the complete manual in FC6Guide.ps.gz.

The latest version of FormCalc can be downloaded from
http://www.feynarts.de/formcalc.


Enjoy!

Thomas Hahn
hahn@feynarts.de

C      ALGORITHM 698 , COLLECTED ALGORITHMS FROM ACM.
C      THIS WORK PUBLISHED IN TRANSACTIONS ON MATHEMATICAL SOFTWARE,
C      VOL. 17, NO. 4, DECEMBER, 1991, PP. 452-456.
C
C     This file summarizes the DOUBLE PRECISION routines
C     in this directory. SINGLE PRECISION names are obtained
C     by replacing the leading D with S in all names.
C
C     DTEST1   Simple test driver for DCUHRE.
C              Sample output from a SUN 3/50 is included.
C     DTEST2   More detailed test driver for DCUHRE.
C              Sample output from a SUN 3/50 is included.
C     DCUHRE   Main Integrator.DCUHRE calls DCHHRE and DADHRE.
C     DCHHRE   Checks the input to DCUHRE.
C     DADHRE   The adaptive integration routine.
C              DADHRE calls DTRHRE, DINHRE and DRLHRE.
C     DTRHRE   Maintaines the heap of subtriangles.
C     DINHRE   Computes weights and abscissas of the integration
C              rule. DINHRE calls D132RE, D112RE, D09HRE and D07HRE.
C     D132RE   Computes weights and abscissas for a 2-dimensional
C              rule of degree 13.
C     D113RE   Computes weights and abscissas for a 3-dimensional
C              rule of degree 11.
C     D09HRE   Computes weights and abscissas for a degree 9 rule.
C     D07HRE   Computes weights and abscissas for a degree 7 rule.
C     DRLHRE   Computes estimates of integral and error over
C              subtriangles.
C     DFSHRE   Computes fully symmetric sums of function evaluations.

This is a demonstration for the program packages FormCalc and LoopTools.

Two processes are calculated by the demo:

In subdirectory zzzz:
   Elastic ZZ scattering (Z Z -> Z Z)
   A. Denner, S. Dittmaier, and T. Hahn
   Phys. Rev. D56 (1997) 117.

In subdirectory eett:
   Top-pair production in electron collisions (e+ e- -> \bar t t)
   W. Beenakker, S.C. van der Marck, and W. Hollik
   Nucl. Phys. B365 (1991) 24.


The both cases the demo code consists of three parts:

> fa.m -- Generate the diagrams with FeynArts

> fc.m -- Simplify the symbolic amplitudes with FormCalc

> fortran.m -- Prepare the Fortran program


To execute these programs you need

> Mathematica 2.2 or higher

> FORM 1 or higher
  (FORM 1 is available from ftp://ftp.nikhef.nl/pub/form, FORM 2 is
  commercial; however, FORM 1 will be awfully slow on the ee -> tt
  process)

> FeynArts 2.2
  (available from http://www-itp.physik.uni-karlsruhe.de/feynarts)
  IMPORTANT: you need a version newer than 22 Feb 99.

> LoopTools
  (available from http://www.feynarts.de/looptools)

> GNU's make
  (available from any GNU ftp site, e.g. prep.ai.mit.edu)

> a Fortran-77 compiler (g77 if you don't have any other)

> for plotting the results: gnuplot 3.6 or higher
  (available from ftp://cmpc1.phys.soton.ac.uk/pub)


To run the demo:
(Note: "run xxx.m" means: start Mathematica and type "<< xxx.m".
Please use a new Mathematica session for every part of the demo.)

> Edit fa.m and supply the correct path to your FeynArts distribution
  in the line
	<< ~/FeynArts/FeynArts.m
  (you guessed it, that's where my FeynArts distribution is).

> Run fa.m, this produces files called
	{born,self,vert,box,counter}.amp
  in the directory fa/.

> Run fc.m, this simplifies the *.amp files with FormCalc and puts
  the results into fc/.

> Now comes the tricky bit: you have to adapt NumPrep to your Fortran
  compiler. In particular, you need to add a compiler flag for ignoring
  the 72-column limit of standard F77. To this end, edit NumPrep.m
  (located in the numerics/ subdirectory), search for the string
  "compiler flags", and follow the instructions given in the comments
  there.

> Run fortran.m, this produces Fortran code in files like self.m or
  boxT1.m in the directory fortran. It also produces a GNUmakefile.

  Note: NumPrep by default writes instructions for linking with the
  CERNlib into the makefile. The CERNlib is needed for computing alpha_s,
  and is hence not necessary for purely electroweak processes. If you
  don't have the CERNlib installed, simply remove the flags
  "-L$(CERN)/$(CERN_LEVEL)/lib -lpdflib -lmathlib -lpacklib" from the
  makefile and comment out the following statement in sm_ini.F:
  Alfas = ALPHAS2(Ecms).

> Change into the directory fortran/ and type "gmake". You may want to
  look in run.F for changing parameters. The resulting executable will
  be called run. For several runs, place the parameters for each in a
  separate file, say run1.F, run2.F, ..., and say "gmake run1",
  "gmake run2" etc.

> Run "run" with the following parameters:
	run <pol1> <pol2> <pol3> <pol4> <energyfrom> <energyto>
  where the <poli> are the polarization of the external particles.
  E.g. in the case of ZZ -> ZZ, to obtain a purely longitudinally
  polarized differential cross-section at Sqrt[s] = 250 GeV use
	run 0 0 0 0 250
  or to get an unpolarized integrated cross-section for ee -> tt from
  Sqrt[s] = 500 to 600 GeV use
	run u u u u 500 600

  IMPORTANT: for ee -> tt, the fc.m program calculates the amplitudes
  for unpolarized fermions only (the line Hel[_] = 0 is responsible for
  this). Not surprisingly then, invoking "run" with polarizations
  different from UUUU won't calculate what you expect: not only won't
  it calculate the cross-section for the required polarization, but in
  general it won't even give you the correct unpolarized result because
  of the different averaging factor.

> If you have gnuplot 3.6 installed, you can plot the results with
	plot run-diff.pol=LLLL.E=00500
  plot is a program which writes out a script for running gnuplot and
  which exploits the structure of the file name to make the final plot
  as "publication-ready" as possible. Even if you're not completely
  satisfied with the plot it produces, say you want to modify some
  plotting parameter, you have a head-on start, because all you need
  to do is edit this script. Further notes on plot, e.g. how to compile
  it, can be found in the README file of the numerics/ subdirectory.


An example of why the numerical evaluation cannot be fully automatized:

In the ZZ -> ZZ process, if you compile the program with a Higgs mass
larger than 2 MZ (\sim 182 GeV), and happen to run straight into s ==
MH^2, the program will crash with a division by zero error. This is
because the s-channel Higgs resonance is not treated. This is a specific
thing that must be taken care of by the user.


Send bug reports, omissions, fan mail etc to
Thomas Hahn <hahn@feynarts.de>

Have fun!

This directory contains example calculations with
FeynArts and FormCalc.

The files in this directory are named in the following way:

  PROCESS-MODEL.m	   -- the Mathematica program that
			      generates the Fortran code,

  PROCESS-MODEL.drivers/   -- the directory with customized
			      (process-specific) versions of
			      the driver programs,

  PROCESS-MODEL.fortran/   -- the directory which will be
			      created by PROCESS-MODEL.m
			      and in which the generated
			      Fortran code is put.

Currently, PROCESS is one of

  eett    -- e^+ e^- -> t-bar t
  eettA   -- e^+ e^- -> t-bar t gamma (hard bremsstrahlung for eett)
  eeWW    -- e^+ e^- -> W^+ W^-
  eeHH    -- e^+ e^- -> H^+ H^-
  AAAA    -- gamma gamma -> gamma gamma
  AAtt    -- gamma gamma -> t-bar t
  AAttA   -- gamma gamma -> t-bar t gamma (hard bremsstrahlung for AAtt)
  WWWW    -- W^+ W^- -> W^+ W^-
  ZZZZ    -- Z Z -> Z Z

and MODEL is the FeynArts model-file name minus the ".mod", i.e.

  SM      -- the electroweak Standard Model
  SMbgf   -- the same in the background-field formulation
  MSSM    -- the Minimal Supersymmetric Standard Model

The Fortran code for these processes can also be
obtained from www.hep-processes.de.


To execute the demo programs you need

> Mathematica 5 or higher

> FORM 3.2 or higher
  (available from http://www.nikhef.nl/~form)

> FeynArts 3.2 or higher
  (available from http://www.feynarts.de)

> LoopTools 2.2 or higher
  (available from http://www.feynarts.de/looptools)

> GNU make 3.80 or higher
  (available e.g. from http://www.gnu.org/directory/GNU/make.html)

> a Fortran-77 compiler (g77 if you don't have any other)

> for plotting the results: gnuplot 3.7 or higher
  (available from http://www.gnuplot.info)


The demo programs are invoked as follows:

Please do have a look at PROCESS-MODEL.m to see what it's doing,
whether e.g. some diagrams are left out or similar things.

Start Mathematica and type
	<< PROCESS-MODEL.m

After the program has finished, quit Mathematica and change into the
directory PROCESS-MODEL.fortran.  You may want to look into run.F or 
model.h for changing some of the parameters.  Then type
	./configure
	make
to compile the Fortran code.  The resulting executable will be called
run.  For several runs, place the parameters for each in a separate
file, say run1.F, run2.F, ..., and say "make run1", "make run2" etc.

Run "run" with the following parameters:
	./run <p1>...<pN> <sqrtS_from>,<sqrtS_to>
where the <pi> are the polarizations of the external particles.
E.g. to obtain an unpolarized differential cross-section at
Sqrt[s] = 500 GeV use
	./run uuuu 500
This creates a subdirectory called run.UUUU.00500 with the
output files.  Extract the "real" data from those (log)files using
	./data run.UUUU.00500
which results in a file run.UUUU.00500.data.  The data are
organized in columns, where column 1 is the ordinate data (angle
for a differential cross-section, Sqrt[S] for a total), column 2
is the Born cross-section, column 3 is the one-loop correction.
If present, columns 4 and 5 contain the integration errors for
columns 2 and 3, respectively.

If you have gnuplot 3.7 (or higher) installed, it is very easy to
plot the results.  Invoke e.g.
	./pnuglot run.UUUU.00500.data
It is important to understand that pnuglot does not make the plot
directly.  Rather, it writes out a shell script to do this
(run.UUUU.00500.gpl) which it then executes to produce the actual
plot (run.UUUU.00500.eps).  The advantage of this extra level of 
indirection is that if you're not completely satisfied with the
gnuplot commands pnuglot puts into the script by default, you can
easily edit run.UUUU.00500.gpl and change whatever you like.  Then
run the .gpl script (not pnuglot!) from the shell prompt to update
the .eps file:
	./run.UUUU.00500.gpl


Send bug reports, omissions, fan mail etc. to
Thomas Hahn <hahn@feynarts.de>

Have fun!

      SUBROUTINE D07HRE(NDIM,WTLENG,W,G,ERRCOF,RULPTS)
C***BEGIN PROLOGUE D07HRE
C***KEYWORDS basic integration rule, degree 7
C***PURPOSE  To initialize a degree 7 basic rule, and null rules.
C***AUTHOR   Alan Genz, Computer Science Department, Washington
C            State University, Pullman, WA 99163-1210 USA
C***LAST MODIFICATION 88-05-31
C***DESCRIPTION  D07HRE initializes a degree 7 integration rule,
C            two degree 5 null rules, one degree 3 null rule and one
C            degree 1 null rule for the hypercube [-1,1]**NDIM.
C
C   ON ENTRY
C
C   NDIM   Integer.
C          Number of variables.
C   WTLENG Integer.
C          The number of weights in each of the rules.
C          WTLENG MUST be set equal to 6.
C
C   ON RETURN
C   W      Real array of dimension (5,WTLENG).
C          The weights for the basic and null rules.
C          W(1,1),...,W(1,WTLENG) are weights for the basic rule.
C          W(I,1),...,W(I,WTLENG), for I > 1 are null rule weights.
C   G      Real array of dimension (NDIM, WTLENG).
C          The fully symmetric sum generators for the rules.
C          G(1, J), ..., G(NDIM, J) are the are the generators for the
C          points associated with the Jth weights.
C   ERRCOF Real array of dimension 6.
C          Heuristic error coefficients that are used in the
C          error estimation in BASRUL.
C   RULPTS Real array of dimension WTLENG.
C          A work array.
C
C***REFERENCES A. Genz and A. Malik,
C             "An Imbedded Family of Fully Symmetric Numerical
C              Integration Rules",
C              SIAM J Numer. Anal. 20 (1983), pp. 580-588.
C***ROUTINES CALLED-NONE
C***END PROLOGUE D07HRE
C
C   Global variables
C
      INTEGER NDIM,WTLENG
      DOUBLE PRECISION W(5,WTLENG),G(NDIM,WTLENG),ERRCOF(6)
      DOUBLE PRECISION RULPTS(WTLENG)
C
C   Local Variables
C
      DOUBLE PRECISION RATIO,LAM0,LAM1,LAM2,LAMP,TWONDM
      INTEGER I,J
C
C***FIRST EXECUTABLE STATEMENT D07HRE
C
C
C     Initialize generators, weights and RULPTS
C
      DO 30 J = 1,WTLENG
          DO 10 I = 1,NDIM
              G(I,J) = 0
10        CONTINUE
          DO 20 I = 1,5
              W(I,J) = 0
20        CONTINUE
          RULPTS(J) = 2*NDIM
30    CONTINUE
      TWONDM = 2**NDIM
      RULPTS(WTLENG) = TWONDM
      RULPTS(WTLENG-1) = 2*NDIM* (NDIM-1)
      RULPTS(1) = 1
C
C     Compute squared generator parameters
C
      LAM0 = 0.4707
      LAMP = 0.5625
      LAM1 = 4/ (15-5/LAM0)
      RATIO = (1-LAM1/LAM0)/27
      LAM2 = (5-7*LAM1-35*RATIO)/ (7-35*LAM1/3-35*RATIO/LAM0)
C
C     Compute degree 7 rule weights
C
      W(1,6) = 1/ (3*LAM0)**3/TWONDM
      W(1,5) = (1-5*LAM0/3)/ (60* (LAM1-LAM0)*LAM1**2)
      W(1,3) = (1-5*LAM2/3-5*TWONDM*W(1,6)*LAM0* (LAM0-LAM2))/
     +         (10*LAM1* (LAM1-LAM2)) - 2* (NDIM-1)*W(1,5)
      W(1,2) = (1-5*LAM1/3-5*TWONDM*W(1,6)*LAM0* (LAM0-LAM1))/
     +         (10*LAM2* (LAM2-LAM1))
C
C     Compute weights for 2 degree 5, 1 degree 3 and 1 degree 1 rules
C
      W(2,6) = 1/ (36*LAM0**3)/TWONDM
      W(2,5) = (1-9*TWONDM*W(2,6)*LAM0**2)/ (36*LAM1**2)
      W(2,3) = (1-5*LAM2/3-5*TWONDM*W(2,6)*LAM0* (LAM0-LAM2))/
     +         (10*LAM1* (LAM1-LAM2)) - 2* (NDIM-1)*W(2,5)
      W(2,2) = (1-5*LAM1/3-5*TWONDM*W(2,6)*LAM0* (LAM0-LAM1))/
     +         (10*LAM2* (LAM2-LAM1))
      W(3,6) = 5/ (108*LAM0**3)/TWONDM
      W(3,5) = (1-9*TWONDM*W(3,6)*LAM0**2)/ (36*LAM1**2)
      W(3,3) = (1-5*LAMP/3-5*TWONDM*W(3,6)*LAM0* (LAM0-LAMP))/
     +         (10*LAM1* (LAM1-LAMP)) - 2* (NDIM-1)*W(3,5)
      W(3,4) = (1-5*LAM1/3-5*TWONDM*W(3,6)*LAM0* (LAM0-LAM1))/
     +         (10*LAMP* (LAMP-LAM1))
      W(4,6) = 1/ (54*LAM0**3)/TWONDM
      W(4,5) = (1-18*TWONDM*W(4,6)*LAM0**2)/ (72*LAM1**2)
      W(4,3) = (1-10*LAM2/3-10*TWONDM*W(4,6)*LAM0* (LAM0-LAM2))/
     +         (20*LAM1* (LAM1-LAM2)) - 2* (NDIM-1)*W(4,5)
      W(4,2) = (1-10*LAM1/3-10*TWONDM*W(4,6)*LAM0* (LAM0-LAM1))/
     +         (20*LAM2* (LAM2-LAM1))
C
C     Set generator values
C
      LAM0 = SQRT(LAM0)
      LAM1 = SQRT(LAM1)
      LAM2 = SQRT(LAM2)
      LAMP = SQRT(LAMP)
      DO 40 I = 1,NDIM
          G(I,WTLENG) = LAM0
40    CONTINUE
      G(1,WTLENG-1) = LAM1
      G(2,WTLENG-1) = LAM1
      G(1,WTLENG-4) = LAM2
      G(1,WTLENG-3) = LAM1
      G(1,WTLENG-2) = LAMP
C
C     Compute final weight values.
C     The null rule weights are computed from differences between
C     the degree 7 rule weights and lower degree rule weights.
C
      W(1,1) = TWONDM
      DO 70 J = 2,5
          DO 50 I = 2,WTLENG
              W(J,I) = W(J,I) - W(1,I)
              W(J,1) = W(J,1) - RULPTS(I)*W(J,I)
50        CONTINUE
70    CONTINUE
      DO 80 I = 2,WTLENG
          W(1,I) = TWONDM*W(1,I)
          W(1,1) = W(1,1) - RULPTS(I)*W(1,I)
80    CONTINUE
C
C     Set error coefficients
C
      ERRCOF(1) = 5
      ERRCOF(2) = 5
      ERRCOF(3) = 1
      ERRCOF(4) = 5
      ERRCOF(5) = 0.5
      ERRCOF(6) = 0.25
C
C***END D07HRE
C
      END

* CEigensystem.F
* diagonalization of a complex n-by-n matrix using the Jacobi algorithm
* code adapted from the "Handbook" routines for complex A
* (Wilkinson, Reinsch: Handbook for Automatic Computation, p. 202)
* this file is part of the Diag library
* last modified 30 Nov 11 th

#include "diag-f.h"


************************************************************************
** CEigensystem diagonalizes a general complex n-by-n matrix.
** Input: n, A = n-by-n matrix
** Output: d = vector of eigenvalues, U = transformation matrix
** these fulfill diag(d) = U A U^-1.

	subroutine CEigensystem(n, A,ldA, d, U,ldU, sort)
	implicit none
	integer n, ldA, ldU, sort
	ComplexType A(ldA,*), U(ldU,*), d(*)

	integer p, q, j
	RealType red, off, thresh
	ComplexType delta, t, s, invc, sx, sy, tx, ty
	ComplexType x, y
	ComplexType ev(2,MAXDIM)

	integer sweep
	common /nsweeps/ sweep

	if( n .gt. MAXDIM ) then
	  print *, "Dimension too large"
	  d(1) = -999
	  return
	endif

	do p = 1, n
	  ev(1,p) = 0
	  ev(2,p) = A(p,p)
	  d(p) = ev(2,p)
	enddo

	do p = 1, n
	  do q = 1, n
	    U(q,p) = 0
	  enddo
	  U(p,p) = 1
	enddo

	red = .01D0/n**4

	do sweep = 1, 50
	  off = 0
	  do q = 2, n
	    do p = 1, q - 1
	      off = off + Sq(A(p,q)) + Sq(A(q,p))
	    enddo
	  enddo
	  if( .not. off .gt. EPS ) goto 1

	  thresh = 0
	  if( sweep .lt. 4 ) thresh = off*red

	  do q = 2, n
	    do p = 1, q - 1
	      off = Sq(A(p,q)) + Sq(A(q,p))
	      if( sweep .gt. 4 .and. off .lt.
     &              EPS*(Sq(ev(2,p)) + Sq(ev(2,q))) ) then
	        A(p,q) = 0
	        A(q,p) = 0
	      else if( off .gt. thresh ) then
	        delta = A(p,q)*A(q,p)
	        x = .5D0*(ev(2,p) - ev(2,q))
	        y = sqrt(x**2 + delta)
	        t = x - y
	        s = x + y
	        if( Sq(t) .lt. Sq(s) ) t = s

	        t = 1/t
	        delta = delta*t
	        ev(1,p) = ev(1,p) + delta
	        ev(2,p) = d(p) + ev(1,p)
	        ev(1,q) = ev(1,q) - delta
	        ev(2,q) = d(q) + ev(1,q)

	        invc = sqrt(delta*t + 1)
	        s = t/invc
	        t = t/(invc + 1)
	        sx = s*A(p,q)
	        ty = t*A(p,q)
	        sy = s*A(q,p)
	        tx = t*A(q,p)

	        do j = 1, n
	          x = A(j,p)
	          y = A(j,q)
	          A(j,p) = x + sy*(y - ty*x)
	          A(j,q) = y - sx*(x + tx*y)
	          x = A(p,j)
	          y = A(q,j)
	          A(p,j) = x + sx*(y - tx*x)
	          A(q,j) = y - sy*(x + ty*y)
	        enddo

	        A(p,q) = 0
	        A(q,p) = 0

	        do j = 1, n
	          x = U(p,j)
	          y = U(q,j)
	          U(p,j) = x + sx*(y - tx*x)
	          U(q,j) = y - sy*(x + ty*y)
	        enddo
	      endif
	    enddo
	  enddo

	  do p = 1, n
	    ev(1,p) = 0
	    d(p) = ev(2,p)
	  enddo
	enddo

	print *, "Bad convergence in CEigensystem"

1	if( sort .eq. 0 ) return

* sort the eigenvalues by their real part

	do p = 1, n - 1
	  j = p
	  t = d(p)
	  do q = p + 1, n
	    if( sort*(Re(t) - Re(d(q))) .gt. 0 ) then
	      j = q
	      t = d(q)
	    endif
	  enddo

	  if( j .ne. p ) then
	    d(j) = d(p)
	    d(p) = t
	    do q = 1, n
	      x = U(p,q)
	      U(p,q) = U(j,q)
	      U(j,q) = x
	    enddo
	  endif
	enddo
	end

* VeS.F
* computes Vector.eps.Spinor
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


	integer function VeS(a, b)
	implicit none
	integer a, b

	ComplexType vec(2,2, 1)
	common /vectors/ vec

	ComplexType spi(2, 2)
	equivalence (spi, vec)

#define A(x,y) vec(x,y, a)
#define B(x) spi(x, b)
#define accu 1

	spi(1, accu) = A(1,1)*B(2) - A(1,2)*B(1)
	spi(2, accu) = A(2,1)*B(2) - A(2,2)*B(1)
	VeS = accu
	end

* num.F
* this is the driver program for Fortran code
* produced by WriteSquaredME
* this file is part of FormCalc
* last modified 4 Mar 02 th

* Note: this file actually supplies only utility functions.
* The main program and all other parts of the code that depend
* on the kinematics are included by process.h (e.g. 2to2.F).


#define SCALAR 0
#define FERMION 1
#define PHOTON 2
#define VECTOR 3

#include "prefix.h"
#include "process.h"


************************************************************************
** ParseCommandline reads the polarizations and the energy range from
** the command line. From these values, it constructs a file name and
** opens the file for writing as file #11.

	subroutine ParseCommandline(Ecmsfrom, Ecmsto)
	implicit none
	double precision Ecmsfrom, Ecmsto

#include COMMON

	integer*4 iargc
	external iargc

	integer argc, i, j
	character*200 argv, outf
	character*LEGS polstr
	character c

	integer type(LEGS)
	data type /TYPES/

	argc = iargc()
	if(argc .lt. LEGS + 1 .or. argc .gt. LEGS + 2) then
	  print *, "USAGE:"
	  print *, "to calculate a differential cross-section:"
	  print *, "  num p1 p2 ... pn sqrts"
	  print *, "to calculate an integrated cross-section:"
	  print *, "  num p1 p2 ... pn sqrts_from sqrts_to"
	  print *, "where the polarizations p1...pn may be one of"
	  print *, "  0  for longitudinal   polarization"
	  print *, "  +  for right-circular      ''"
	  print *, "  -  for left-circular       ''"
	  print *, "  t  for transverse          ''"
	  print *, "  u  for unpolarized particle"
	  stop
	endif

	avgfac = COLOURFACTOR

	do i = 1, LEGS
	  if(type(i) .eq. SCALAR) then
	    c = 'S'
	    bpol(i) = 0
	    epol(i) = 0
	  else
	    call getarg(i, argv)
	    c = argv(1:1)
	    if(type(i) .eq. FERMION) then
	      if(c .eq. 'u') then
	        j = 0
	        if(i .gt. 2) avgfac = avgfac*2
	        c = 'U'
	      else if(c .eq. '+') then
	        j = 1
	      else if(c .eq. '-') then
	        j = -1
	      else
	        stop "Invalid polarization"
	      endif
	      bpol(i) = j
	      epol(i) = j
	    else
	      if(c .eq. 'u') then
	        if(type(i) .eq. PHOTON)
     +            stop "No longitudinal polarizations allowed"
	        bpol(i) = 0
	        epol(i) = 2
	        if(i .lt. 3) avgfac = avgfac/3D0
	        c = 'U'
	      else if(c .eq. 't') then
	        bpol(i) = 1
	        epol(i) = 2
	        if(i .lt. 3) avgfac = avgfac/2D0
	        c = 'T'
	      else
	        if(c .eq. 'l' .or. c .eq. '0') then
	          if(type(i) .eq. PHOTON)
     +              stop "No longitudinal polarizations allowed"
	          j = 0
	          c = 'L'
	        else if(c .eq. '+') then
	          j = 1
	        else if(c .eq. '-') then
	          j = 2
	        else
	          stop "Invalid polarization"
	        endif
	        bpol(i) = j
	        epol(i) = j
	      endif
	    endif
	  endif
	  polstr(i:i) = c
	enddo

22	format(E20.0)
23	format("diff.pol=", A, ".E=", I5.5)
24	format("tot.pol=", A, ".E=", I5.5, "-", I5.5)

	call getarg(LEGS + 1, argv)
	read(argv, 22) Ecmsfrom
	if(argc .gt. LEGS + 1) then
	  call getarg(LEGS + 2, argv)
	  read(argv, 22) Ecmsto
	  write(outf, 24) polstr, int(Ecmsfrom), int(Ecmsto)
	else
	  Ecmsto = -1
	  write(outf, 23) polstr, int(Ecmsfrom)
	endif

	call getarg(0, argv)
	i = 0
12	continue
	i = i + 1
	if(argv(i:i) .ne. ' ') goto 12
	outf = argv(1:i - 1) // "-" // outf

	open(11, file=outf, status='UNKNOWN')
	print *, "output file: ", outf
	end


************************************************************************
** VecSet constructs the CMS representation of a momentum and the
** three corresponding polarization vectors. The arguments:
** n: the index of the momentum in the array vec
** dir: 1 for incoming, -1 for outgoing particle
** m, p: mass and three-momentum of the particle
** ex, ey, ez: the unit three-vector of the momentum

	subroutine VecSet(n, dir, m, p, ex, ey, ez)
	implicit none
	integer n, dir
	double precision m, p, ex, ey, ez

#include COMMON

	double precision E, sinth
	integer rho, nn

	E = sqrt(p**2 + m**2)

	vec(0, n) = E
	vec(1, n) = p*ex
	vec(2, n) = p*ey
	vec(3, n) = p*ez

	if(m .ne. 0) then
	  vec(0, n + 1) = p/m
	  vec(1, n + 1) = E/m*ex
	  vec(2, n + 1) = E/m*ey
	  vec(3, n + 1) = E/m*ez
	endif

	vec(0, n + 2) = 0
	sinth = 1 - ez**2
	if(sinth .ne. 0) then
	  sinth = sqrt(sinth)
	  vec(1, n + 2) = (ex*ez - dir*ey*cI)/sinth/sqrt2
	  vec(2, n + 2) = (ey*ez + dir*ex*cI)/sinth/sqrt2
	  vec(3, n + 2) = -sinth/sqrt2
	else
	  vec(1, n + 2) = 1/sqrt2
	  vec(2, n + 2) = dir*ez/sqrt2*cI
	  vec(3, n + 2) = 0
	endif

	do rho = 0, 3
	  vec(rho, n + 3) = dconjg(vec(rho, n + 2))
	enddo

	do nn = n, n + 3
	  do rho = 0, 3
	    vec(rho, -nn) = dconjg(vec(rho, nn))
	  enddo
	enddo
	end


************************************************************************
** The Kronecker delta.

	integer function Delta(i, j)
	implicit none
	integer i, j

	if(i .eq. j) then
	  Delta = 1
	else
	  Delta = 0
	endif
	end


************************************************************************
** MomSquare is a function used to calculate Mandelstam variables
** which in general are the squared difference of two momenta. If the
** squared sum is needed, the second argument must be passed as a
** negative integer. Since MomSquare is called only on momentum
** vectors, all operations are done only on the real part.

	double precision function MomSquare(i, j)
	implicit none
	integer i, j

#include COMMON

	if(j .lt. 0) then
	  MomSquare =
     +      (dble(vec(0, i)) + dble(vec(0, j)))**2 -
     +      (dble(vec(1, i)) + dble(vec(1, j)))**2 -
     +      (dble(vec(2, i)) + dble(vec(2, j)))**2 -
     +      (dble(vec(3, i)) + dble(vec(3, j)))**2
	else
	  MomSquare =
     +      (dble(vec(0, i)) - dble(vec(0, j)))**2 -
     +      (dble(vec(1, i)) - dble(vec(1, j)))**2 -
     +      (dble(vec(2, i)) - dble(vec(2, j)))**2 -
     +      (dble(vec(3, i)) - dble(vec(3, j)))**2
	endif
	end


************************************************************************
** Pair calculates the scalar product of two four-vectors.

	double complex function Pair(i, j)
	implicit none
	integer i, j

#include COMMON

	Pair =
     +    vec(0, i)*vec(0, j) -
     +    vec(1, i)*vec(1, j) -
     +    vec(2, i)*vec(2, j) -
     +    vec(3, i)*vec(3, j)
	end


************************************************************************
** Eps calculates -I times the Levi-Civita tensor contracted with
** four four-vectors.

	double complex function Eps(i, j, k, l)
	implicit none
	integer i, j, k, l

#include COMMON

	double complex x01, x02, x03, x12, x13, x23

	double complex Cross
	integer mu_, nu_

	Cross(mu_, nu_) =
     +    vec(mu_, k)*vec(nu_, l) - vec(nu_, k)*vec(mu_, l)

	x01 = Cross(0, 1)
	x02 = Cross(0, 2)
	x03 = Cross(0, 3)
	x12 = Cross(1, 2)
	x13 = Cross(1, 3)
	x23 = Cross(2, 3)

	Eps =
     +    vec(0, i)*(vec(1, j)*x23 - vec(2, j)*x13 + vec(3, j)*x12) -
     +    vec(1, i)*(vec(0, j)*x23 - vec(2, j)*x03 + vec(3, j)*x02) +
     +    vec(2, i)*(vec(0, j)*x13 - vec(1, j)*x03 + vec(3, j)*x01) -
     +    vec(3, i)*(vec(0, j)*x12 - vec(1, j)*x02 + vec(2, j)*x01)

* Note: although Eps is defined as -I*(Levi-Civita tensor) in FormCalc,
* we have to multiply with I (not -I) here because we've neglected
* the metric in the summation above.

	Eps = cI*Eps
	end


#ifdef BREMSSTRAHLUNG

************************************************************************
** SoftPhotonFactor adds up the contributions from soft-photon emission
** off the different legs. The result then has to be multiplied with
** the Born cross-section.

	double precision function SoftPhotonFactor()
	implicit none

#include COMMON

	double precision PhaseSpaceIntegral
	external PhaseSpaceIntegral

	integer i, j

	double precision loglambda
	common /infrared/ loglambda

	double precision Ecms
	equivalence (Ecms, sqrtS)

	double precision ch1, ch2, ch3, ch4, relsign(4), r
	parameter (ch1 = CHARGE1, ch2 = CHARGE2,
     +             ch3 = CHARGE3, ch4 = CHARGE4)
	data relsign / ch1, ch2, -ch3, -ch4 /

	loglambda = log(4*(ESOFTMAX)**2/getlambda())

	SoftPhotonFactor = 0
	do i = 1, 4
	  do j = i, 4
	    r = relsign(i)*relsign(j)
	    if(r .ne. 0) SoftPhotonFactor = SoftPhotonFactor +
     +        r*PhaseSpaceIntegral(i, j)
	  enddo
	enddo
	SoftPhotonFactor = -4*pi*Alfa/(2*pi)**3*SoftPhotonFactor
	end


************************************************************************
** PhaseSpaceIntegral calculates the integral over the soft photon's
** phase space. See A. Denner, Fortschr. d. Physik, 41 (1993) 4.

	double precision function PhaseSpaceIntegral(i, j)
	implicit none
	integer i, j

#include COMMON

	double complex Pair
	double precision Li2
	external Pair, Li2

	double precision ki0, ki, ki2, kidelta, kilog
	double precision kj0, kj, kj2, kjdelta, kjlog
	double precision kikj, alpha, d, vi

	double precision loglambda
	common /infrared/ loglambda

	call getkk0(i, ki0, ki, kidelta, kilog)

	if(i .eq. j) then
	  PhaseSpaceIntegral = pi*(loglambda + ki0/ki*kilog)
	  return
	endif

	call getkk0(j, kj0, kj, kjdelta, kjlog)
	kikj = dble(Pair(4*i - 3, 4*j - 3))
	ki2 = mass(i)
	kj2 = mass(j)

	d = sqrt(kikj**2 - ki2*kj2)
	alpha = (kikj + d)/ki2
	if(sign(kj0, alpha*ki0 - kj0) .ne. kj0) alpha = (kikj - d)/ki2

	d = 1/(alpha**2*ki2 - kj2)
	vi = 2*(alpha*ki0 - kj0)*d

	PhaseSpaceIntegral = 4*pi*alpha*kikj*d * (
     +    .5D0*log(ki2/kj2*alpha**2)*loglambda +
     +    .25D0*(kilog**2 - kjlog**2) +
     +    Li2(1 - (ki0 + ki)*alpha*vi) + Li2(1 - kidelta*alpha*vi) -
     +    Li2(1 - (kj0 + kj)*vi) - Li2(1 - kjdelta*vi) )

	end


************************************************************************
** getkk0 computes k and k0 for a given momentum. It also returns the
** difference (k0 - k), which needs to be computed using a series
** expansion if the mass is very small to achieve sufficient accuracy.

	subroutine getkk0(i, k0, k, kdelta, klog)
	implicit none
	integer i
	double precision k0, k, kdelta, klog

#include COMMON

	integer ii

	ii = 4*i - 3
	k0 = dble(vec(0, ii))
	k = sqrt( dble(vec(1, ii))**2 + dble(vec(2, ii))**2 +
     +    dble(vec(3, ii))**2 )

	kdelta = k0 - k
	if(kdelta .lt. 1D-8*k) kdelta = .5D0*mass(i)/k

	klog = log(kdelta/(k0 + k))
	end

#endif BREMSSTRAHLUNG


************************************************************************
** Li2 calls the dilogarithm function of FF, ffzxdl

	double precision function Li2(x)
	implicit none
	double precision x

#include COMMON

	double precision pi12
	parameter (pi12 = pi**2/12D0)

	double complex cli2, dummy
	integer ier, ipi12

	ier = 0
	call ffzxdl(cli2, ipi12, dummy, x, 1, ier)
	Li2 = dble(cli2) + ipi12*pi12
	end

* sm_ini.F
* all parameters for the Standard Model are initialized here
* this file is part of FormCalc
* last modified 14 Jun 01 th


	subroutine model_ini(Ecms, reset, *)
	implicit none
	double precision Ecms
	logical reset

	double precision ALPHAS2
	external ALPHAS2

#include "model.h"


* Warning: With the PDG values used here, the CKM matrix is
* not strictly unitary. In cases where GIM cancellations are
* important, this parametrization may give wrong results!

	data CKM /
     +    .97495D0, .2225D0,  .0035D0,
     +    .222D0,   .97415D0, .040D0,
     +    .009D0,   .039D0,   .99915D0 /

	data MLE  / ME,  MM,  ML  /
	data MLE2 / ME2, MM2, ML2 /

	data MQU  / MU,  MC,  MT  /
	data MQU2 / MU2, MC2, MT2 /

	data MQD  / MD,  MS,  MB  /
	data MQD2 / MD2, MS2, MB2 /

	Alfas = ALPHAS2(Ecms)
	Alfas2 = Alfas**2
	GS = sqrt(4*pi*Alfas)

	if(.not. reset) return

	EL = sqrt(4*pi*Alfa)

* boson masses

	MH2 = MH**2
	SW = sqrt(SW2)

#ifdef DEBUG

	print *, "============================"
	print *, "SM parameters"
	print *, "----------------------------"
	print *, "1/alpha =", 1/Alfa
	print *, "alpha_s(s) =", Alfas
	print *, "GF =", GF
	print *, "SW2 =", SW2
	print *, "----------------------------"
	print *, "Gauge-boson masses:"
	print *, "MW =", MW
	print *, "MZ =", MZ
	print *, "----------------------------"
	print *, "Fermion masses:"
	print *, "ME =", ME
	print *, "MM =", MM
	print *, "ML =", ML
	print *, "MU =", MU
	print *, "MC =", MC
	print *, "MT =", MT
	print *, "MD =", MD
	print *, "MS =", MS
	print *, "MB =", MB
	print *, "----------------------------"
	print *, "Higgs mass:"
	print *, "MH =", MH
	print *, "============================"

#endif

	end

* ndimgauss_scalar.f
* this file is part of FormCalc
* last revision: 28 Feb 00 Thomas Hahn
*
* n-dimensional Gaussian integration for a vector of functions.
*	Note: this file works only with compilers that accept
*	      recursive functions!
*
* - The integration interval in each dimension is assumed to be
*   [0, 1] (similar to VEGAS).
*
* - The function to be integrated is calculated in the
*		subroutine func(intvar, res)
*		double precision intvar(10), result
*   which receives the integration variables in the vector intvar, filled
*   with "maxdim" entries such that intvar(1) is the innermost integration
*   variable.
*
* - GaussNDim.f contains the arrays of sampling points and weights
*   calculated by GaussPointsNDim.m. The number of sampling points and
*   can be set in the makefile.
*
* - "dim" is mainly for the internal recursion. The user calls the
*   subroutine with dim = maxdim.
*
* For instance to calculate \int_0^1 dx dy dz sin(x) cos(y) exp(z) one
* might use the following sample invocation:
*
* 	double precision integrand(X)
*	double precision X(10)
*	integrand = sin(X(3)) * cos(X(2)) * exp(X(1))
*	end
*
*	program main
*	double precision integral
*	call gauss(integral, integrand, 3, 3)
*	print *, integral
*	end


	subroutine gauss(result, func, dim, maxdim)
	implicit none
	integer dim, maxdim
	double precision result, func
	external func

	integer j
	double precision dx
	double precision left, right
	double precision intvar(10)
	common /static/ intvar

	automatic j, dx, left, right

	include "GaussNDim.f"

	if(dim .eq. 0) then
	  result = func(intvar)
	else 
	  result = 0
	  do j = 1, points(dim)
	    dx = .5D0*gauss_x(dim, j)

*		may want to delete this in final version:
*	    if(dim .ge. 4) print *, "lev ", dim, " dx=", dx

	    intvar(maxdim + 1 - dim) = .5D0 + dx
	    call gauss(left, func, dim - 1, maxdim)
	    intvar(maxdim + 1 - dim) = .5D0 - dx
	    call gauss(right, func, dim - 1, maxdim)
	    result = result + gauss_w(dim, j)*(left + right)
	  enddo
	endif
	end

* Eps.F
* calculates -I times the Levi-Civita tensor contracted with
* four four-vectors
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


* Note: the arguments a, b, c, d specify the vector's position in
* the array vec, NOT the vector itself.  The macros k, e, ec, s
* (defined in util.h) convert from 1...LEGS to a, b, c, d.

	ComplexType function Eps(a, b, c, d)
	implicit none
	integer a, b, c, d

	ComplexType vec(2,2, 1)
	common /vectors/ vec

#define A(x,y) vec(x,y, a)
#define B(x,y) vec(x,y, b)
#define C(x,y) vec(x,y, c)
#define D(x,y) vec(x,y, d)

#define diag(i,j) (i(1,1)*j(2,2) - i(2,2)*j(1,1))
#define offdiag(i,j) (i(2,1)*j(1,2) - i(1,2)*j(2,1))

	Eps = .25D0*(
     &    diag(A,B)*
     &      offdiag(C,D) +
     &    diag(C,D)*
     &      offdiag(A,B) -
     &    diag(A,C)*
     &      offdiag(B,D) -
     &    diag(B,D)*
     &      offdiag(A,C) +
     &    diag(A,D)*
     &      offdiag(B,C) +
     &    diag(B,C)*
     &      offdiag(A,D) )
	end

      SUBROUTINE DCUHRE(NDIM,NUMFUN,A,B,MINPTS,MAXPTS,FUNSUB,EPSABS,
     +                  EPSREL,KEY,NW,RESTAR,RESULT,ABSERR,NEVAL,IFAIL,
     +                  WORK)
C***BEGIN PROLOGUE DCUHRE
C***DATE WRITTEN   900116   (YYMMDD)
C***REVISION DATE  900116   (YYMMDD)
C***CATEGORY NO. H2B1A1
C***AUTHOR
C            Jarle Berntsen, The Computing Centre,
C            University of Bergen, Thormohlens gt. 55,
C            N-5008 Bergen, Norway
C            Phone..  47-5-544055
C            Email..  jarle@eik.ii.uib.no
C            Terje O. Espelid, Department of Informatics,
C            University of Bergen, Thormohlens gt. 55,
C            N-5008 Bergen, Norway
C            Phone..  47-5-544180
C            Email..  terje@eik.ii.uib.no
C            Alan Genz, Computer Science Department, Washington State
C            University, Pullman, WA 99163-1210, USA
C            Phone.. 509-335-2131
C            Email..  acg@cs2.cs.wsu.edu
C***KEYWORDS automatic multidimensional integrator,
C            n-dimensional hyper-rectangles,
C            general purpose, global adaptive
C***PURPOSE  The routine calculates an approximation to a given
C            vector of definite integrals
C
C      B(1) B(2)     B(NDIM)
C     I    I    ... I       (F ,F ,...,F      ) DX(NDIM)...DX(2)DX(1),
C      A(1) A(2)     A(NDIM)  1  2      NUMFUN
C
C       where F = F (X ,X ,...,X    ), I = 1,2,...,NUMFUN.
C              I   I  1  2      NDIM
C
C            hopefully satisfying for each component of I the following
C            claim for accuracy:
C            ABS(I(K)-RESULT(K)).LE.MAX(EPSABS,EPSREL*ABS(I(K)))
C***DESCRIPTION Computation of integrals over hyper-rectangular
C            regions.
C            DCUHRE is a driver for the integration routine
C            DADHRE, which repeatedly subdivides the region
C            of integration and estimates the integrals and the
C            errors over the subregions with greatest
C            estimated errors until the error request
C            is met or MAXPTS function evaluations have been used.
C
C            For NDIM = 2 the default integration rule is of
C            degree 13 and uses 65 evaluation points.
C            For NDIM = 3 the default integration rule is of
C            degree 11 and uses 127 evaluation points.
C            For NDIM greater then 3 the default integration rule
C            is of degree 9 and uses NUM evaluation points where
C              NUM = 1 + 4*2*NDIM + 2*NDIM*(NDIM-1) + 4*NDIM*(NDIM-1) +
C                    4*NDIM*(NDIM-1)*(NDIM-2)/3 + 2**NDIM
C            The degree 9 rule may also be applied for NDIM = 2
C            and NDIM = 3.
C            A rule of degree 7 is available in all dimensions.
C            The number of evaluation
C            points used by the degree 7 rule is
C              NUM = 1 + 3*2*NDIM + 2*NDIM*(NDIM-1) + 2**NDIM
C
C            When DCUHRE computes estimates to a vector of
C            integrals, all components of the vector are given
C            the same treatment. That is, I(F ) and I(F ) for
C                                            J         K
C            J not equal to K, are estimated with the same
C            subdivision of the region of integration.
C            For integrals with enough similarity, we may save
C            time by applying DCUHRE to all integrands in one call.
C            For integrals that vary continuously as functions of
C            some parameter, the estimates produced by DCUHRE will
C            also vary continuously when the same subdivision is
C            applied to all components. This will generally not be
C            the case when the different components are given
C            separate treatment.
C
C            On the other hand this feature should be used with
C            caution when the different components of the integrals
C            require clearly different subdivisions.
C
C   ON ENTRY
C
C     NDIM   Integer.
C            Number of variables. 1 < NDIM <=  15.
C     NUMFUN Integer.
C            Number of components of the integral.
C     A      Real array of dimension NDIM.
C            Lower limits of integration.
C     B      Real array of dimension NDIM.
C            Upper limits of integration.
C     MINPTS Integer.
C            Minimum number of function evaluations.
C     MAXPTS Integer.
C            Maximum number of function evaluations.
C            The number of function evaluations over each subregion
C            is NUM.
C            If (KEY = 0 or KEY = 1) and (NDIM = 2) Then
C              NUM = 65
C            Elseif (KEY = 0 or KEY = 2) and (NDIM = 3) Then
C              NUM = 127
C            Elseif (KEY = 0 and NDIM > 3) or (KEY = 3) Then
C              NUM = 1 + 4*2*NDIM + 2*NDIM*(NDIM-1) + 4*NDIM*(NDIM-1) +
C                    4*NDIM*(NDIM-1)*(NDIM-2)/3 + 2**NDIM
C            Elseif (KEY = 4) Then
C              NUM = 1 + 3*2*NDIM + 2*NDIM*(NDIM-1) + 2**NDIM
C            MAXPTS >= 3*NUM and MAXPTS >= MINPTS
C            For 3 < NDIM < 13 the minimum values for MAXPTS are:
C             NDIM =    4   5   6    7    8    9    10   11    12
C            KEY = 3:  459 819 1359 2151 3315 5067 7815 12351 20235
C            KEY = 4:  195 309  483  765 1251 2133 3795  7005 13299
C     FUNSUB Externally declared subroutine for computing
C            all components of the integrand at the given
C            evaluation point.
C            It must have parameters (NDIM,X,NUMFUN,FUNVLS)
C            Input parameters:
C              NDIM   Integer that defines the dimension of the
C                     integral.
C              X      Real array of dimension NDIM
C                     that defines the evaluation point.
C              NUMFUN Integer that defines the number of
C                     components of I.
C            Output parameter:
C              FUNVLS Real array of dimension NUMFUN
C                     that defines NUMFUN components of the integrand.
C
C     EPSABS Real.
C            Requested absolute error.
C     EPSREL Real.
C            Requested relative error.
C     KEY    Integer.
C            Key to selected local integration rule.
C            KEY = 0 is the default value.
C                  For NDIM = 2 the degree 13 rule is selected.
C                  For NDIM = 3 the degree 11 rule is selected.
C                  For NDIM > 3 the degree  9 rule is selected.
C            KEY = 1 gives the user the 2 dimensional degree 13
C                  integration rule that uses 65 evaluation points.
C            KEY = 2 gives the user the 3 dimensional degree 11
C                  integration rule that uses 127 evaluation points.
C            KEY = 3 gives the user the degree 9 integration rule.
C            KEY = 4 gives the user the degree 7 integration rule.
C                  This is the recommended rule for problems that
C                  require great adaptivity.
C     NW     Integer.
C            Defines the length of the working array WORK.
C            Let MAXSUB denote the maximum allowed number of subregions
C            for the given values of MAXPTS, KEY and NDIM.
C            MAXSUB = (MAXPTS-NUM)/(2*NUM) + 1
C            NW should be greater or equal to
C            MAXSUB*(2*NDIM+2*NUMFUN+2) + 17*NUMFUN + 1
C            For efficient execution on parallel computers
C            NW should be chosen greater or equal to
C            MAXSUB*(2*NDIM+2*NUMFUN+2) + 17*NUMFUN*MDIV + 1
C            where MDIV is the number of subregions that are divided in
C            each subdivision step.
C            MDIV is default set internally in DCUHRE equal to 1.
C            For efficient execution on parallel computers
C            with NPROC processors MDIV should be set equal to
C            the smallest integer such that MOD(2*MDIV,NPROC) = 0.
C
C     RESTAR Integer.
C            If RESTAR = 0, this is the first attempt to compute
C            the integral.
C            If RESTAR = 1, then we restart a previous attempt.
C            In this case the only parameters for DCUHRE that may
C            be changed (with respect to the previous call of DCUHRE)
C            are MINPTS, MAXPTS, EPSABS, EPSREL and RESTAR.
C
C   ON RETURN
C
C     RESULT Real array of dimension NUMFUN.
C            Approximations to all components of the integral.
C     ABSERR Real array of dimension NUMFUN.
C            Estimates of absolute errors.
C     NEVAL  Integer.
C            Number of function evaluations used by DCUHRE.
C     IFAIL  Integer.
C            IFAIL = 0 for normal exit, when ABSERR(K) <=  EPSABS or
C              ABSERR(K) <=  ABS(RESULT(K))*EPSREL with MAXPTS or less
C              function evaluations for all values of K,
C              1 <= K <= NUMFUN .
C            IFAIL = 1 if MAXPTS was too small for DCUHRE
C              to obtain the required accuracy. In this case DCUHRE
C              returns values of RESULT with estimated absolute
C              errors ABSERR.
C            IFAIL = 2 if KEY is less than 0 or KEY greater than 4.
C            IFAIL = 3 if NDIM is less than 2 or NDIM greater than 15.
C            IFAIL = 4 if KEY = 1 and NDIM not equal to 2.
C            IFAIL = 5 if KEY = 2 and NDIM not equal to 3.
C            IFAIL = 6 if NUMFUN is less than 1.
C            IFAIL = 7 if volume of region of integration is zero.
C            IFAIL = 8 if MAXPTS is less than 3*NUM.
C            IFAIL = 9 if MAXPTS is less than MINPTS.
C            IFAIL = 10 if EPSABS < 0 and EPSREL < 0.
C            IFAIL = 11 if NW is too small.
C            IFAIL = 12 if unlegal RESTAR.
C     WORK   Real array of dimension NW.
C            Used as working storage.
C            WORK(NW) = NSUB, the number of subregions in the data
C            structure.
C            Let WRKSUB=(NW-1-17*NUMFUN*MDIV)/(2*NDIM+2*NUMFUN+2)
C            WORK(1),...,WORK(NUMFUN*WRKSUB) contain
C              the estimated components of the integrals over the
C              subregions.
C            WORK(NUMFUN*WRKSUB+1),...,WORK(2*NUMFUN*WRKSUB) contain
C              the estimated errors over the subregions.
C            WORK(2*NUMFUN*WRKSUB+1),...,WORK(2*NUMFUN*WRKSUB+NDIM*
C              WRKSUB) contain the centers of the subregions.
C            WORK(2*NUMFUN*WRKSUB+NDIM*WRKSUB+1),...,WORK((2*NUMFUN+
C              NDIM)*WRKSUB+NDIM*WRKSUB) contain subregion half widths.
C            WORK(2*NUMFUN*WRKSUB+2*NDIM*WRKSUB+1),...,WORK(2*NUMFUN*
C              WRKSUB+2*NDIM*WRKSUB+WRKSUB) contain the greatest errors
C              in each subregion.
C            WORK((2*NUMFUN+2*NDIM+1)*WRKSUB+1),...,WORK((2*NUMFUN+
C              2*NDIM+1)*WRKSUB+WRKSUB) contain the direction of
C              subdivision in each subregion.
C            WORK(2*(NDIM+NUMFUN+1)*WRKSUB),...,WORK(2*(NDIM+NUMFUN+1)*
C              WRKSUB+ 17*MDIV*NUMFUN) is used as temporary
C              storage in DADHRE.
C
C
C        DCUHRE Example Test Program
C
C
C   DTEST1 is a simple test driver for DCUHRE.
C
C   Output produced on a SUN 3/50.
c
C       DCUHRE TEST RESULTS
C
C    FTEST CALLS = 3549, IFAIL =  0
C   N   ESTIMATED ERROR   INTEGRAL
C   1     0.00000010     0.13850818
C   2     0.00000013     0.06369469
C   3     0.00000874     0.05861748
C   4     0.00000021     0.05407034
C   5     0.00000019     0.05005614
C   6     0.00000009     0.04654608
C
C     PROGRAM DTEST1
C     EXTERNAL FTEST
C     INTEGER KEY, N, NF, NDIM, MINCLS, MAXCLS, IFAIL, NEVAL, NW
C     PARAMETER (NDIM = 5, NW = 5000, NF = NDIM+1)
C     DOUBLE PRECISION A(NDIM), B(NDIM), WRKSTR(NW)
C     DOUBLE PRECISION ABSEST(NF), FINEST(NF), ABSREQ, RELREQ
C     DO 10 N = 1,NDIM
C        A(N) = 0
C        B(N) = 1
C  10 CONTINUE
C     MINCLS = 0
C     MAXCLS = 10000
C     KEY = 0
C     ABSREQ = 0
C     RELREQ = 1E-3
C     CALL DCUHRE(NDIM, NF, A, B, MINCLS, MAXCLS, FTEST, ABSREQ, RELREQ,
C    * KEY, NW, 0, FINEST, ABSEST, NEVAL, IFAIL, WRKSTR)
C     PRINT 9999, NEVAL, IFAIL
C9999 FORMAT (8X, 'DCUHRE TEST RESULTS', //'     FTEST CALLS = ', I4,
C    * ', IFAIL = ', I2, /'    N   ESTIMATED ERROR   INTEGRAL')
C     DO 20 N = 1,NF
C        PRINT 9998, N, ABSEST(N), FINEST(N)
C9998    FORMAT (3X, I2, 2F15.8)
C  20 CONTINUE
C     END
C     SUBROUTINE FTEST(NDIM, Z, NFUN, F)
C     INTEGER N, NDIM, NFUN
C     DOUBLE PRECISION Z(NDIM), F(NFUN), SUM
C     SUM = 0
C     DO 10 N = 1,NDIM
C        SUM = SUM + N*Z(N)**2
C  10 CONTINUE
C     F(1) = EXP(-SUM/2)
C     DO 20 N = 1,NDIM
C        F(N+1) = Z(N)*F(1)
C  20 CONTINUE
C     END
C
C***LONG DESCRIPTION
C
C   The information for each subregion is contained in the
C   data structure WORK.
C   When passed on to DADHRE, WORK is split into eight
C   arrays VALUES, ERRORS, CENTRS, HWIDTS, GREATE, DIR,
C   OLDRES and WORK.
C   VALUES contains the estimated values of the integrals.
C   ERRORS contains the estimated errors.
C   CENTRS contains the centers of the subregions.
C   HWIDTS contains the half widths of the subregions.
C   GREATE contains the greatest estimated error for each subregion.
C   DIR    contains the directions for further subdivision.
C   OLDRES and WORK are used as work arrays in DADHRE.
C
C   The data structures for the subregions are in DADHRE organized
C   as a heap, and the size of GREATE(I) defines the position of
C   region I in the heap. The heap is maintained by the program
C   DTRHRE.
C
C   The subroutine DADHRE is written for efficient execution on shared
C   memory parallel computer. On a computer with NPROC processors we wil
C   in each subdivision step divide MDIV regions, where MDIV is
C   chosen such that MOD(2*MDIV,NPROC) = 0, in totally 2*MDIV new region
C   Each processor will then compute estimates of the integrals and erro
C   over 2*MDIV/NPROC subregions in each subdivision step.
C   The subroutine for estimating the integral and the error over
C   each subregion, DRLHRE, uses WORK2 as a work array.
C   We must make sure that each processor writes its results to
C   separate parts of the memory, and therefore the sizes of WORK and
C   WORK2 are functions of MDIV.
C   In order to achieve parallel processing of subregions, compiler
C   directives should be placed in front of the DO 200
C   loop in DADHRE on machines like Alliant and CRAY.
C
C***REFERENCES
C   J.Berntsen, T.O.Espelid and A.Genz, An Adaptive Algorithm
C   for the Approximate Calculation of Multiple Integrals,
C   To be published.
C
C   J.Berntsen, T.O.Espelid and A.Genz, DCUHRE: An Adaptive
C   Multidimensional Integration Routine for a Vector of
C   Integrals, To be published.
C
C***ROUTINES CALLED DCHHRE,DADHRE
C***END PROLOGUE DCUHRE
C
C   Global variables.
C
      EXTERNAL FUNSUB
      INTEGER NDIM,NUMFUN,MINPTS,MAXPTS,KEY,NW,RESTAR
      INTEGER NEVAL,IFAIL
      DOUBLE PRECISION A(NDIM),B(NDIM),EPSABS,EPSREL
      DOUBLE PRECISION RESULT(NUMFUN),ABSERR(NUMFUN),WORK(NW)
C
C   Local variables.
C
C   MDIV   Integer.
C          MDIV is the number of subregions that are divided in
C          each subdivision step in DADHRE.
C          MDIV is chosen default to 1.
C          For efficient execution on parallel computers
C          with NPROC processors MDIV should be set equal to
C          the smallest integer such that MOD(2*MDIV,NPROC) = 0.
C   MAXDIM Integer.
C          The maximum allowed value of NDIM.
C   MAXWT  Integer. The maximum number of weights used by the
C          integration rule.
C   WTLENG Integer.
C          The number of generators used by the selected rule.
C   WORK2  Real work space. The length
C          depends on the parameters MDIV,MAXDIM and MAXWT.
C   MAXSUB Integer.
C          The maximum allowed number of subdivisions
C          for the given values of KEY, NDIM and MAXPTS.
C   MINSUB Integer.
C          The minimum allowed number of subregions for the given
C          values of MINPTS, KEY and NDIM.
C   WRKSUB Integer.
C          The maximum allowed number of subregions as a function
C          of NW, NUMFUN, NDIM and MDIV. This determines the length
C          of the main work arrays.
C   NUM    Integer. The number of integrand evaluations needed
C          over each subregion.
C
      INTEGER MDIV,MAXWT,WTLENG,MAXDIM,LENW2,MAXSUB,MINSUB
      INTEGER NUM,NSUB,LENW,KEYF
      PARAMETER (MDIV=1)
      PARAMETER (MAXDIM=15)
      PARAMETER (MAXWT=14)
      PARAMETER (LENW2=2*MDIV*MAXDIM* (MAXWT+1)+12*MAXWT+2*MAXDIM)
      INTEGER WRKSUB,I1,I2,I3,I4,I5,I6,I7,I8,K1,K2,K3,K4,K5,K6,K7,K8
      DOUBLE PRECISION WORK2(LENW2)
C
C***FIRST EXECUTABLE STATEMENT DCUHRE
C
C   Compute NUM, WTLENG, MAXSUB and MINSUB,
C   and check the input parameters.
C
      CALL DCHHRE(MAXDIM,NDIM,NUMFUN,MDIV,A,B,MINPTS,MAXPTS,EPSABS,
     +            EPSREL,KEY,NW,RESTAR,NUM,MAXSUB,MINSUB,KEYF,
     +            IFAIL,WTLENG)
      WRKSUB = (NW - 1 - 17*MDIV*NUMFUN)/(2*NDIM + 2*NUMFUN + 2)
      IF (IFAIL.NE.0) THEN
          GO TO 999
      END IF
C
C   Split up the work space.
C
      I1 = 1
      I2 = I1 + WRKSUB*NUMFUN
      I3 = I2 + WRKSUB*NUMFUN
      I4 = I3 + WRKSUB*NDIM
      I5 = I4 + WRKSUB*NDIM
      I6 = I5 + WRKSUB
      I7 = I6 + WRKSUB
      I8 = I7 + NUMFUN*MDIV
      K1 = 1
      K2 = K1 + 2*MDIV*WTLENG*NDIM
      K3 = K2 + WTLENG*5
      K4 = K3 + WTLENG
      K5 = K4 + NDIM
      K6 = K5 + NDIM
      K7 = K6 + 2*MDIV*NDIM
      K8 = K7 + 3*WTLENG
C
C   On restart runs the number of subregions from the
C   previous call is assigned to NSUB.
C
      IF (RESTAR.EQ.1) THEN
          NSUB = WORK(NW)
      END IF
C
C   Compute the size of the temporary work space needed in DADHRE.
C
      LENW = 16*MDIV*NUMFUN
      CALL DADHRE(NDIM,NUMFUN,MDIV,A,B,MINSUB,MAXSUB,FUNSUB,EPSABS,
     +            EPSREL,KEYF,RESTAR,NUM,LENW,WTLENG,
     +            RESULT,ABSERR,NEVAL,NSUB,IFAIL,WORK(I1),WORK(I2),
     +            WORK(I3),WORK(I4),WORK(I5),WORK(I6),WORK(I7),WORK(I8),
     +            WORK2(K1),WORK2(K2),WORK2(K3),WORK2(K4),WORK2(K5),
     +            WORK2(K6),WORK2(K7),WORK2(K8))
      WORK(NW) = NSUB
999   RETURN
C
C***END DCUHRE
C
      END

* SABcut.F
* the FormCalc wrapper for the Samurai two-point function
* this file is part of FormCalc
* last modified 31 Mar 11 th


	double complex function SABcut(rank, num, numeps, p, m1, m2)
	implicit none
	integer rank
	double complex num, numeps
	external num, numeps
	integer*8 p
	double precision m1, m2

#include "SA.h"

	double precision pj(2,4), mj(2)
	double complex tot(-2:0), totr
	logical ok

	pj(1,1) = 0
	pj(1,2) = 0
	pj(1,3) = 0
	pj(1,4) = 0
	call SAMomDecode(p, pj(2,1), 2)

	mj(1) = m1
	mj(2) = m2

	PRINT *, "SABcut:", rank
	PRINT *, "p1=", pj(2,4)
	PRINT *, "   ", pj(2,1)
	PRINT *, "   ", pj(2,2)
	PRINT *, "   ", pj(2,3)
	PRINT *, "m1=", m1
	PRINT *, "m2=", m2

	call samurai(num, tot, totr, pj, mj, 2, rank, 1, mudim, ok)
	SABcut = tot(epscoeff)
	PRINT *, "SABcut=", SABcut
	end

* rc_zero.F
* sets all renormalization constants to zero for debugging purposes
* this file is part of FormCalc
* last modified 23 Feb 00 th


	subroutine calc_renconst
	implicit none

#include "renconst.h"

	integer g1

	dMZsq1 = 0
	dMWsq1 = 0
	dMHsq1 = 0
	dSWsq1 = 0
	dCWsq1 = 0
	dSW1 = 0
	dZAA1 = 0
	dZAZ1 = 0
	dZZA1 = 0
	dZZZ1 = 0
	dZW1 = 0
	dZH1 = 0
	dZphi1 = 0
	dZchi1 = 0
	dWFZ1 = 0
	dWFW1 = 0
	dZe1 = 0
	dTad1 = 0

	do g1 = 1, 3
	  dMf1(2,g1) = 0
	  dZfL1(2,g1,g1) = 0
	  dZfR1(2,g1,g1) = 0
	  dMf1(3,g1) = 0
	  dZfL1(3,g1,g1) = 0
	  dZfR1(3,g1,g1) = 0
	  dMf1(4,g1) = 0
	  dZfL1(4,g1,g1) = 0
	  dZfR1(4,g1,g1) = 0
	enddo

	end

* lumi_parton.F
* "luminosity" for a partonic process
* this file is part of FormCalc
* last modified 30 Nov 11 th


#define MINVAR SQRTS


************************************************************************

	subroutine LumiDefaults(argc, argv)
	implicit none
	integer argc
	character*128 argv(*)

	end


************************************************************************

	subroutine LumiIni(fail)
	implicit none
	integer fail

#include "xsection.h"

	integer i

	do i = 1, 10
	  call SetEnergy(fail, Var(SQRTS))
#ifdef FORCE_ONSHELL
	  if( abs(mass_in - Var(SQRTS)) .lt. 1D-9 ) then
	    if( fail .ne. 0 ) INFO "Below threshold"
	    return
	  endif
	  Var(SQRTS) = mass_in
	  Upper(SQRTS) = mass_in
#else
	  if( fail .ne. 1 ) return
	  Var(SQRTS) = threshold + .01D0
	  INFO "Adjusting sqrtS to above-threshold value ", Var(SQRTS)
#endif
	enddo

	Warning("Calculation of threshold did not converge")
	end


************************************************************************

	subroutine Luminosity(fac)
	implicit none
	RealType fac

	integer fail

#include "xsection.h"

	call SetEnergy(fail, Var(SQRTS))

	if( fail .ne. 0 ) fac = 0
	end

* SAFcut.F
* the FormCalc wrapper for the Samurai six-point function
* this file is part of FormCalc
* last modified 31 Mar 11 th


	double complex function SAFcut(rank, num,
     &    p1, p2, p3, p4, p5, m1, m2, m3, m4, m5, m6)
	implicit none
	integer rank
	double complex num, numeps
	external num, numeps
	integer*8 p1, p2, p3, p4, p5
	double precision m1, m2, m3, m4, m5, m6

#include "SA.h"

	double precision pj(6,4), mj(6)
	double complex tot(-2:0), totr
	logical ok

	pj(1,1) = 0
	pj(1,2) = 0
	pj(1,3) = 0
	pj(1,4) = 0
	call SAMomDecode(p1, pj(2,1), 6)
	call SAMomDecode(p2, pj(3,1), 6)
	call SAMomDecode(p3, pj(4,1), 6)
	call SAMomDecode(p4, pj(5,1), 6)
	call SAMomDecode(p5, pj(6,1), 6)

	mj(1) = m1
	mj(2) = m2
	mj(3) = m3
	mj(4) = m4
	mj(5) = m5
	mj(6) = m6

	call samurai(num, tot, totr, pj, mj, 6, rank, 1, mudim, ok)
	SAFcut = tot(epscoeff)
	end

* ndimgauss_vector.f
* this file is part of FormCalc
* last revision: 28 Feb 00 Thomas Hahn
*
* n-dimensional Gaussian integration for a vector of functions.
*	Note: this file works only with compilers that accept
*	      recursive functions!
*
* - The integration interval in each dimension is assumed to be
*   [0, 1] (similar to VEGAS).
*
* - The function to be integrated is calculated in the
*		subroutine func(result, intvar, from, to)
*		integer from, to
*		double precision result, intvar(10)
*		dimension res(to)
*   which receives the integration variables in the vector intvar, filled
*   with "maxdim" entries such that intvar(1) is the innermost integration
*   variable. func is expected to fill the elements "from" to "to" of the
*   vector "res".
*
* - gauss returns its results in the vector "result". Only the elements
*   "from" to "to" are filled.
*
* - gaussNDim.f contains the arrays of sampling points and weights
*   calculated by GaussPointsNDim.m. The number of sampling points and
*   can be set in the makefile.
*
* - "dim" is mainly for the internal recursion. The user calls the
*   subroutine with dim = maxdim.
*
* Integrating scalar functions can be treated as a special case of
* an n-dimensional integration with n = 1, for instance to calculate
* \int_0^1 dx dy dz sin(x) sin(y) sin(z) one might use the following
* sample invocation:
*
* 	subroutine integrand(result, X)
*	double precision result, X(10)
*	result = sin(X(3)) * sin(X(2)) * sin(X(1))
*	end
*
*	program main
*	double precision integral
*	call gauss(integral, integrand, 3, 3, 1, 1)
*	print *, integral
*	end
*
* Most Fortran compilers allow the arguments "from" and "to" to be omitted
* in the definition of the integrand function, i.e. the subroutine
* "integrand" defined above should really have four arguments:
* res, X, from, to.


	subroutine gauss(result, func, dim, maxdim, from, to)
	implicit none
	integer dim, maxdim, from, to
	double precision result
	dimension result(to)
	external func

	integer j, k
	double precision dx
	double precision left, right
	dimension left(to), right(to)
	double precision intvar(10)
	common /static/ intvar

	automatic j, dx, left, right

	include "GaussNDim.f"

	if(dim .eq. 0) then
	  call func(result, intvar, from, to)
	else 
	  do k = from, to
	    result(k) = 0
	  enddo
	  do j = 1, points(dim)
	    dx = .5D0*gauss_x(dim, j)

*		may want to delete this in final version:
*	    if(dim .ge. 4) print *, "lev ", dim, ": dx=", dx

	    intvar(maxdim + 1 - dim) = .5D0 + dx
	    call gauss(left, func, dim - 1, maxdim, from, to)
	    intvar(maxdim + 1 - dim) = .5D0 - dx
	    call gauss(right, func, dim - 1, maxdim, from, to)
	    do k = from, to
	      result(k) = result(k) +
     +          gauss_w(dim, j)*(left(k) + right(k))
	    enddo
	  enddo
	endif
	end

* SAAcut.F
* the FormCalc wrapper for the Samurai one-point function
* this file is part of FormCalc
* last modified 31 Mar 11 th


	double complex function SAAcut(rank, num, numeps, m)
	implicit none
	integer rank
	double complex num, numeps
	external num, numeps
	double precision m

#include "SA.h"

	double precision pj(4,1)
	double complex tot(-2:0)
	integer ncut

	pj(1,1) = 0
	pj(2,1) = 0
	pj(3,1) = 0
	pj(4,1) = 0

	PRINT *, "SAAcut:", rank
	PRINT *, "m1=", m

	tot(-2) = 0
	tot(-1) = m
	tot(0) = m - log(m/mudim)
	SAAcut = tot(epscoeff)*num(ncut, pj, 0D0)

	PRINT *, "SAAcut=", SAAcut
	end

* SEigensystem.F
* diagonalization of a complex symmetric n-by-n matrix using
* the Jacobi algorithm
* code adapted from the "Handbook" routines for complex A
* (Wilkinson, Reinsch: Handbook for Automatic Computation, p. 202)
* this file is part of the Diag library
* last modified 22 Dec 06 th

#include "config.h"


************************************************************************
** SEigensystem diagonalizes a complex symmetric n-by-n matrix.
** Input: n, A = n-by-n matrix, complex symmetric
** (only the upper triangle of A needs to be filled).
** Output: d = vector of eigenvalues, U = transformation matrix
** these fulfill diag(d) = U A U^T = U A U^-1 with U U^T = 1.

	subroutine SEigensystem(n, A,ldA, d, U,ldU, sort)
	implicit none
	integer n, ldA, ldU, sort
	double complex A(ldA,*), U(ldU,*), d(*)

	integer sweep, p, q, j
	double precision test, threshold, absA, absB, absX
	double complex delta, t, invc, s
	double complex x, y
	double complex ev(2,MAXDIM)

	if( n .gt. MAXDIM ) then
	  print *, "Dimension too large"
	  d(1) = -999
	  return
	endif

	do p = 1, n
	  ev(1,p) = 0
	  ev(2,p) = Element(A,p,p)
	  d(p) = ev(2,p)
	enddo

	do p = 1, n
	  do q = 1, n
	    Element(U,q,p) = 0
	  enddo
	  Element(U,p,p) = 1
	enddo

	do sweep = 1, 50
	  test = 0
	  do q = 2, n
	    do p = 1, q - 1
	      test = test + abs(Element(A,p,q))
	    enddo
	  enddo
	  if( test .lt. EPS ) goto 1

	  threshold = 0
	  if( sweep .lt. 4 ) threshold = test/(5*n**2)

	  do q = 2, n
	    do p = 1, q - 1
	      absA = abs(ev(2,p))
	      absB = abs(ev(2,q))
	      absX = abs(Element(A,p,q))
	      test = 100*absX
	      if( sweep .gt. 4 .and.
     &            absA + test .eq. absA .and.
     &            absB + test .eq. absB ) then
	        Element(A,p,q) = 0
	      else
	        if( absX .gt. threshold ) then
	          x = .5D0*(ev(2,p) - ev(2,q))
	          y = sqrt(x**2 + Element(A,p,q)**2)
	          t = x - y
	          x = x + y
	          if( abs(t) .lt. abs(x) ) t = x

	          t = Element(A,p,q)/t
	          delta = t*Element(A,p,q)
	          ev(1,p) = ev(1,p) + delta
	          ev(2,p) = d(p) + ev(1,p)
	          ev(1,q) = ev(1,q) - delta
	          ev(2,q) = d(q) + ev(1,q)

	          invc = sqrt(t**2 + 1)
	          s = t/invc
	          t = t/(invc + 1)

	          do j = 1, p - 1
	            x = Element(A,j,p)
	            y = Element(A,j,q)
	            Element(A,j,p) = x + s*(y - t*x)
	            Element(A,j,q) = y - s*(x + t*y)
	          enddo

	          do j = p + 1, q - 1
	            x = Element(A,p,j)
	            y = Element(A,j,q)
	            Element(A,p,j) = x + s*(y - t*x)
	            Element(A,j,q) = y - s*(x + t*y)
	          enddo

	          do j = q + 1, n
	            x = Element(A,p,j)
	            y = Element(A,q,j)
	            Element(A,p,j) = x + s*(y - t*x)
	            Element(A,q,j) = y - s*(x + t*y)
	          enddo

	          do j = 1, n
	            x = Element(U,p,j)
	            y = Element(U,q,j)
	            Element(U,p,j) = x + s*(y - t*x)
	            Element(U,q,j) = y - s*(x + t*y)
	          enddo

	          Element(A,p,q) = 0
	        endif
	      endif
	    enddo
	  enddo

	  do p = 1, n
	    ev(1,p) = 0
	    d(p) = ev(2,p)
	  enddo
	enddo

	print *, "Bad convergence in SEigensystem"

1	if( sort .eq. 0 ) return

* sort the eigenvalues by their real part

	do p = 1, n - 1
	  j = p
	  x = d(p)
	  do q = p + 1, n
	    if( sort*(DBLE(x) - DBLE(d(q))) .gt. 0 ) then
	      j = q
	      x = d(q)
	    endif
	  enddo

	  if( j .ne. p ) then
	    d(j) = d(p)
	    d(p) = x
	    do q = 1, n
	      x = Element(U,p,q)
	      Element(U,p,q) = Element(U,j,q)
	      Element(U,j,q) = x
	    enddo
	  endif
	enddo
	end

* VecSet.F
* construct the CMS representation of a momentum and the
* three corresponding polarization vectors
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


* i: the index of the momentum
* m, p: mass and three-momentum of the particle
* ex,ey,ez: the unit three-vector of the momentum

	subroutine VecSet(i, m, p, ex,ey,ez)
	implicit none
	integer i
	RealType m, p, ex,ey,ez

	ComplexType vec(2,2, 8, 0:1)
	common /vectors/ vec

#define K(x,y)     vec(x,y, 1, i)
#define EpsTR(x,y) vec(x,y, 2, i)
#define EpsL(x,y)  vec(x,y, 3, i)
#define EpsTL(x,y) vec(x,y, 4, i)

	ComplexType spi(2, 16, 0:1)
	equivalence (spi, vec)

#define Spinor(hel,om,x) spi(x, hel*2+om+5, i)
#define DottedSpinor(hel,om,x) spi(x, hel*2+om+7, i)

* i.e., spi(x,  9, i) = left-handed,  undotted, upper
*       spi(x, 10, i) = left-handed,  undotted, lower
*       spi(x, 11, i) = left-handed,  dotted,   upper
*       spi(x, 12, i) = left-handed,  dotted,   lower
*       spi(x, 13, i) = right-handed, undotted, upper
*       spi(x, 14, i) = right-handed, undotted, lower
*       spi(x, 15, i) = right-handed, dotted,   upper
*       spi(x, 16, i) = right-handed, dotted,   lower

	RealType momspec(16,1)
	common /momenta/ momspec

* the following must match the definitions in util.h:
#define SPEC_M 1
#define SPEC_K 2
#define SPEC_E 3
#define SPEC_KT 4
#define SPEC_ET 5
#define SPEC_PRAP 6
#define SPEC_RAP 7
#define SPEC_DELTAK 8
#define SPEC_PHI 9
#define SPEC_EX 10
#define SPEC_EY 11
#define SPEC_EZ 12

	RealType m2, p2, p0, deltap, sump
	RealType sinth, onePez, oneMez
	ComplexType expIphi

	RealType sqrt2
	parameter (sqrt2 = 1.4142135623730950488016887242096981D0)

	momspec(SPEC_M,i) = m
	momspec(SPEC_K,i) = p

	m2 = m**2
	if( m2 .lt. 1D-14 ) then
	  p0 = p
	  deltap = 0
	else
	  p2 = p**2
	  p0 = sqrt(p2 + m2)
	  deltap = m2/(p0 + p)
	endif

	momspec(SPEC_E,i) = p0
	momspec(SPEC_DELTAK,i) = deltap
	momspec(SPEC_EX,i) = ex
	momspec(SPEC_EY,i) = ey
	momspec(SPEC_EZ,i) = ez

	sinth = ex**2 + ey**2
	onePez = 1 + ez
	if( onePez .lt. .5D0 ) onePez = sinth/(1 - ez)
	oneMez = 1 - ez
	if( oneMez .lt. .5D0 ) oneMez = sinth/(1 + ez)

	if( sinth .lt. 1D-14 ) then
* phi is irrelevant when theta = 0
	  expIphi = 1
	  momspec(SPEC_PHI,i) = 0
	else
	  sinth = sqrt(sinth)
	  expIphi = ToComplex(ex, ey)/sinth
	  momspec(SPEC_PHI,i) = atan2(ey, ex)
	endif

	K(1,1) = p0*onePez - deltap*ez
	K(2,2) = p0*oneMez + deltap*ez
	K(2,1) = p*ToComplex(ex, ey)
	K(1,2) = Conjugate(K(2,1))

	if( m .ne. 0 ) then
	  EpsL(1,1) = (p*onePez + deltap*ez)/m
	  EpsL(2,2) = (p*oneMez - deltap*ez)/m
	  EpsL(2,1) = p0/m*ToComplex(ex, ey)
	  EpsL(1,2) = Conjugate(EpsL(2,1))
	endif

	EpsTR(2,2) = 1/sqrt2*sinth
	EpsTL(2,2) = EpsTR(2,2)
	EpsTR(1,1) = -EpsTR(2,2)
	EpsTL(1,1) = EpsTR(1,1)
	EpsTR(2,1) = -1/sqrt2*oneMez*expIphi
	EpsTL(1,2) = Conjugate(EpsTR(2,1))
	EpsTL(2,1) = 1/sqrt2*onePez*expIphi
	EpsTR(1,2) = Conjugate(EpsTL(2,1))

#define safelog(x) log(max(x, 1D-300))

	momspec(SPEC_KT,i) = p*sinth
	momspec(SPEC_ET,i) = sqrt(momspec(SPEC_KT,i)**2 + m2)
	momspec(SPEC_PRAP,i) = safelog(onePez) -
     &    safelog(sinth)
	momspec(SPEC_RAP,i) = safelog(Re(K(1,1))) -
     &    safelog(momspec(SPEC_ET,i))

* this is E^(I phi) cos(th/2) = 1/sqrt2*sqrt(1 + ez)*expIphi:
	expIphi = 1/sqrt2*sqrt(onePez)*expIphi
* this is sin(th/2):
	sinth = 1/sqrt2*sqrt(oneMez)
	sump = sqrt(p0 + p)
	deltap = sqrt(deltap)

	Spinor(-1, 6, 1) = deltap*sinth
	DottedSpinor(-1, 6, 1) = Spinor(-1, 6, 1)
	Spinor(-1, 6, 2) = -deltap*expIphi
	DottedSpinor(-1, 6, 2) = Conjugate(Spinor(-1, 6, 2))

	Spinor(-1, 7, 1) = sump*sinth
	DottedSpinor(-1, 7, 1) = Spinor(-1, 7, 1)
	Spinor(-1, 7, 2) = -sump*expIphi
	DottedSpinor(-1, 7, 2) = Conjugate(Spinor(-1, 7, 2))

	DottedSpinor(1, 6, 1) = sump*expIphi
	Spinor(1, 6, 1) = Conjugate(DottedSpinor(1, 6, 1))
	DottedSpinor(1, 6, 2) = sump*sinth
	Spinor(1, 6, 2) = DottedSpinor(1, 6, 2)

	DottedSpinor(1, 7, 1) = deltap*expIphi
	Spinor(1, 7, 1) = Conjugate(DottedSpinor(1, 7, 1))
	DottedSpinor(1, 7, 2) = deltap*sinth
	Spinor(1, 7, 2) = DottedSpinor(1, 7, 2)
	end

      SUBROUTINE DRLHRE(NDIM,CENTER,HWIDTH,WTLENG,G,W,ERRCOF,NUMFUN,
     +                  FUNSUB,SCALES,NORMS,X,NULL,BASVAL,RGNERR,DIRECT)
C***BEGIN PROLOGUE DRLHRE
C***KEYWORDS basic numerical integration rule
C***PURPOSE  To compute basic integration rule values.
C***AUTHOR   Alan Genz, Computer Science Department, Washington
C            State University, Pullman, WA 99163-1210 USA
C***LAST MODIFICATION 90-02-06
C***DESCRIPTION DRLHRE computes basic integration rule values for a
C            vector of integrands over a hyper-rectangular region.
C            These are estimates for the integrals. DRLHRE also computes
C            estimates for the errors and determines the coordinate axis
C            where the fourth difference for the integrands is largest.
C
C   ON ENTRY
C
C   NDIM   Integer.
C          Number of variables.
C   CENTER Real array of dimension NDIM.
C          The coordinates for the center of the region.
C   HWIDTH Real Array of dimension NDIM.
C          HWIDTH(I) is half of the width of dimension I of the region.
C   WTLENG Integer.
C          The number of weights in the basic integration rule.
C   G      Real array of dimension (NDIM,WTLENG).
C          The fully symmetric sum generators for the rules.
C          G(1,J), ..., G(NDIM,J) are the are the generators for the
C          points associated with the Jth weights.
C   W      Real array of dimension (5,WTLENG).
C          The weights for the basic and null rules.
C          W(1,1),...,W(1,WTLENG) are weights for the basic rule.
C          W(I,1),...,W(I,WTLENG), for I > 1 are null rule weights.
C   ERRCOF Real array of dimension 6.
C          The error coefficients for the rules.
C          It is assumed that the error is computed using:
C           IF (N1*ERRCOF(1) < N2 and N2*ERRCOF(2) < N3)
C             THEN ERROR = ERRCOF(3)*N1
C             ELSE ERROR = ERRCOF(4)*MAX(N1, N2, N3)
C           ERROR = ERROR + EP*(ERRCOF(5)*ERROR/(ES+ERROR)+ERRCOF(6))
C          where N1-N4 are the null rules, EP is the error
C          for the parent
C          subregion and ES is the error for the sibling subregion.
C   NUMFUN Integer.
C          Number of components for the vector integrand.
C   FUNSUB Externally declared subroutine.
C          For computing the components of the integrand at a point X.
C          It must have parameters (NDIM,X,NUMFUN,FUNVLS).
C           Input Parameters:
C            X      Real array of dimension NDIM.
C                   Defines the evaluation point.
C            NDIM   Integer.
C                   Number of variables for the integrand.
C            NUMFUN Integer.
C                   Number of components for the vector integrand.
C           Output Parameters:
C            FUNVLS Real array of dimension NUMFUN.
C                   The components of the integrand at the point X.
C   SCALES Real array of dimension (3,WTLENG).
C          Scaling factors used to construct new null rules based
C          on a linear combination of two successive null rules
C          in the sequence of null rules.
C   NORMS  Real array of dimension (3,WTLENG).
C          2**NDIM/(1-norm of the null rule constructed by each of the
C          scaling factors.)
C   X      Real Array of dimension NDIM.
C          A work array.
C   NULL   Real array of dimension (NUMFUN, 8)
C          A work array.
C
C   ON RETURN
C
C   BASVAL Real array of dimension NUMFUN.
C          The values for the basic rule for each component
C          of the integrand.
C   RGNERR Real array of dimension NUMFUN.
C          The error estimates for each component of the integrand.
C   DIRECT Real.
C          The coordinate axis where the fourth difference of the
C          integrand values is largest.
C
C***REFERENCES
C   A.C.Genz and A.A.Malik, An adaptive algorithm for numerical
C   integration over an N-dimensional rectangular region,
C   J.Comp.Appl.Math., 6:295-302, 1980.
C
C   T.O.Espelid, Integration Rules, Null Rules and Error
C   Estimation, Reports in Informatics 33, Dept. of Informatics,
C   Univ. of Bergen, 1988.
C
C***ROUTINES CALLED: DFSHRE, FUNSUB
C
C***END PROLOGUE DRLHRE
C
C   Global variables.
C
      EXTERNAL FUNSUB
      INTEGER WTLENG,NUMFUN,NDIM
      DOUBLE PRECISION CENTER(NDIM),X(NDIM),HWIDTH(NDIM),BASVAL(NUMFUN),
     +                 RGNERR(NUMFUN),NULL(NUMFUN,8),W(5,WTLENG),
     +                 G(NDIM,WTLENG),ERRCOF(6),DIRECT,SCALES(3,WTLENG),
     +                 NORMS(3,WTLENG)
C
C   Local variables.
C
      DOUBLE PRECISION RGNVOL,DIFSUM,DIFMAX,FRTHDF
      INTEGER I,J,K,DIVAXN
      DOUBLE PRECISION SEARCH,RATIO
C
C***FIRST EXECUTABLE STATEMENT DRLHRE
C
C
C       Compute volume of subregion, initialize DIVAXN and rule sums;
C       compute fourth differences and new DIVAXN (RGNERR is used
C       for a work array here). The integrand values used for the
C       fourth divided differences are accumulated in rule arrays.
C
      RGNVOL = 1
      DIVAXN = 1
      DO 10 I = 1,NDIM
          RGNVOL = RGNVOL*HWIDTH(I)
          X(I) = CENTER(I)
          IF (HWIDTH(I).GT.HWIDTH(DIVAXN)) DIVAXN = I
10    CONTINUE
      CALL FUNSUB(NDIM,X,NUMFUN,RGNERR)
      DO 30 J = 1,NUMFUN
          BASVAL(J) = W(1,1)*RGNERR(J)
          DO 20 K = 1,4
              NULL(J,K) = W(K+1,1)*RGNERR(J)
20        CONTINUE
30    CONTINUE
      DIFMAX = 0
      RATIO = (G(1,3)/G(1,2))**2
      DO 60 I = 1,NDIM
          X(I) = CENTER(I) - HWIDTH(I)*G(1,2)
          CALL FUNSUB(NDIM,X,NUMFUN,NULL(1,5))
          X(I) = CENTER(I) + HWIDTH(I)*G(1,2)
          CALL FUNSUB(NDIM,X,NUMFUN,NULL(1,6))
          X(I) = CENTER(I) - HWIDTH(I)*G(1,3)
          CALL FUNSUB(NDIM,X,NUMFUN,NULL(1,7))
          X(I) = CENTER(I) + HWIDTH(I)*G(1,3)
          CALL FUNSUB(NDIM,X,NUMFUN,NULL(1,8))
          X(I) = CENTER(I)
          DIFSUM = 0
          DO 50 J = 1,NUMFUN
              FRTHDF = 2* (1-RATIO)*RGNERR(J) - (NULL(J,7)+NULL(J,8)) +
     +                 RATIO* (NULL(J,5)+NULL(J,6))
C
C           Ignore differences below roundoff
C
              IF (RGNERR(J)+FRTHDF/4.NE.RGNERR(J)) DIFSUM = DIFSUM +
     +            ABS(FRTHDF)
              DO 40 K = 1,4
                  NULL(J,K) = NULL(J,K) + W(K+1,2)*
     +                        (NULL(J,5)+NULL(J,6)) +
     +                        W(K+1,3)* (NULL(J,7)+NULL(J,8))
40            CONTINUE
              BASVAL(J) = BASVAL(J) + W(1,2)* (NULL(J,5)+NULL(J,6)) +
     +                    W(1,3)* (NULL(J,7)+NULL(J,8))
50        CONTINUE
          IF (DIFSUM.GT.DIFMAX) THEN
              DIFMAX = DIFSUM
              DIVAXN = I
          END IF
60    CONTINUE
      DIRECT = DIVAXN
C
C    Finish computing the rule values.
C
      DO 90 I = 4,WTLENG
          CALL DFSHRE(NDIM,CENTER,HWIDTH,X,G(1,I),NUMFUN,FUNSUB,RGNERR,
     +                NULL(1,5))
          DO 80 J = 1,NUMFUN
              BASVAL(J) = BASVAL(J) + W(1,I)*RGNERR(J)
              DO 70 K = 1,4
                  NULL(J,K) = NULL(J,K) + W(K+1,I)*RGNERR(J)
70            CONTINUE
80        CONTINUE
90    CONTINUE
C
C    Compute errors.
C
      DO 130 J = 1,NUMFUN
C
C    We search for the null rule, in the linear space spanned by two
C    successive null rules in our sequence, which gives the greatest
C    error estimate among all normalized (1-norm) null rules in this
C    space.
C
          DO 110 I = 1,3
              SEARCH = 0
              DO 100 K = 1,WTLENG
                  SEARCH = MAX(SEARCH,ABS(NULL(J,I+1)+SCALES(I,
     +                     K)*NULL(J,I))*NORMS(I,K))
100           CONTINUE
              NULL(J,I) = SEARCH
110       CONTINUE
          IF (ERRCOF(1)*NULL(J,1).LE.NULL(J,2) .AND.
     +        ERRCOF(2)*NULL(J,2).LE.NULL(J,3)) THEN
              RGNERR(J) = ERRCOF(3)*NULL(J,1)
          ELSE
              RGNERR(J) = ERRCOF(4)*MAX(NULL(J,1),NULL(J,2),NULL(J,3))
          END IF
          RGNERR(J) = RGNVOL*RGNERR(J)
          BASVAL(J) = RGNVOL*BASVAL(J)
130   CONTINUE
C
C***END DRLHRE
C
      END

* 2to3.F
* this file supplies num.F with the main program and other
* functions that depend on the kinematics for a 2 -> 3 process
* this file is part of FormCalc
* last modified 18 Oct 01 th


* some definitions for num.F
#define LEGS 5
#define TYPES TYPE1, TYPE2, TYPE3, TYPE4, TYPE5
#define COMMON "2to3.h"

* this defines the order of integrations:
#define K50 4
#define COSTH 3
#define K30 2
#define ETA 1

#define NDIM 4
#define NCOMP 2


	program main
	implicit none

#include COMMON

	double precision Ecmsfrom, Ecmsto, Ecms, k50, tree, loop

	call ParseCommandline(Ecmsfrom, Ecmsto)

	call ffini
#ifdef MUDIM
	call setmudim(MUDIM)
#endif
#ifdef DELTA
	call setdelta(DELTA)
#endif
#ifdef LAMBDA
	call setlambda(LAMBDA)
#endif

	upper(COSTH) = cos(THETACUT)
	lower(COSTH) = -upper(COSTH)

	upper(ETA) = 2*pi
	lower(ETA) = 0

27	format(3G24.15)
28	format()

	LOOP1
	LOOP2
	LOOP3
	LOOP4
	LOOP5
	LOOP6
	LOOP7
	LOOP8
	LOOP9
	LOOP10
	LOOP11
	LOOP12
	LOOP13
	LOOP14
	LOOP15

	Ecms = Ecmsfrom
	call SetEnergy(Ecms, .TRUE., *1)

	if(Ecmsto .ge. Ecmsfrom) then
18	  continue
	  print *, "sqrt(s) =", Ecms
	  call IntegratedCS(tree, loop, 4)
	  write(11, 27) Ecms, tree, loop
	  call flush(11)
	  if(Ecms .lt. Ecmsto) then
	    Ecms = Ecms + ECMSSTEP
	    call SetEnergy(Ecms, .FALSE., *1)
	    goto 18
	  endif
	else
	  do k50 = lower(K50), upper(K50), K50STEP
	    print *, "sqrt(s) =", Ecms, "  k50 =", k50
	    var(K50) = k50
	    call SetLimits
	    call IntegratedCS(tree, loop, 3)
	    write(11, 27) k50, tree, loop
	    call flush(11)
	  enddo
	endif

	write(11, 28)
1	continue

	close(11)
	call ffexi
	end


************************************************************************
** SetEnergy sets the CMS energy and initializes everything that depends
** on it.

	subroutine SetEnergy(Ecms, fullini, *)
	implicit none
	double precision Ecms
	logical fullini

#include COMMON

	double precision threshold, m, Pin
	logical adjust, ini

25	format("# WARNING: adjusted sqrt(s) to above-threshold value ",
     +    F10.2)
26	format("# ", A, F8.2)

	reset = fullini
	ini = fullini
	adjust = .FALSE.
1	continue
	call model_ini(Ecms, ini, *999)
	m = (MASS3 + MASS4)**2 - MASS5**2
	lower(K50) = max(dble(MASS5) + .01D0, dble(K50CUT))
	threshold = max(
     +    dble(MASS1 + MASS2),
     +    dble(MASS3 + MASS4 + MASS5),
     +    lower(K50) + sqrt(lower(K50)**2 + m) )
	if(Ecms .lt. threshold) then
	  Ecms = threshold + .01D0
	  ini = .FALSE.
	  adjust = .TRUE.
	  goto 1
	endif

	if(adjust) then
	  write(11, 25) Ecms
	  print 25, Ecms
	endif

	if(fullini) then
#define PRINT write(11, 26)
	  PRINT1
	  PRINT2
	  PRINT3
	  PRINT4
	  PRINT5
#undef PRINT

#define PRINT print 26,
	  PRINT1
	  PRINT2
	  PRINT3
	  PRINT4
	  PRINT5
#undef PRINT
	endif

	mass(1) = MASS1**2
	mass(2) = MASS2**2
	mass(3) = MASS3**2
	mass(4) = MASS4**2
	mass(5) = MASS5**2
	call calc_renconst

	upper(K50) = .5D0*(Ecms - m/Ecms)

	Pin = sqrt((.5D0*(Ecms - (mass(1) - mass(2))/Ecms))**2
     +    - mass(2))

	sqrtS = Ecms
	flux = hbar_c2/(8*(2*pi)**4*4)/(Pin*Ecms)*avgfac

	call VecSet(1, 1, dble(MASS1), Pin, 0D0, 0D0, 1D0)
	call VecSet(5, 1, dble(MASS2), Pin, 0D0, 0D0, -1D0)
	return

999	continue
	return 1
	end


************************************************************************
** SetLimits is called after a new value for var(K50) has been set and
** computes the limits of the k30 integration that depend on k50.

	subroutine SetLimits
	implicit none

#include COMMON

	double precision k50, k5, sig, tau, m1, m2

	k50 = var(K50)
	k5 = sqrt(k50**2 - mass(5))
	sig = sqrtS - k50
	tau = sqrtS*(sig - k50) + mass(5)
	m1 = MASS3 + MASS4
	m2 = MASS3 - MASS4
	sig = sig*(1 + m1*m2/tau)
	tau = k5*sqrt((1 - m1**2/tau)*(1 - m2**2/tau))
	lower(K30) = .5D0*(sig - tau)
	upper(K30) = .5D0*(sig + tau)
	end


************************************************************************
** DifferentialCS actually invokes the generated function squared_me.
** If necessary, soft-photon bremsstrahlung corrections are added.
** DifferentialCS = dsigma/(dk50 dk30 dcosth deta)

	subroutine DifferentialCS(tree, loop, k50, costh, k30, eta)
	implicit none
	double precision tree, loop, k50, costh, k30, eta

#include COMMON
#include "renconst.h"

#ifdef BREMSSTRAHLUNG
	double precision SoftPhotonFactor
	external SoftPhotonFactor
#endif

	double precision sinth, cosxi, sinxi, coseta, sineta
	double precision e3x, e3y, e3z
	double precision k3, k4, k5

	k3 = sqrt(k30**2 - mass(3))
	k4 = sqrt((sqrtS - k30 - k50)**2 - mass(4))
	k5 = sqrt(k50**2 - mass(5))
	cosxi = (k4**2 - k3**2 - k5**2)/(2*k3*k5)
	sinxi = sqrt(1 - cosxi**2)
	sinth = sqrt(1 - costh**2)
	coseta = cos(eta)
	sineta = sin(eta)

	e3x = costh*coseta*sinxi + sinth*cosxi
	e3y = sineta*sinxi
	e3z = costh*cosxi - sinth*coseta*sinxi

	call VecSet(9, -1, dble(MASS3), k3, e3x, e3y, e3z)
	call VecSet(13, -1, dble(MASS4), k4,
     +    (-k3*e3x - k5*sinth)/k4, -k3*e3y/k4, (-k3*e3z - k5*costh)/k4)
	call VecSet(17, -1, dble(MASS5), k5,
     +    sinth, 0D0, costh)

	call squared_me(tree, loop, sqrtS,
     +    bpol(1), epol(1),
     +    bpol(2), epol(2),
     +    bpol(3), epol(3),
     +    bpol(4), epol(4),
     +    bpol(5), epol(5), reset)

	tree = flux*tree
	loop = flux*loop + tree

#ifdef BREMSSTRAHLUNG
	loop = loop + tree*SoftPhotonFactor()
#endif

#ifdef WF_RENORMALIZATION
	loop = loop + tree*WF_RENORMALIZATION
#endif
	end


#if defined(VEGAS) || defined(DCUHRE)

#ifdef VEGAS
#include "vegas.F"
#endif

************************************************************************
** IntegratedCS integrates DifferentialCS over the scattering angle.

	subroutine IntegratedCS(tree, loop, ndim)
	implicit none
	double precision tree, loop
	integer ndim

#include COMMON

	double precision result(2)
	integer neval
	external sample

#ifdef DCUHRE
* this is for checking the integration with the DCUHRE algorithm, see
* http://www.acm.org/pubs/citations/journals/toms/1991-17-4/p452-berntsen

	double precision zero(4), one(4)
	data zero /0, 0, 0, 0/, one /1, 1, 1, 1/

	integer nwork, fail
	parameter (nwork = 25000)
	double precision work(nwork)
	double precision error(2)

	call dcuhre(ndim, NCOMP, zero, one, 0, NCALL*MAXITER,
     +    sample, 1D-15, ACCURACY, 0, nwork, 0,
     +    result, error, neval, fail, work)
	if(fail .gt. 1) print *, "integration error ", fail
	if(fail .eq. 1) then
	  print *,
     +      "Warning: DCUHRE failed to reach the desired accuracy."
	  print *, "Remaining relative errors:"
	  print *, error(1)/result(1), " (tree)"
	  print *, error(2)/result(2), " (loop)"
	endif
#else
	call vegas(sample, result, ACCURACY, ndim,
     +    NCALL, MAXITER, neval)
#endif
	print *, neval, " evaluations used"

	tree = result(1)
	loop = result(2)
	end


************************************************************************
** sample samples the differential cross-section at x. The arrays upper
** and lower contain the integration limits.

	subroutine sample(ndim, x, ncomp, result)
	implicit none
	integer ndim, ncomp
	double precision x(ndim), result(ncomp)

#include COMMON

	integer dim
	double precision range, jacobian

	jacobian = 1
	do dim = ndim, 1, -1
	  range = upper(dim) - lower(dim)
	  jacobian = jacobian*range
	  var(dim) = lower(dim) + x(dim)*range
	  if(dim .eq. K50) call SetLimits
	enddo

	call DifferentialCS(result(1), result(2),
     +    var(K50), var(COSTH), var(K30), var(ETA))
	result(1) = result(1)*jacobian
	result(2) = result(2)*jacobian
	end

#else

#include "multigauss.F"

************************************************************************
** IntegratedCS integrates DifferentialCS over the scattering angle.

	subroutine IntegratedCS(tree, loop, ndim)
	implicit none
	double precision tree, loop
	integer ndim

#include COMMON

	double precision result(2)
	integer d

	double precision para(-1:NCOMP, 0:MAXINTV, NDIM), accuracy
	integer intv(3, NDIM), dim, neval
	common /intpara/ para, accuracy, intv, dim, neval

	neval = 0
	accuracy = ACCURACY
	dim = ndim
	do d = 1, ndim
	  para(-1, 0, d) = lower(d)
	  para(-1, 1, d) = upper(d)
	  intv(1, d) = 1
	  intv(2, d) = 1
	  intv(3, d) = 0
	enddo

	call integrate(result)

	print *, "intervals:   ", (intv(2, d), d = 1, ndim)
	print *, "fluctuation: ", (intv(3, d), d = 1, ndim)
	print *, neval, " evaluations used"

	tree = result(1)
	loop = result(2)
	end


************************************************************************
** sample takes care of the multi-dimensional sampling of the
** differential cross-section.

	subroutine sample(result, x)
	implicit none
	double precision result(*), x

#include COMMON

	double precision para(-1:NCOMP, 0:MAXINTV, NDIM), accuracy
	integer intv(3, NDIM), dim, neval
	common /intpara/ para, accuracy, intv, dim, neval

	integer nodes(NDIM)
	data nodes(K50) /NODES_K50/
	data nodes(COSTH) /NODES_COSTH/
	data nodes(K30) /NODES_K30/
	data nodes(ETA) /NODES_ETA/

	var(dim) = x
	if(dim .eq. 1) then
	  call DifferentialCS(result(1), result(2),
     +      var(K50), var(COSTH), var(K30), var(ETA))
	  neval = neval + 1
	  if(mod(neval, 10000) .eq. 0) print *, neval, " evaluations"
	  return
	endif

	if(dim .eq. K50) then
	  call SetLimits
	  para(-1, 0, K30) = lower(K30)
	  para(-1, 1, K30) = upper(K30)
	  intv(1, K30) = 1
	endif
	dim = dim - 1
	accuracy = accuracy/GAIN

	entry integrate(result)

	call multigauss(result, accuracy,
     +    para(-1, 0, dim), intv(1, dim), MAXINTV, nodes(dim))
	accuracy = accuracy*GAIN
	dim = dim + 1
	end

#endif

* BeS.F
* computes Bar[Vector].eps.Spinor
* this file is part of FormCalc
* last modified 15 Jun 04 th


	integer function BeS(a, b)
	implicit none
	integer a, b

	double complex vec(2,2, 1)
	common /vectors/ vec

	double complex spi(2, 2)
	equivalence (spi, vec)

#define A(x,y) vec(x,y, a)
#define B(x) spi(x, b)
#define accu 2

	spi(1, accu) = A(1,2)*B(1) + A(2,2)*B(2)
	spi(2, accu) = -A(1,1)*B(1) - A(2,1)*B(2)
	BeS = accu
	end

      SUBROUTINE DADHRE(NDIM,NUMFUN,MDIV,A,B,MINSUB,MAXSUB,FUNSUB,
     +                  EPSABS,EPSREL,KEY,RESTAR,NUM,LENW,WTLENG,
     +                  RESULT,ABSERR,NEVAL,NSUB,IFAIL,VALUES,
     +                  ERRORS,CENTRS,HWIDTS,GREATE,DIR,OLDRES,WORK,G,W,
     +                  RULPTS,CENTER,HWIDTH,X,SCALES,NORMS)
C***BEGIN PROLOGUE DADHRE
C***KEYWORDS automatic multidimensional integrator,
C            n-dimensional hyper-rectangles,
C            general purpose, global adaptive
C***PURPOSE  The routine calculates an approximation to a given
C            vector of definite integrals, I, over a hyper-rectangular
C            region hopefully satisfying for each component of I the
C            following claim for accuracy:
C            ABS(I(K)-RESULT(K)).LE.MAX(EPSABS,EPSREL*ABS(I(K)))
C***DESCRIPTION Computation of integrals over hyper-rectangular
C            regions.
C            DADHRE repeatedly subdivides the region
C            of integration and estimates the integrals and the
C            errors over the subregions with  greatest
C            estimated errors until the error request
C            is met or MAXSUB subregions are stored.
C            The regions are divided in two equally sized parts along
C            the direction with greatest absolute fourth divided
C            difference.
C
C   ON ENTRY
C
C     NDIM   Integer.
C            Number of variables. 1 < NDIM <= MAXDIM.
C     NUMFUN Integer.
C            Number of components of the integral.
C     MDIV   Integer.
C            Defines the number of new subregions that are divided
C            in each subdivision step.
C     A      Real array of dimension NDIM.
C            Lower limits of integration.
C     B      Real array of dimension NDIM.
C            Upper limits of integration.
C     MINSUB Integer.
C            The computations proceed until there are at least
C            MINSUB subregions in the data structure.
C     MAXSUB Integer.
C            The computations proceed until there are at most
C            MAXSUB subregions in the data structure.
C
C     FUNSUB Externally declared subroutine for computing
C            all components of the integrand in the given
C            evaluation point.
C            It must have parameters (NDIM,X,NUMFUN,FUNVLS)
C            Input parameters:
C              NDIM   Integer that defines the dimension of the
C                     integral.
C              X      Real array of dimension NDIM
C                     that defines the evaluation point.
C              NUMFUN Integer that defines the number of
C                     components of I.
C            Output parameter:
C              FUNVLS Real array of dimension NUMFUN
C                     that defines NUMFUN components of the integrand.
C
C     EPSABS Real.
C            Requested absolute error.
C     EPSREL Real.
C            Requested relative error.
C     KEY    Integer.
C            Key to selected local integration rule.
C            KEY = 0 is the default value.
C                  For NDIM = 2 the degree 13 rule is selected.
C                  For NDIM = 3 the degree 11 rule is selected.
C                  For NDIM > 3 the degree  9 rule is selected.
C            KEY = 1 gives the user the 2 dimensional degree 13
C                  integration rule that uses 65 evaluation points.
C            KEY = 2 gives the user the 3 dimensional degree 11
C                  integration rule that uses 127 evaluation points.
C            KEY = 3 gives the user the degree 9 integration rule.
C            KEY = 4 gives the user the degree 7 integration rule.
C                  This is the recommended rule for problems that
C                  require great adaptivity.
C     RESTAR Integer.
C            If RESTAR = 0, this is the first attempt to compute
C            the integral.
C            If RESTAR = 1, then we restart a previous attempt.
C            (In this case the output parameters from DADHRE
C            must not be changed since the last
C            exit from DADHRE.)
C     NUM    Integer.
C            The number of function evaluations over each subregion.
C     LENW   Integer.
C            Defines the length of the working array WORK.
C            LENW should be greater or equal to
C            16*MDIV*NUMFUN.
C     WTLENG Integer.
C            The number of weights in the basic integration rule.
C     NSUB   Integer.
C            If RESTAR = 1, then NSUB must specify the number
C            of subregions stored in the previous call to DADHRE.
C
C   ON RETURN
C
C     RESULT Real array of dimension NUMFUN.
C            Approximations to all components of the integral.
C     ABSERR Real array of dimension NUMFUN.
C            Estimates of absolute accuracies.
C     NEVAL  Integer.
C            Number of function evaluations used by DADHRE.
C     NSUB   Integer.
C            Number of stored subregions.
C     IFAIL  Integer.
C            IFAIL = 0 for normal exit, when ABSERR(K) <=  EPSABS or
C              ABSERR(K) <=  ABS(RESULT(K))*EPSREL with MAXSUB or less
C              subregions processed for all values of K,
C              1 <=  K <=  NUMFUN.
C            IFAIL = 1 if MAXSUB was too small for DADHRE
C              to obtain the required accuracy. In this case DADHRE
C              returns values of RESULT with estimated absolute
C              accuracies ABSERR.
C     VALUES Real array of dimension (NUMFUN,MAXSUB).
C            Used to store estimated values of the integrals
C            over the subregions.
C     ERRORS Real array of dimension (NUMFUN,MAXSUB).
C            Used to store the corresponding estimated errors.
C     CENTRS Real array of dimension (NDIM,MAXSUB).
C            Used to store the centers of the stored subregions.
C     HWIDTS Real array of dimension (NDIM,MAXSUB).
C            Used to store the half widths of the stored subregions.
C     GREATE Real array of dimension MAXSUB.
C            Used to store the greatest estimated errors in
C            all subregions.
C     DIR    Real array of dimension MAXSUB.
C            DIR is used to store the directions for
C            further subdivision.
C     OLDRES Real array of dimension (NUMFUN,MDIV).
C            Used to store old estimates of the integrals over the
C            subregions.
C     WORK   Real array of dimension LENW.
C            Used  in DRLHRE and DTRHRE.
C     G      Real array of dimension (NDIM,WTLENG,2*MDIV).
C            The fully symmetric sum generators for the rules.
C            G(1,J,1),...,G(NDIM,J,1) are the generators for the
C            points associated with the Jth weights.
C            When MDIV subregions are divided in 2*MDIV
C            subregions, the subregions may be processed on different
C            processors and we must make a copy of the generators
C            for each processor.
C     W      Real array of dimension (5,WTLENG).
C            The weights for the basic and null rules.
C            W(1,1), ..., W(1,WTLENG) are weights for the basic rule.
C            W(I,1), ..., W(I,WTLENG) , for I > 1 are null rule weights.
C     RULPTS Real array of dimension WTLENG.
C            Work array used in DINHRE.
C     CENTER Real array of dimension NDIM.
C            Work array used in DTRHRE.
C     HWIDTH Real array of dimension NDIM.
C            Work array used in DTRHRE.
C     X      Real array of dimension (NDIM,2*MDIV).
C            Work array used in DRLHRE.
C     SCALES Real array of dimension (3,WTLENG).
C            Work array used by DINHRE and DRLHRE.
C     NORMS  Real array of dimension (3,WTLENG).
C            Work array used by DINHRE and DRLHRE.
C
C***REFERENCES
C
C   P. van Dooren and L. de Ridder, Algorithm 6, An adaptive algorithm
C   for numerical integration over an n-dimensional cube, J.Comput.Appl.
C   Math. 2(1976)207-217.
C
C   A.C.Genz and A.A.Malik, Algorithm 019. Remarks on algorithm 006:
C   An adaptive algorithm for numerical integration over an
C   N-dimensional rectangular region,J.Comput.Appl.Math. 6(1980)295-302.
C
C***ROUTINES CALLED DTRHRE,DINHRE,DRLHRE
C***END PROLOGUE DADHRE
C
C   Global variables.
C
      EXTERNAL FUNSUB
      INTEGER NDIM,NUMFUN,MDIV,MINSUB,MAXSUB,KEY,LENW,RESTAR
      INTEGER NUM,NEVAL,NSUB,IFAIL,WTLENG
      DOUBLE PRECISION A(NDIM),B(NDIM),EPSABS,EPSREL
      DOUBLE PRECISION RESULT(NUMFUN),ABSERR(NUMFUN)
      DOUBLE PRECISION VALUES(NUMFUN,MAXSUB),ERRORS(NUMFUN,MAXSUB)
      DOUBLE PRECISION CENTRS(NDIM,MAXSUB)
      DOUBLE PRECISION HWIDTS(NDIM,MAXSUB)
      DOUBLE PRECISION GREATE(MAXSUB),DIR(MAXSUB)
      DOUBLE PRECISION OLDRES(NUMFUN,MDIV)
      DOUBLE PRECISION WORK(LENW),RULPTS(WTLENG)
      DOUBLE PRECISION G(NDIM,WTLENG,2*MDIV),W(5,WTLENG)
      DOUBLE PRECISION CENTER(NDIM),HWIDTH(NDIM),X(NDIM,2*MDIV)
      DOUBLE PRECISION SCALES(3,WTLENG),NORMS(3,WTLENG)
C
C   Local variables.
C
C   INTSGN is used to get correct sign on the integral.
C   SBRGNS is the number of stored subregions.
C   NDIV   The number of subregions to be divided in each main step.
C   POINTR Pointer to the position in the data structure where
C          the new subregions are to be stored.
C   DIRECT Direction of subdivision.
C   ERRCOF Heuristic error coeff. defined in DINHRE and used by DRLHRE
C          and DADHRE.
C
      INTEGER I,J,K
      INTEGER INTSGN,SBRGNS
      INTEGER L1
      INTEGER NDIV,POINTR,DIRECT,INDEX
      DOUBLE PRECISION OLDCEN,EST1,EST2,ERRCOF(6)
C
C***FIRST EXECUTABLE STATEMENT DADHRE
C
C   Get the correct sign on the integral.
C
      INTSGN = 1
      DO 10 J = 1,NDIM
          IF (B(J).LT.A(J)) THEN
              INTSGN = - INTSGN
          END IF
10    CONTINUE
C
C   Call DINHRE to compute the weights and abscissas of
C   the function evaluation points.
C
      CALL DINHRE(NDIM,KEY,WTLENG,W,G,ERRCOF,RULPTS,SCALES,NORMS)
C
C   If RESTAR = 1, then this is a restart run.
C
      IF (RESTAR.EQ.1) THEN
          SBRGNS = NSUB
          GO TO 110
      END IF
C
C   Initialize the SBRGNS, CENTRS and HWIDTS.
C
      SBRGNS = 1
      DO 15 J = 1,NDIM
          CENTRS(J,1) = (A(J)+B(J))/2
          HWIDTS(J,1) = ABS(B(J)-A(J))/2
15    CONTINUE
C
C   Initialize RESULT, ABSERR and NEVAL.
C
      DO 20 J = 1,NUMFUN
          RESULT(J) = 0
          ABSERR(J) = 0
20    CONTINUE
      NEVAL = 0
C
C   Apply DRLHRE over the whole region.
C
      CALL DRLHRE(NDIM,CENTRS(1,1),HWIDTS(1,1),WTLENG,G,W,ERRCOF,NUMFUN,
     +            FUNSUB,SCALES,NORMS,X,WORK,VALUES(1,1),ERRORS(1,1),
     +            DIR(1))
      NEVAL = NEVAL + NUM
C
C   Add the computed values to RESULT and ABSERR.
C
      DO 55 J = 1,NUMFUN
          RESULT(J) = RESULT(J) + VALUES(J,1)
55    CONTINUE
      DO 65 J = 1,NUMFUN
          ABSERR(J) = ABSERR(J) + ERRORS(J,1)
65    CONTINUE
C
C   Store results in heap.
C
      INDEX = 1
      CALL DTRHRE(2,NDIM,NUMFUN,INDEX,VALUES,ERRORS,CENTRS,HWIDTS,
     +            GREATE,WORK(1),WORK(NUMFUN+1),CENTER,HWIDTH,DIR)
C
C***End initialisation.
C
C***Begin loop while the error is too great,
C   and SBRGNS+1 is less than MAXSUB.
C
110   IF (SBRGNS+1.LE.MAXSUB) THEN
C
C   If we are allowed to divide further,
C   prepare to apply basic rule over each half of the
C   NDIV subregions with greatest errors.
C   If MAXSUB is great enough, NDIV = MDIV
C
          IF (MDIV.GT.1) THEN
              NDIV = MAXSUB - SBRGNS
              NDIV = MIN(NDIV,MDIV,SBRGNS)
          ELSE
              NDIV = 1
          END IF
C
C   Divide the NDIV subregions in two halves, and compute
C   integral and error over each half.
C
          DO 150 I = 1,NDIV
              POINTR = SBRGNS + NDIV + 1 - I
C
C   Adjust RESULT and ABSERR.
C
              DO 115 J = 1,NUMFUN
                  RESULT(J) = RESULT(J) - VALUES(J,1)
                  ABSERR(J) = ABSERR(J) - ERRORS(J,1)
115           CONTINUE
C
C   Compute first half region.
C
              DO 120 J = 1,NDIM
                  CENTRS(J,POINTR) = CENTRS(J,1)
                  HWIDTS(J,POINTR) = HWIDTS(J,1)
120           CONTINUE
              DIRECT = DIR(1)
              DIR(POINTR) = DIRECT
              HWIDTS(DIRECT,POINTR) = HWIDTS(DIRECT,1)/2
              OLDCEN = CENTRS(DIRECT,1)
              CENTRS(DIRECT,POINTR) = OLDCEN - HWIDTS(DIRECT,POINTR)
C
C   Save the computed values of the integrals.
C
              DO 125 J = 1,NUMFUN
                  OLDRES(J,NDIV-I+1) = VALUES(J,1)
125           CONTINUE
C
C   Adjust the heap.
C
              CALL DTRHRE(1,NDIM,NUMFUN,SBRGNS,VALUES,ERRORS,CENTRS,
     +                    HWIDTS,GREATE,WORK(1),WORK(NUMFUN+1),CENTER,
     +                    HWIDTH,DIR)
C
C   Compute second half region.
C
              DO 130 J = 1,NDIM
                  CENTRS(J,POINTR-1) = CENTRS(J,POINTR)
                  HWIDTS(J,POINTR-1) = HWIDTS(J,POINTR)
130           CONTINUE
              CENTRS(DIRECT,POINTR-1) = OLDCEN + HWIDTS(DIRECT,POINTR)
              HWIDTS(DIRECT,POINTR-1) = HWIDTS(DIRECT,POINTR)
              DIR(POINTR-1) = DIRECT
150       CONTINUE
C
C   Make copies of the generators for each processor.
C
          DO 190 I = 2,2*NDIV
              DO 190 J = 1,NDIM
                  DO 190 K = 1,WTLENG
                      G(J,K,I) = G(J,K,1)
190       CONTINUE
C
C   Apply basic rule.
C
Cvd$l cncall
          DO 200 I = 1,2*NDIV
              INDEX = SBRGNS + I
              L1 = 1 + (I-1)*8*NUMFUN
              CALL DRLHRE(NDIM,CENTRS(1,INDEX),HWIDTS(1,INDEX),WTLENG,
     +                    G(1,1,I),W,ERRCOF,NUMFUN,FUNSUB,SCALES,NORMS,
     +                    X(1,I),WORK(L1),VALUES(1,INDEX),
     +                    ERRORS(1,INDEX),DIR(INDEX))
200       CONTINUE
          NEVAL = NEVAL + 2*NDIV*NUM
C
C   Add new contributions to RESULT.
C
          DO 220 I = 1,2*NDIV
              DO 210 J = 1,NUMFUN
                  RESULT(J) = RESULT(J) + VALUES(J,SBRGNS+I)
210           CONTINUE
220       CONTINUE
C
C   Check consistency of results and if necessary adjust
C   the estimated errors.
C
          DO 240 I = 1,NDIV
              GREATE(SBRGNS+2*I-1) = 0
              GREATE(SBRGNS+2*I) = 0
              DO 230 J = 1,NUMFUN
                  EST1 = ABS(OLDRES(J,I)- (VALUES(J,
     +                   SBRGNS+2*I-1)+VALUES(J,SBRGNS+2*I)))
                  EST2 = ERRORS(J,SBRGNS+2*I-1) + ERRORS(J,SBRGNS+2*I)
                  IF (EST2.GT.0) THEN
                      ERRORS(J,SBRGNS+2*I-1) = ERRORS(J,SBRGNS+2*I-1)*
     +                  (1+ERRCOF(5)*EST1/EST2)
                      ERRORS(J,SBRGNS+2*I) = ERRORS(J,SBRGNS+2*I)*
     +                                       (1+ERRCOF(5)*EST1/EST2)
                  END IF
                  ERRORS(J,SBRGNS+2*I-1) = ERRORS(J,SBRGNS+2*I-1) +
     +                                     ERRCOF(6)*EST1
                  ERRORS(J,SBRGNS+2*I) = ERRORS(J,SBRGNS+2*I) +
     +                                   ERRCOF(6)*EST1
                  IF (ERRORS(J,SBRGNS+2*I-1).GT.
     +                GREATE(SBRGNS+2*I-1)) THEN
                      GREATE(SBRGNS+2*I-1) = ERRORS(J,SBRGNS+2*I-1)
                  END IF
                  IF (ERRORS(J,SBRGNS+2*I).GT.GREATE(SBRGNS+2*I)) THEN
                      GREATE(SBRGNS+2*I) = ERRORS(J,SBRGNS+2*I)
                  END IF
                  ABSERR(J) = ABSERR(J) + ERRORS(J,SBRGNS+2*I-1) +
     +                        ERRORS(J,SBRGNS+2*I)
230           CONTINUE
240       CONTINUE
C
C   Store results in heap.
C
          DO 250 I = 1,2*NDIV
              INDEX = SBRGNS + I
              CALL DTRHRE(2,NDIM,NUMFUN,INDEX,VALUES,ERRORS,CENTRS,
     +                    HWIDTS,GREATE,WORK(1),WORK(NUMFUN+1),CENTER,
     +                    HWIDTH,DIR)
250       CONTINUE
          SBRGNS = SBRGNS + 2*NDIV
C
C   Check for termination.
C
          IF (SBRGNS.LT.MINSUB) THEN
              GO TO 110
          END IF
          DO 255 J = 1,NUMFUN
              IF (ABSERR(J).GT.EPSREL*ABS(RESULT(J)) .AND.
     +            ABSERR(J).GT.EPSABS) THEN
                  GO TO 110
              END IF
255       CONTINUE
          IFAIL = 0
          GO TO 499
C
C   Else we did not succeed with the
C   given value of MAXSUB.
C
      ELSE
          IFAIL = 1
      END IF
C
C   Compute more accurate values of RESULT and ABSERR.
C
499   CONTINUE
      DO 500 J = 1,NUMFUN
          RESULT(J) = 0
          ABSERR(J) = 0
500   CONTINUE
      DO 510 I = 1,SBRGNS
          DO 505 J = 1,NUMFUN
              RESULT(J) = RESULT(J) + VALUES(J,I)
              ABSERR(J) = ABSERR(J) + ERRORS(J,I)
505       CONTINUE
510   CONTINUE
C
C   Compute correct sign on the integral.
C
      DO 600 J = 1,NUMFUN
          RESULT(J) = RESULT(J)*INTSGN
600   CONTINUE
      NSUB = SBRGNS
      RETURN
C
C***END DADHRE
C
      END

* ThreeMom.F
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


* ThreeMom computes the length of \vec p_b in the frame in which
* \vec p_a + \vec p_b vanishes.  With sqrtS = sqrt((p_a + p_b)^2),
*
* ThreeMom(sqrtS, ma, mb) = sqrt(lambda(sqrtS, ma**2, mb**2))/(2*sqrtS),
*
* where lambda is the Kallen function.


	RealType function ThreeMom(sqrtS, ma, mb)
	implicit none
	RealType sqrtS, ma, mb

	RealType kb0

c	kb0 = ((sqrtS - ma)*(sqrtS + ma) + m2)/(2*sqrtS)
	kb0 = .5D0*(sqrtS - (ma - mb)*(ma + mb)/sqrtS)
	ThreeMom = sqrt((kb0 - mb)*(kb0 + mb))
	end

	program test
	implicit none
	double precision res
	double precision integrand
	external integrand

	call gauss(res, integrand, 3, 3, 1, 1)
	print *, "integral = ", res
	end

************************************************************************

	subroutine integrand(res, X)
	implicit none
	double precision res, X(10)

	res = sin(X(1))*cos(X(2))*exp(X(3))
	end

************************************************************************

	include "ndimgauss_vector.f"

* MomDecode.F
* form a linear combination of momenta
* and return it as a Minkowski four-vector
* the momenta's (integer*1) prefactors are encoded as the
* bytes of an integer*8
* this file is part of FormCalc
* last modified 20 Oct 05 th


	subroutine MomDecode(code, p)
	implicit none
	integer*8 code
	double precision p(0:3)

	integer i
	double precision a(4)

	integer*8 c
	integer*1 f
	equivalence (f, c)

	double complex vec(2,2, 1)
	common /vectors/ vec

	a(1) = 0
	a(2) = 0
	a(3) = 0
	a(4) = 0

	c = code
	i = 1

	do while( c .ne. 0 )
	  i = i + 8
	  a(1) = a(1) + f*DBLE(vec(1,1,i))
	  a(2) = a(2) + f*DBLE(vec(2,1,i))
	  a(3) = a(3) + f*DIMAG(vec(2,1,i))
	  a(4) = a(4) + f*DBLE(vec(2,2,i))
	  c = ishft(c, -8)
	enddo

	p(0) = .5D0*(a(1) + a(4))
	p(3) = .5D0*(a(1) - a(4))
	p(1) = a(2)
	p(2) = a(3)
	end

* num.F
* this is the driver program for a 2 -> 2 process
* for code produced by NumPrep.m
* this file is part of FormCalc
* last modified 14 May 00 th


#include "process.h"
#include "squared_me.F"

#define SCALAR 0
#define FERMION 1
#define PHOTON 2
#define VECTOR 3


* The momenta and polarization vectors are defined as
* (this is the order NumPrep expects them in):

* vec(1)     = k1     = (E1, 0, 0, -Pin)
* vec(2)     = e1(0)  = (-Pin, 0, 0, E1)/MASS1
* vec(3,4)   = e1(+-) = (0, -1, +-i, 0)/sqrt(2)

#define k1(i) vec(i, 1)
#define e1(pol, i) vec(i, 2 + pol)

* vec(5)     = k2     = (E2, 0, 0, Pin)
* vec(6)     = e2(0)  = (-Pin, 0, 0, -E2)/MASS2
* vec(7,8)   = e2(+-) = (0, 1, +-i, 0)/sqrt(2)

#define k2(i) vec(i, 5)
#define e2(pol, i) vec(i, 6 + pol)

* vec(9)     = k3     = (E3, -Pout sin(th), 0, -Pout cos(th))
* vec(10)    = e3(0)  = (-Pout, E3 sin(th), 0, E3 cos(th))/MASS3
* vec(11,12) = e3(+-) = (0, -cos(th), -+i, sin(th))/sqrt(2)

#define k3(i) vec(i, 9)
#define e3(pol, i) vec(i, 10 + pol)

* vec(13)    = k4     = (E4, Pout sin(th), 0, Pout cos(th))
* vec(14)    = e4(0)  = (-Pout, -E4 sin(th), 0, -E4 cos(th))/MASS4
* vec(15,16) = e4(+-) = (0, cos(th), -+i, -sin(th))/sqrt(2)

#define k4(i) vec(i, 13)
#define e4(pol, i) vec(i, 14 + pol)


************************************************************************
** THE MAIN PROGRAM STARTS HERE:

	program num
	implicit none

#include "kin.h"

	double precision Ecms, Ecmsfrom, Ecmsto, theta
	double precision treeres, loopres

	call ParseCommandline(Ecmsfrom, Ecmsto)

	call ffini

27	format(3G24.15)
28	format()

	LOOP1
	LOOP2
	LOOP3
	LOOP4
	LOOP5
	LOOP6
	LOOP7
	LOOP8
	LOOP9
	LOOP10

	reset = .TRUE.

	if(Ecmsto .ge. Ecmsfrom) then
	  Ecms = Ecmsfrom
18	  continue
	  print *, "sqrt(s) =", Ecms
	  call IntegratedCS(treeres, loopres, Ecms, *1)
	  write(11, 27) Ecms, treeres, loopres
	  call flush(11)
	  if(Ecms .lt. Ecmsto) then
	    Ecms = Ecms + ECMSSTEP
	    goto 18
	  endif
	else
	  do theta = CUTOFF, pi - CUTOFF, THETASTEP
	    print *, "sqrt(s) =", Ecmsfrom, "  theta =", theta
	    call DifferentialCS(treeres, loopres, Ecmsfrom, theta, *1)
	    write(11, 27) theta, treeres, loopres
	    call flush(11)
	  enddo
	endif

	write(11, 28)
1	continue

	close(11)
	call ffexi
	end


************************************************************************
** ParseCommandline reads the polarizations and the energy range from
** the command line. From these values, it constructs a file name and
** opens the file for writing as file #11.

	subroutine ParseCommandline(Ecmsfrom, Ecmsto)
	implicit none
	double precision Ecmsfrom, Ecmsto

#include "kin.h"

	integer*4 iargc
	external iargc

	integer argc, i, j
	character*200 argv, outf
	character*4 polstr
	character c

	integer type(4)
	data type / TYPE1, TYPE2, TYPE3, TYPE4 /

	argc = iargc()
	if(argc .lt. 5 .or. argc .gt. 6) then
	  print *, "USAGE:"
	  print *, "to calculate a differential cross-section:"
	  print *, "  num p1 p2 p3 p4 sqrts"
	  print *, "to calculate an integrated cross-section:"
	  print *, "  num p1 p2 p3 p4 sqrts_from sqrts_to"
	  print *, "for polarizations p1 + p2 -> p3 + p4"
	  print *, "where p[1-4] may be one of"
	  print *, "  0  for longitudinal   polarization"
	  print *, "  +  for right-circular      ''"
	  print *, "  -  for left-circular       ''"
	  print *, "  t  for transverse          ''"
	  print *, "  u  for unpolarized particle"
	  stop
	endif

	avgfac = 1

	do i = 1, 4
	  if(type(i) .eq. SCALAR) then
	    c = 'S'
	    bpol(i) = 0
	    epol(i) = 0
	  else
	    call getarg(i, argv)
	    c = argv(1:1)
	    if(type(i) .eq. FERMION) then
	      if(c .eq. 'u') then
	        j = 0
	        if(i .gt. 2) avgfac = avgfac*2
	        c = 'U'
	      else if(c .eq. '+') then
	        j = 1
	      else if(c .eq. '-') then
	        j = -1
	      else
	        stop "Invalid polarization"
	      endif
	      bpol(i) = j
	      epol(i) = j
	    else
	      if(c .eq. 'u') then
	        if(type(i) .eq. PHOTON)
     +            stop "No longitudinal polarizations allowed"
	        bpol(i) = 0
	        epol(i) = 2
	        if(i .lt. 3) avgfac = avgfac/3D0
	        c = 'U'
	      else if(c .eq. 't') then
	        bpol(i) = 1
	        epol(i) = 2
	        if(i .lt. 3) avgfac = avgfac/2D0
	        c = 'T'
	      else
	        if(c .eq. 'l' .or. c .eq. '0') then
	          if(type(i) .eq. PHOTON)
     +              stop "No longitudinal polarizations allowed"
	          j = 0
	          c = 'L'
	        else if(c .eq. '+') then
	          j = 1
	        else if(c .eq. '-') then
	          j = 2
	        else
	          stop "Invalid polarization"
	        endif
	        bpol(i) = j
	        epol(i) = j
	      endif
	    endif
	  endif
	  polstr(i:i) = c
	enddo

22	format(E20.0)
23	format("diff.pol=", A4, ".E=", I5.5)
24	format("tot.pol=", A4, ".E=", I5.5, "-", I5.5)

	call getarg(5, argv)
	read(argv, 22) Ecmsfrom
	if(argc .eq. 5) then
	  Ecmsto = -1
	  write(outf, 23) polstr, int(Ecmsfrom)
	else
	  call getarg(6, argv)
	  read(argv, 22) Ecmsto
	  write(outf, 24) polstr, int(Ecmsfrom), int(Ecmsto)
	endif

	call getarg(0, argv)
	i = 0
12	continue
	i = i + 1
	if(argv(i:i) .ne. ' ') goto 12
	outf = argv(1:i - 1) // "-" // outf

	open(11, file=outf, status='UNKNOWN')
	print *, "output file: ", outf

	end


************************************************************************
** DifferentialCS actually invokes the generated function squared_me.
** If necessary, soft-photon bremsstrahlung corrections are added.

	subroutine DifferentialCS(treeres, loopres, Ecms, theta, *)
	implicit none
	double precision treeres, loopres, Ecms, theta

#include "kin.h"
#include "renconst.h"

#ifdef BREMSSTRAHLUNG
	double precision SoftPhotonFactor
	external SoftPhotonFactor
#endif

	double precision Ecms2, flux, EE(4), Pin, Pout
	double precision threshold, costh
	integer component, n
	logical reini
	save Ecms2, flux, EE, Pin, Pout

	double precision kallen, x1, x2

	double precision sqrt2, hbar_c2
	parameter (sqrt2 = 1.4142135623730950488016887242096981D0)
	parameter (hbar_c2 = 3.8937966D8)
*	  = \hbar c^2 in picobarn

	double precision prevEcms
	data prevEcms /-1/

	kallen(x1, x2) =
     +    sqrt(Ecms2*(Ecms2 - 2*(x1 + x2)) + (x1 - x2)**2)

26	format(VARFMT)
27	format("# WARNING: adjusted sqrt(s) to above-threshold value ",
     +    F10.2)

	if(reset .or. Ecms .ne. prevEcms) then
	  reini = reset
1	  continue
	  call model_ini(Ecms, reini, *999)
	  reini = .FALSE.
	  threshold = max(
     +      dble(MASS1 + MASS2),
     +      dble(MASS3 + MASS4))
	  if(Ecms .lt. threshold) then
	    print *, "Warning: sqrt(s) =", Ecms, " is below threshold."
	    Ecms = threshold + .01D0
	    print *, "Using sqrt(s) = ", Ecms, " now."
	    write(11, 27) Ecms
	    goto 1
	  endif

	  if(reset) then
	    write(11, 26) VAROUT
	    print 26, VAROUT
	  endif

#ifdef MUDIM
	  call setmudim(MUDIM)
#endif
#ifdef DELTA
	  call setdelta(DELTA)
#endif
#ifdef LAMBDA
	  call setlambda(LAMBDA)
#endif

	  mass(1) = MASS1**2
	  mass(2) = MASS2**2
	  mass(3) = MASS3**2
	  mass(4) = MASS4**2
	  call calc_renconst

	  prevEcms = Ecms
	  Ecms2 = Ecms**2

	  flux = avgfac*COLOURFACTOR*
     +      hbar_c2/(64*pi**2*Ecms2)*
     +      kallen(mass(3), mass(4))/kallen(mass(1), mass(2))

	  Pin = (Ecms2 + mass(2) - mass(1))**2/4D0/Ecms2 - mass(2)
	  Pout = (Ecms2 + mass(4) - mass(3))**2/4D0/Ecms2 - mass(4)
	  EE(1) = sqrt(Pin + mass(1))
	  EE(2) = sqrt(Pin + mass(2))
	  EE(3) = sqrt(Pout + mass(3))
	  EE(4) = sqrt(Pout + mass(4))
	  Pin = sqrt(Pin)
	  Pout = sqrt(Pout)

* some apps need the relative velocity of the final-state particles
	  beta = Pout/(.5D0*Ecms)

	  k1(1) = EE(1)
	  k1(2) = 0
	  k1(3) = 0
	  k1(4) = -Pin

	  if(MASS1 .ne. 0) then
	    e1(0,1) = -Pin/MASS1
	    e1(0,2) = 0
	    e1(0,3) = 0
	    e1(0,4) = EE(1)/MASS1
	  endif

	  e1(1,1) = 0
	  e1(1,2) = -1/sqrt2
	  e1(1,3) = dcmplx(0D0, 1/sqrt2)
	  e1(1,4) = 0

	  e1(2,1) = 0
	  e1(2,2) = -1/sqrt2
	  e1(2,3) = -dcmplx(0D0, 1/sqrt2)
	  e1(2,4) = 0

	  k2(1) = EE(2)
	  k2(2) = 0
	  k2(3) = 0
	  k2(4) = Pin

	  if(MASS2 .ne. 0) then
	    e2(0,1) = -Pin/MASS2
	    e2(0,2) = 0
	    e2(0,3) = 0
	    e2(0,4) = -EE(2)/MASS2
	  endif

	  e2(1,1) = 0
	  e2(1,2) = 1/sqrt2
	  e2(1,3) = dcmplx(0D0, 1/sqrt2)
	  e2(1,4) = 0

	  e2(2,1) = 0
	  e2(2,2) = 1/sqrt2
	  e2(2,3) = -dcmplx(0D0, 1/sqrt2)
	  e2(2,4) = 0

	  do n = 1, 8
	    do component = 1, 4
	      vec(component, -n) = dconjg(vec(component, n))
	    enddo
	  enddo
	endif

	sinth = sin(theta)
	costh = cos(theta)

	k3(1) = EE(3)
	k3(2) = -Pout*sinth
	k3(3) = 0
	k3(4) = -Pout*costh

	if(MASS3 .ne. 0) then
	  e3(0,1) = -Pout/MASS3
	  e3(0,2) = EE(3)/MASS3*sinth
	  e3(0,3) = 0
	  e3(0,4) = EE(3)/MASS3*costh
	endif

	e3(1,1) = 0
	e3(1,2) = -costh/sqrt2
	e3(1,3) = -dcmplx(0D0, 1/sqrt2)
	e3(1,4) = sinth/sqrt2

	e3(2,1) = 0
	e3(2,2) = -costh/sqrt2
	e3(2,3) = dcmplx(0D0, 1/sqrt2)
	e3(2,4) = sinth/sqrt2

	k4(1) = EE(4)
	k4(2) = Pout*sinth
	k4(3) = 0
	k4(4) = Pout*costh

	if(MASS4 .ne. 0) then
	  e4(0,1) = -Pout/MASS4
	  e4(0,2) = -EE(4)/MASS4*sinth
	  e4(0,3) = 0
	  e4(0,4) = -EE(4)/MASS4*costh
	endif

	e4(1,1) = 0
	e4(1,2) = costh/sqrt2
	e4(1,3) = -dcmplx(0D0, 1/sqrt2)
	e4(1,4) = -sinth/sqrt2

	e4(2,1) = 0
	e4(2,2) = costh/sqrt2
	e4(2,3) = dcmplx(0D0, 1/sqrt2)
	e4(2,4) = -sinth/sqrt2

	do n = 9, 16
	  do component = 1, 4
	    vec(component, -n) = dconjg(vec(component, n))
	  enddo
	enddo

	call squared_me(treeres, loopres, Ecms2,
     +    bpol(1), epol(1),
     +    bpol(2), epol(2),
     +    bpol(3), epol(3), 
     +    bpol(4), epol(4), reset)

	treeres = treeres*flux
	loopres = loopres*flux + treeres

#ifdef BREMSSTRAHLUNG
	loopres = loopres + treeres*SoftPhotonFactor(Ecms)
#endif

#ifdef WF_RENORMALIZATION
	loopres = loopres + treeres*WF_RENORMALIZATION
#endif
	return

999	continue
	return 1
	end


************************************************************************
** IntegratedCS integrates DifferentialCS over the scattering angle.

	subroutine IntegratedCS(treeres, loopres, Ecms, *)
	implicit none
	double precision treeres, loopres, Ecms

#include "kin.h"

	double precision gauss_x(GAUSSPOINTS/2)
	double precision gauss_w(GAUSSPOINTS/2)

	integer i
	double precision x, w
	double precision treeamp, loopamp, treeF, treeB, loopF, loopB
	double precision lower, upper, mid1, mid2, range
	parameter ( lower = CUTOFF, upper = pi - CUTOFF,
     +    mid1 = .5D0*(lower + pi/2),
     +    mid2 = .5D0*(upper + pi/2),
     +    range = .25D0*(upper - lower) )

#include "gauss.F"

* Integration is done in two intervals separately:
* [CUTOFF, pi/2] and [pi/2, pi - CUTOFF].
* In this way, we get the F-B asymmetry for free, even
* though the number of sampling points is the same,
* e.g. instead of 32 over the whole interval we can do
* with 16 over each half.

	treeF = 0
	loopF = 0
	treeB = 0
	loopB = 0

	do i = 1, GAUSSPOINTS/2
	  x = range*gauss_x(i)
	  w = range*2*pi*IDENTICALFACTOR*gauss_w(i)
*			*2*pi from phi integration
*			possibly /2 because of identical particles
	  call DifferentialCS(treeamp, loopamp, Ecms, mid1 + x, *999)
	  treeF = treeF + sinth*w*treeamp
	  loopF = loopF + sinth*w*loopamp
	  call DifferentialCS(treeamp, loopamp, Ecms, mid1 - x, *999)
	  treeF = treeF + sinth*w*treeamp
	  loopF = loopF + sinth*w*loopamp
	  call DifferentialCS(treeamp, loopamp, Ecms, mid2 + x, *999)
	  treeB = treeB + sinth*w*treeamp
	  loopB = loopB + sinth*w*loopamp
	  call DifferentialCS(treeamp, loopamp, Ecms, mid2 - x, *999)
	  treeB = treeB + sinth*w*treeamp
	  loopB = loopB + sinth*w*loopamp
	enddo

	treeres = treeF + treeB
	loopres = loopF + loopB

#ifdef FB_ASYMMETRY
	if(treeres .eq. 0) then
	  treeres = 999D0
	else
	  treeres = (treeF - treeB)/treeres
	endif

	if(loopres .eq. 0) then
	  loopres = 999D0
	else
	  loopres = (loopF - loopB)/loopres
	endif
#endif
	return

999	continue
	return 1
	end


************************************************************************
** The Kronecker delta.

	integer function IndexDelta(i, j)
	implicit none
	integer i, j

	if(i .eq. j) then
	  IndexDelta = 1
	else
	  IndexDelta = 0
	endif
	end


************************************************************************
** MomSquare is a function used to calculate Mandelstam variables
** which in general are the squared difference of two momenta. If the
** squared sum is needed, the second argument must be passed as a
** negative integer. Since MomSquare is called only on momentum
** vectors, all operations are done only on the real part.

	double precision function MomSquare(i, j)
	implicit none
	integer i, j

#include "kin.h"

	if(j .lt. 0) then
	  j = -j
	  MomSquare =
     +      (dble(vec(1,i)) + dble(vec(1,j)))**2 -
     +      (dble(vec(2,i)) + dble(vec(2,j)))**2 -
     +      (dble(vec(3,i)) + dble(vec(3,j)))**2 -
     +      (dble(vec(4,i)) + dble(vec(4,j)))**2
	else
	  MomSquare =
     +      (dble(vec(1,i)) - dble(vec(1,j)))**2 -
     +      (dble(vec(2,i)) - dble(vec(2,j)))**2 -
     +      (dble(vec(3,i)) - dble(vec(3,j)))**2 -
     +      (dble(vec(4,i)) - dble(vec(4,j)))**2
	endif
	end


************************************************************************
** Pair calculates the scalar product of two four-vectors.

	double complex function Pair(i, j)
	implicit none
	integer i, j

#include "kin.h"

	Pair =
     +    vec(1,i)*vec(1,j) -
     +    vec(2,i)*vec(2,j) -
     +    vec(3,i)*vec(3,j) -
     +    vec(4,i)*vec(4,j)
	end


************************************************************************
** Eps calculates -I times the Levi-Civita tensor contracted with
** four four-vectors.

	double complex function Eps(i, j, k, l)
	implicit none
	integer i, j, k, l

#include "kin.h"

	double complex kl12, kl13, kl14, kl23, kl24, kl34

	kl12 = vec(1,k)*vec(2,l) - vec(2,k)*vec(1,l)
	kl13 = vec(1,k)*vec(3,l) - vec(3,k)*vec(1,l)
	kl14 = vec(1,k)*vec(4,l) - vec(4,k)*vec(1,l)
	kl23 = vec(2,k)*vec(3,l) - vec(3,k)*vec(2,l)
	kl24 = vec(2,k)*vec(4,l) - vec(4,k)*vec(2,l)
	kl34 = vec(3,k)*vec(4,l) - vec(4,k)*vec(3,l)

	Eps =
     +    vec(1,i)*(vec(2,j)*kl34 - vec(3,j)*kl24 + vec(4,j)*kl23) -
     +    vec(2,i)*(vec(1,j)*kl34 - vec(3,j)*kl14 + vec(4,j)*kl13) +
     +    vec(3,i)*(vec(1,j)*kl24 - vec(2,j)*kl14 + vec(4,j)*kl12) -
     +    vec(4,i)*(vec(1,j)*kl23 - vec(2,j)*kl13 + vec(3,j)*kl12)

* Note: although Eps is defined as -I*(Levi-Civita tensor) in FormCalc,
* we have to multiply with I (not -I) here because we've neglected
* the metric in the summation above.

	Eps = dcmplx(0, 1)*Eps
	end


#ifdef BREMSSTRAHLUNG

************************************************************************
** SoftPhotonFactor adds up the contributions from soft-photon emission
** off the different legs. The result then has to be multiplied with
** the Born cross-section.

	double precision function SoftPhotonFactor(Ecms)
	implicit none
	double precision Ecms

#include "kin.h"

	double precision PhaseSpaceIntegral
	external PhaseSpaceIntegral

	integer i, j

	double precision loglambda
	common /infrared/ loglambda

	double precision ch1, ch2, ch3, ch4, relsign(4)
	parameter (ch1 = CHARGE1, ch2 = CHARGE2,
     +    ch3 = -(CHARGE3), ch4 = -(CHARGE4))
	data relsign / ch1, ch2, ch3, ch4 /

	loglambda = log(4*(ESOFTMAX)**2/getlambda())

	SoftPhotonFactor = 0
	do i = 1, 4
	  do j = i, 4
	    SoftPhotonFactor = SoftPhotonFactor +
     +        relsign(i)*relsign(j)*PhaseSpaceIntegral(i, j)
	  enddo
	enddo
	SoftPhotonFactor = -4*pi*Alfa/(2*pi)**3*SoftPhotonFactor
	end


************************************************************************
** PhaseSpaceIntegral calculates the integral over the soft photon's
** phase space. See A. Denner, Fortschr. d. Physik, 41 (1993) 4.

	double precision function PhaseSpaceIntegral(i, j)
	implicit none
	integer i, j

#include "kin.h"

	double complex Pair
	double precision Li2
	external Pair, Li2

	integer ii, jj
	double precision ki0, ki, kj0, kj, kikj
	double precision alpha, vnum, v

	double precision loglambda
	common /infrared/ loglambda

	double precision AbsVec
	integer k

	AbsVec(k) = sqrt(dble(vec(2,k))**2 +
     +    dble(vec(3,k))**2 + dble(vec(4,k))**2)

	ii = 4*i - 3
	ki0 = dble(vec(1,ii))
	ki = AbsVec(ii)

	if(i .eq. j) then
	  PhaseSpaceIntegral =
     +      pi*(loglambda + ki0/ki*log((ki0 - ki)/(ki0 + ki)))
	  return
	endif

	jj = 4*j - 3
	kj0 = dble(vec(1,jj))
	kj = AbsVec(jj)
	kikj = dble(Pair(ii, jj))

	v = sqrt(kikj**2 - mass(i)*mass(j))
	alpha = (kikj + v)/mass(i)
	if((alpha*ki0 - kj0)/kj0 .lt. 0) alpha = (kikj - v)/mass(i)

	vnum = alpha**2*mass(i) - mass(j)
	v = .5D0*vnum/(alpha*ki0 - kj0)

	PhaseSpaceIntegral = 4*pi*alpha*kikj/vnum * (
     +    .5D0*log(alpha**2*mass(i)/mass(j))*loglambda +
     +    .25D0*(log((ki0 - ki)/(ki0 + ki)) -
     +           log((kj0 - kj)/(kj0 + kj))) +
     +    Li2(1 - (ki0 + ki)*alpha/v) - Li2(1 - (kj0 + kj)/v) +
     +    Li2(1 - (ki0 - ki)*alpha/v) - Li2(1 - (kj0 - kj)/v) )

	end


************************************************************************
** Li2 calls the dilogarithm function of FF, ffzxdl

	double precision function Li2(x)
	implicit none
	double precision x

#include "kin.h"

	double precision pi12
	parameter (pi12 = pi**2/12D0)

	double complex cli2, dummy
	integer ier, ipi12

	ier = 0
	call ffzxdl(cli2, ipi12, dummy, x, 1, ier)
	Li2 = dble(cli2) + ipi12*pi12
	end

#endif

* rc_zero.F
* sets all renormalization constants to zero for debugging purposes
* this file is part of FormCalc
* last modified 21 Jun 01 th

#include "prefix.h"

	subroutine calc_renconst
	implicit none

#include "renconst.h"

	data rc /sizeof_rc*0/

	end

* 2to4.F
* the kinematics for a 2 -> 4 process
* this file is part of FormCalc
* last modified 18 Jan 08 th


* some definitions for xsection.F
#define LEGS 6
#define LEGS_IN 2
#define LEGS_OUT 4
#define MASS_IN MASS1 + MASS2
#define MASS_OUT MASS3 + MASS4 + MASS5 + MASS6
#define TYPES TYPE1, TYPE2, TYPE3, TYPE4, TYPE5, TYPE6

* this defines the order of integrations:
#define XMREM6 1
#define XCOSTH6 2
#define XMREM5 3
#define XCOSTH5 4
#define XPHI5 5
#define XCOSTH4 6
#define XPHI4 7
#define MAXVAR XPHI4

#include LUMI


************************************************************************

	subroutine KinIni(fail)
	implicit none
	integer fail

#include "xsection.h"

	Lower(XMREM6) = 0
	Upper(XMREM6) = 1
	if( Lower(SQRTS) .gt. Upper(SQRTS) ) then
	  Step(XMREM6) = XMREM6STEP
	else
	  Step(XMREM6) = 0
	endif

	Lower(XMREM5) = 0
	Upper(XMREM5) = 1
	Step(XMREM5) = 0

	Lower(XCOSTH5) = 0
	Upper(XCOSTH5) = 1
	Step(XCOSTH5) = 0

	Lower(XCOSTH4) = 0
	Upper(XCOSTH4) = 1
	Step(XCOSTH4) = 0

	Lower(XPHI4) = 0
	Upper(XPHI4) = 1
	Step(XPHI4) = 0

	fail = 0
	end


************************************************************************

	subroutine InitialState
	implicit none

#include "xsection.h"

	double precision p

	p = ThreeMom(sqrtS, DBLE(MASS1), DBLE(MASS2))

	call VecSet(1, DBLE(MASS1), p, 0D0, 0D0, 1D0)
	call VecSet(2, DBLE(MASS2), p, 0D0, 0D0, -1D0)
	end


************************************************************************

	subroutine FinalState(fac)
	implicit none
	double precision fac

#include "xsection.h"

	double precision p, ex,ey,ez, msum, minv
	integer key

	p = 0
	ex = 0
	ey = 0
	ez = 1
	minv = sqrtS
	msum = MASS_OUT

	key = 0
#ifdef E5MIN
	CutMin(XMREM6) = E6MIN
	key = key + Cut(CUT_MREM_E, CUT_MIN)
#endif
#ifdef COSTH6CUT
	CutMin(XCOSTH6) = -(1 - COSTH6CUT)
	CutMax(XCOSTH6) = +(1 - COSTH6CUT)
	key = key + Cut(CUT_COSTH, CUT_MIN + CUT_MAX)
#endif

	call Split(6, DBLE(MASS6), p, ex,ey,ez, minv, msum,
     &    fac, key, Var(XMREM6), Var(XCOSTH6), Var(TRIVIAL))
	Show(XMREM6) = momspec(SPEC_E, 6)
	if( fac .eq. 0 ) return

	call Split(5, DBLE(MASS5), p, ex,ey,ez, minv, msum,
     &    fac, key, Var(XMREM5), Var(XCOSTH5), Var(XPHI5))
	Show(XMREM5) = momspec(SPEC_E, 5)
	if( fac .eq. 0 ) return

	call Split(4, DBLE(MASS4), p, ex,ey,ez, minv, msum,
     &    fac, 0, Var(FIXED), Var(XCOSTH4), Var(XPHI4))

	call VecSet(3, DBLE(MASS3), p, ex,ey,ez)
	end

* CTBcut.F
* the FormCalc wrapper for the CutTools two-point function
* this file is part of FormCalc
* last modified 3 Aug 11 th


	double complex function CTBcut(rank, num, numeps,
     &    p, m1, m2)
	implicit none
	integer rank
	external num, numeps
	integer*8 p
	double precision m1, m2

	double precision pj(0:3,2), mj(2)
	logical stable, forcemp
	double complex res(0:2), res1
	external CTmpnum

	double precision rootsvalue, muscale
	common /cuttools_para/ rootsvalue, muscale

	pj(0,1) = 0
	pj(1,1) = 0
	pj(2,1) = 0
	pj(3,1) = 0
	call CTMomDecode(p, pj(0,2))

	mj(1) = m1
	mj(2) = m2

	PRINT *, "CTBcut:", rank
	PRINT *, "p1=", pj(0,2)
	PRINT *, "   ", pj(1,2)
	PRINT *, "   ", pj(2,2)
	PRINT *, "   ", pj(3,2)
	PRINT *, "m1=", m1
	PRINT *, "m2=", m2

	call ctsxcut(rootsvalue, muscale, 2, num, CTmpnum,
     &    rank, pj, mj, res, res1, stable, forcemp)
	CTBcut = res(0)
	PRINT *, "CTBcut=", CTBcut
	end

* mssm_ini.F
* all parameters for the MSSM are initialized here
* this file is part of FormCalc
* Christian Schappacher, 17 Feb 99
* last modified 15 Jun 01 th


* The input parameters for mssm_ini are:

* Higgs sector:
*   TB = tan beta
*   MA0 = Mass(A_0)

* Chargino/Neutralino sector:
*   M_2 
*   Mue

* Sfermion sector:
*   MSusy
*   Au, Ad
* If one wants to specify the breaking and mixing in the
* sfermion sector more precisely, the following preprocessor
* variables can be used:
*   MSQ, MSU, MSD, MSL, MSE (= MSusy by default)


* The following preprocessor variables can be defined
* (they are usually set in process.h):

* NO_SQUARK_MIXING
*   If defined, sets Au and Ad such that the off-diagonal entries of
*   the sfermion mixing matrices vanish, i.e. gauge eigenstates =
*   mass eigenstates.

* COMPLEX_PARAMETERS
*   If defined, uses a simpler (one-loop) approximation of the
*   Higgs masses which is valid for all parameters. Normally,
*   the more precise (two-loop) approximation is taken, which is
*   however valid only for real parameters.

* SM_ONLY
*   If defined, reverse-engineers the mixing in the Higgs sector
*   (alpha and beta) such that the MSSM Higgs sector looks like
*   a SM Higgs sector.

* NO_EXCLUSION_LIMITS
*   If defined, the experimental exclusion limits are ignored.


#ifndef MSQ
#define MSQ MSusy
#endif

#ifndef MSU
#define MSU MSusy
#endif

#ifndef MSL
#define MSL MSusy
#endif

#ifndef MSD
#define MSD MSusy
#endif

#ifndef MSE
#define MSE MSusy
#endif

#define MSQ2 MSQ**2
#define MSU2 MSU**2
#define MSD2 MSD**2
#define MSE2 MSE**2
#define MSL2 MSL**2


* Exclusion limits (only checked if NO_EXCLUSION_LIMITS is not set):

* hep-ex/9910020 (L3)
#define MStop_LOWERBOUND 80

* hep-ex/9910020 (L3)
#define MSbottom_LOWERBOUND 70

* hep-ex/9910020 (L3)
#define MSquark_LOWERBOUND 150

* hep-ex/9910006 (L3)
#define MSlepton_LOWERBOUND 70

* PDG
#define DeltaRho_UPPERBOUND .003D0

#ifdef COMPLEX_PARAMETERS
* Kane & Wang, Phys Lett B488 (2000) 383
#define Mh0_LOWERBOUND 85
#else
* http://lephiggs.web.cern.ch/LEPHIGGS/papers/osaka_note.ps
#define Mh0_LOWERBOUND 91
#endif

* hep-ex/9910007 (L3) and hep-ex/9909051 (OPAL)
#define MNeutralino_LOWERBOUND 30

* hep-ex/9910007 (L3) and hep-ex/9909051 (OPAL)
#define MChargino_LOWERBOUND 90

* hep-ex/9910020 (L3) and PDG
#define MGl_LOWERBOUND 175


#define model_ini sm_ini
#include "sm_ini.F"
#undef model_ini


************************************************************************

	subroutine model_ini(Ecms, reset, *)
	implicit none
	double precision Ecms
	logical reset

#include "model.h"

	integer i, j
	double precision A, B

	double precision Alfas_MT, sig1, sig12, sig2
	common /radcor/ Alfas_MT, sig1, sig12, sig2

	double precision ALPHAS2
	external ALPHAS2

	call sm_ini(Ecms, reset, *999)

* Gluino mass: GUT relation
* we use 1/Alfa(s) approx 1/Alfa(MZ2) - 20/(9*pi)*log(s/MZ2)

	MGl = Alfas*(127.934D0 - 40/(9*pi)*log(Ecms/MZ))*SW2*M_2
#ifndef NO_EXCLUSION_LIMITS
	if(MGl .lt. MGl_LOWERBOUND) then
	  print *, "mssm_ini: MGl = ", MGl,
     +      " < MGl_LOWERBOUND = ", MGl_LOWERBOUND
	  return 1
	endif
#endif
	MGl2 = MGl**2

	if(.not. reset) return

	Alfas_MT = ALPHAS2(MT)

* GUT relation (Higgs Hunter's Guide p. 287)
	M_1 = 5/3D0*SW2/CW2*M_2

#ifdef NO_SQUARK_MIXING
	Au = dconjg(MUE)/TB
	Ad = dconjg(MUE)*TB
#endif

	B   = atan(TB)
	SB  = sin(B)
	CB  = cos(B)
	S2B = sin(2*B)
	C2B = cos(2*B)
	SB2 = SB**2
	CB2 = CB**2
	TB2 = TB**2

	call sfermion_masses(*999)
	call chargino_masses(*999)
	call neutralino_masses(*999)
	call higgs_masses(*999)

#ifdef SM_ONLY

* With SM_ONLY defined, the values of the MSSM parameters are set
* such that the SM is reproduced. See Higgs Hunter's Guide p. 356.
* Note one tricky thing: the Higgs mass Mh0 is first calculated as
* it would be in the MSSM (to get the same value when comparing
* MSSM <-> SM), but then beta is reverse-engineered to be consistent
* with the SM relations. In other words, we start with the MSSM-
* value of beta, calculate Mh0, and then redefine beta to fulfill
* cos(2 beta) = Mh0/MZ. In principle, beta could also be fixed such
* that cos(2 beta) = -Mh0/MZ, but this is insignificant here since
* we only need beta to be consistent with the values of Mh0 and MZ.

	C2B = Mh0/MZ
	B   = .5D0*acos(C2B)
	SB  = sin(B)
	CB  = cos(B)
	TB  = tan(B)
	S2B = sin(2*B)

	A   = 0
	SA  = -CB
	CA  = SB
	S2A = -S2B
	C2A = -C2B
	SAB = -C2B
	CAB = S2B
	SBA = 1
	CBA = 0
#else
	A = (-(MA02 + MZ2)*SB*CB - sig12)/
     &        (MZ2*CB2 + MA02*SB2 - sig1 - Mh02)
	if(A .le. 0) then
	  A = atan(A)
	else
	  A = atan(A) - pi
	endif
	SA  = sin(A)
	CA  = cos(A)
	S2A = sin(2*A)
	C2A = cos(2*A)
	SAB = sin(A + B)
	CAB = cos(A + B)
	SBA = sin(B - A)
	CBA = cos(B - A)
#endif

	SA2  = SA**2
	CA2  = CA**2

*-----------------------------------------------------------------------

#ifdef DEBUG

	print *, "SUSY parameters"
	print *, "----------------------------"
	print *, "TB =", TB
	print *, "M_1 =", M_1
	print *, "M_2 =", M_2
	print *, "MUE =", MUE
	print *, "MSusy =", MSusy
	print *, "Af(top) =", Af(3, 3)
	print *, "Af(bottom) =", Af(4, 3)
	print *, "----------------------------"
	print *, "Higgs masses:"
#ifdef COMPLEX_PARAMETERS
	print *, "(using simple approximation for Higgs mass)"
#else
	print *, "(using 2-loop approximation for Higgs mass)"
#endif
	print *, "Mh0 =", Mh0
	print *, "MHH =", MHH
	print *, "MHp =", MHp
	print *, "MA0 =", MA0
	print *, "----------------------------"
	print *, "Sfermion masses:"
#ifdef NO_SQUARK_MIXING
	print *, "(diagonal sfermion mass matrix: L-R basis)"
#else
	print *, "(non-diagonal sfermion mass matrix: 1-2 basis)"
#endif
3	format(" MSf(1|2, ", I1, ", ", I1, ") =", 2G24.15)
	do j = 1, 4
	  do i = 1, 3
	    print 3, j, i, MSf(1, j, i), MSf(2, j, i)
	  enddo
	enddo
	print *, "----------------------------"
	print *, "Chargino masses:"
	print *, "MCha(1) =", MCha(1)
	print *, "MCha(2) =", MCha(2)
	print *, "----------------------------"
	print *, "Neutralino masses:"
	print *, "MNeu(1) =", MNeu(1)
	print *, "MNeu(2) =", MNeu(2)
	print *, "MNeu(3) =", MNeu(3)
	print *, "MNeu(4) =", MNeu(4)
	print *, "----------------------------"
	print *, "Gluino mass:"
	print *, "MGl =", MGl
	print *, "============================"

#endif
	return

999	return 1
	end


*-----------------------------------------------------------------------
* Sfermion sector:

	subroutine sfermion_masses(*)
	implicit none

#include "model.h"

	integer lwork, i, j, svdinfo
	parameter (lwork = 16)
	double complex work(lwork), rwork(lwork), tmp

	double precision Qe, Qu, Qd
	parameter (Qe = -1D0, Qu = 2/3D0, Qd = -1/3D0)

#ifndef NO_EXCLUSION_LIMITS
	double precision f1f2, abs2, DeltaRho
	double complex c_
	external f1f2
	abs2(c_) = dble(c_*dconjg(c_))
#endif

	do j = 1, 3
	  Af(2, j) = Ad
	  USf(1, 1, 2, j) = MSL2 + MZ2*(-.5D0 - Qe*SW2)*C2B + MLE2(j)
	  USf(2, 2, 2, j) = MSE2 + Qe*MZ2*SW2*C2B + MLE2(j)
	  USf(1, 2, 2, j) = MLE(j)*(Af(2, j) - dconjg(MUE)*TB)

	  Af(3, j) = Au
	  USf(1, 1, 3, j) = MSQ2 + MZ2*(.5D0 - Qu*SW2)*C2B + MQU2(j)
	  USf(2, 2, 3, j) = MSU2 + Qu*MZ2*SW2*C2B + MQU2(j)
	  USf(1, 2, 3, j) = MQU(j)*(Af(3, j) - dconjg(MUE)/TB)

	  Af(4, j) = Ad
	  USf(1, 1, 4, j) = MSQ2 + MZ2*(-.5D0 - Qd*SW2)*C2B + MQD2(j)
	  USf(2, 2, 4, j) = MSD2 + Qd*MZ2*SW2*C2B + MQD2(j)
	  USf(1, 2, 4, j) = MQD(j)*(Af(4, j) - dconjg(MUE)*TB)

	  do i = 2, 4
	    call ZHEEV('V', 'U', 
     +         2, USf(1, 1, i, j), 2, MSf2(1, i, j),
     +         work, lwork, rwork, svdinfo)
* transpose USf
	    tmp = USf(1, 2, i, j)
	    USf(1, 2, i, j) = USf(2, 1, i, j)
	    USf(2, 1, i, j) = tmp

	    if(svdinfo .ne. 0) then
	      print *,
     +          "mssm_ini: error in sfermion matrix diagonalization"
	      return 1
	    endif
	    if(MSf2(1, i, j) .lt. 0) then
	      print *, "mssm_ini: negative sfermion mass squares"
	      return 1
	    endif

	    MSf(1, i, j) = sqrt(MSf2(1, i, j))
	    MSf(2, i, j) = sqrt(MSf2(2, i, j))
	  enddo
	enddo

#ifndef NO_EXCLUSION_LIMITS
	if(MSf(1, 4, 3) .lt. MSbottom_LOWERBOUND) then
	  print *, "mssm_ini: MSf(1, 4, 3) = ", MSf(1, 4, 3),
     +      " < MSbottom_LOWERBOUND = ", MSbottom_LOWERBOUND
	  return 1
	endif

	if(MSf(1, 3, 3) .lt. MStop_LOWERBOUND) then
	  print *, "mssm_ini: MSf(1, 3, 3) = ", MSf(1, 3, 3),
     +      " < MStop_LOWERBOUND = ", MStop_LOWERBOUND
	  return 1
	endif

	if(MSf(1, 2, 1) .lt. MSlepton_LOWERBOUND) then
	  print *, "mssm_ini: MSf(1, 2, 1) = ", MSf(1, 2, 1),
     +      " < MSlepton_LOWERBOUND = ", MSlepton_LOWERBOUND
	  return 1
	endif

	if(MSf(1, 3, 1) .lt. MSquark_LOWERBOUND) then
	  print *, "mssm_ini: MSf(1, 3, 1) = ", MSf(1, 3, 1),
     +      " < MSquark_LOWERBOUND = ", MSquark_LOWERBOUND
	  return 1
	endif

	DeltaRho =
     &     USf(1,1,3,3)*dconjg(USf(1,2,3,3))
     &     * USf(2,2,3,3)*dconjg(USf(2,1,3,3)) 
     &     * f1f2(MSf2(1,3,3), MSf2(2,3,3))
     &   + USf(1,1,4,3)*dconjg(USf(1,2,4,3))
     &     * USf(2,2,4,3)*dconjg(USf(2,1,4,3)) 
     &     * f1f2(MSf2(1,4,3), MSf2(2,4,3))
     &   + abs2(USf(1,1,3,3)) * abs2(USf(1,1,4,3))
     &     * f1f2(MSf2(1,3,3), MSf2(1,4,3))
     &   + abs2(USf(1,1,3,3)) * abs2(USf(2,1,4,3))
     &     * f1f2(MSf2(1,3,3), MSf2(2,4,3))
     &   + abs2(USf(2,1,3,3)) * abs2(USf(1,1,4,3))
     &     * f1f2(MSf2(2,3,3), MSf2(1,4,3))
     &   + abs2(USf(2,1,3,3)) * abs2(USf(2,1,4,3))
     &     * f1f2(MSf2(2,3,3), MSf2(2,4,3))

	if(DeltaRho .gt. DeltaRho_UPPERBOUND) then
	  print *, "mssm_ini: DeltaRho = ", DeltaRho,
     +      " > DeltaRho_UPPERBOUND = ", DeltaRho_UPPERBOUND
	  return 1
	endif
#endif

	do j = 1, 3
	  MSf2(1, 1, j) = MSL2 + .5D0*MZ2*C2B
	  MSf(1, 1, j) = sqrt(MSf2(1, 1, j))
	  MSf2(2, 1, j) = -1
	  MSf(2, 1, j) = -1
	enddo
	end


*-----------------------------------------------------------------------
* this function is needed for the calculation of Delta rho

	double precision function f1f2(m1, m2)
	implicit none
	double precision m1, m2

#include "model.h"

	double precision f1, f2, logm1m2, c1

	double precision Alfas_MT, sig1, sig12, sig2
	common /radcor/ Alfas_MT, sig1, sig12, sig2

	double precision Li2
	external Li2

	logm1m2 = log(m1/m2)
	c1 = 2*m1*m2/(m1 - m2)*logm1m2
	f1 = m1 + m2 - c1
	f2 = m1 + m2 - c1*(2 + m1/m2*logm1m2)
     +   + (m1 + m2)*m1**2/(m1 - m2)**2 * logm1m2**2
     +   - 2*(m1 - m2) * dble(Li2(1 - m1/m2))

	f1f2 = 3*GF/(8*sqrt2*pi**2) * (f1 + 2/(3*pi)*Alfas_MT*f2)
	end


*-----------------------------------------------------------------------
* Chargino sector:

	subroutine chargino_masses(*)
	implicit none

#include "model.h"

	integer lwork, svdinfo
	parameter (lwork = 16)
	double complex work(lwork), rwork(lwork), X(2, 2), tmp

	X(1, 1) = M_2
	X(1, 2) = sqrt2*MW*SB
	X(2, 1) = sqrt2*MW*CB
	X(2, 2) = MUE
	call ZGESVD('A', 'A', 2, 2, X, 2, MCha, UCha, 2, VCha, 2,
     +    work, lwork, rwork, svdinfo)

	if(svdinfo .ne. 0) then
	  print *, "mssm_ini: error in chargino matrix SVD"
	  return 1
	endif
	if(MCha(2) .lt. 0) then
	  print *, "mssm_ini: negative chargino mass squares"
	  return 1
	endif

#ifndef NO_EXCLUSION_LIMITS
	if(MCha(2) .lt. MChargino_LOWERBOUND) then
	  print *, "mssm_ini: MCha(2) = ", MCha(2),
     +      " < MChargino_LOWERBOUND = ", MChargino_LOWERBOUND
	  return 1
	endif
#endif

* transpose UCha
	tmp = UCha(1, 2)
	UCha(1, 2) = UCha(2, 1)
	UCha(2, 1) = tmp

	MCha2(1) = MCha(1)**2
	MCha2(2) = MCha(2)**2
	end


*-----------------------------------------------------------------------
* Neutralino sector:

	subroutine neutralino_masses(*)
	implicit none

#include "model.h"

	integer lwork, i, j, svdinfo
	parameter (lwork = 16)
	double complex work(lwork), rwork(lwork)
	double complex Y(4, 4), phase
	double complex USVD(4, 4), VHSVD(4, 4)

	Y(1, 1) = M_1
	Y(2, 1) = 0
	Y(3, 1) = -MZ*SW*CB
	Y(4, 1) = MZ*SW*SB
	Y(1, 2) = Y(2, 1)
	Y(2, 2) = M_2
	Y(3, 2) = MZ*CW*CB
	Y(4, 2) = -MZ*CW*SB
	Y(1, 3) = Y(3, 1)
	Y(2, 3) = Y(3, 2)
	Y(3, 3) = 0
	Y(4, 3) = -MUE
	Y(1, 4) = Y(4, 1)
	Y(2, 4) = Y(4, 2)
	Y(3, 4) = Y(4, 3)
	Y(4, 4) = 0

* ZGESVD calculates USVD, VHSVD, MNeu such that Y = USVD diag(MNeu) VHSVD.
	call ZGESVD('A', 'A', 4, 4, Y, 4, MNeu, USVD, 4, VHSVD, 4,
     +    work, lwork, rwork, svdinfo)

	if(svdinfo .ne. 0) then
	  print *, "mssm_ini: error in neutralino matrix SVD"
	  return 1
	endif
	if(MNeu(4) .lt. 0) then
	  print *, "mssm_ini: negative neutralino mass squares"
	  return 1
	endif

#ifndef NO_EXCLUSION_LIMITS
	if(MNeu(4) .lt. MNeutralino_LOWERBOUND) then
	  print *, "mssm_ini: MNeu(4) = ", MNeu(4),
     +      " < MNeutralino_LOWERBOUND = ", MNeutralino_LOWERBOUND
	  return 1
	endif
#endif

* ZNeu_{ij} = diag(sqrt(V . U^*)^*) . V
*           = sqrt(sum_k V_{ik} U^*_{ki})^* V_{ij}
	do i = 1, 4
	  MNeu2(i) = MNeu(i)**2
	  phase = 0
	  do j = 1, 4
	    phase = phase + VHSVD(i, j)*dconjg(USVD(j, i))
	  enddo
	  phase = dconjg(sqrt(phase))
	  do j = 1, 4
	    ZNeu(i, j) = phase*VHSVD(i, j)
	  enddo
	enddo
	end


*-----------------------------------------------------------------------
* Higgs masses:
* Mh0, MHH, (MHp) are tree-level masses if sig1 = sig12 = sig2 = 0,
* otherwise they are radiatively corrected!

	subroutine higgs_masses(*)
	implicit none

#include "model.h"

	double precision MTr2, M_S2, MtLR, MbLR, Lambda
	double precision Xt, topstop, toplog, mix
	double precision Pb, Pf, Pg, Pg_, P1h, P2h, P2h_
	double precision pref, pref2, tmp, tmp2, tmplog

	double precision Alfas_MT, sig1, sig12, sig2
	common /radcor/ Alfas_MT, sig1, sig12, sig2

	integer Nc, Ng
	double precision Qt, Qb
	parameter (Nc = 3, Ng = 3, Qt = 2/3D0, Qb = -1/3D0)

	MA02 = MA0**2

* this is the running top quark mass:
	MTr2 = MT2/(1 + 4/(3*pi)*Alfas_MT)**2

#ifdef COMPLEX_PARAMETERS

* Simple approximation: (for complex and/or real case)
* ~~~~~~~~~~~~~~~~~~~~~
	sig2 = 3*GF/(2*sqrt2*pi**2)*MTr2**2/SB2*
     &    log(1 + (MSQ2*MSU2/MTr2 + MSQ2 + MSU2)/MTr2)
	sig1 = 0
	sig12 = 0

#else

* Heinemeyer/Weiglein approximation: hep-ph/9903404 (only for real case)
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	M_S2 = sqrt(MSQ2*MSU2 + MT2*(MSQ2 + MSU2 + MT2))
	MtLR = Af(3, 3) - dconjg(MUE)/TB
	MbLR = Af(4, 3) - dconjg(MUE)*TB
	mix = MtLR**2/M_S2

* The one-loop top/stop contributions:
	Lambda = 1/8D0 - SW2*(1/3D0 - 4/9D0*SW2)
	topstop = MT2/M_S2
	toplog = log(topstop)
	tmp = MZ2/MT2
	sig1 = GF*sqrt2/pi**2*MZ2**2*Lambda*CB2 * toplog
	sig12 = -GF*sqrt2/pi**2*MZ2/TB *
     &    (-3/8D0*MT2 + MZ2*Lambda*SB2) * toplog
	sig2 = GF*sqrt2/(8*pi**2)*MT2**2/SB2 *
     &    ( tmp*(-2 + 11/10D0*tmp)
     &       + (12 + SB2*tmp*(-6 + 8*Lambda*SB2*tmp)) * toplog
     &       + mix*(-12 + 4*tmp + 6*topstop
     &         + mix*(1 + topstop*(-4 + 3*topstop)
     &           + mix*topstop
     &             *(3/5D0 + topstop*(-12/5D0 + 2*topstop)
     &             + mix*topstop
     &               *(3/7D0 + topstop*(-12/7D0 + 3/2D0*topstop))
     &       ))) )

* The dominant two-loop top/stop contributions:
	toplog = log(MTr2/M_S2)
	tmp = (MSf2(2,3,3) - MSf2(1,3,3))/MTr2
     &    * (USf(1,1,3,3)*USf(2,1,3,3))**2
	tmplog = log(MSf2(2,3,3)/MSf2(1,3,3))
	Xt = tmp*(
     &    tmp*(2 - (MSf2(2,3,3) + MSf2(1,3,3))/
     &             (MSf2(2,3,3) - MSf2(1,3,3))*tmplog)
     &    + 2*tmplog)
	tmplog = log(MSf(2,3,3)*MSf(1,3,3)/MTr2)
	sig2 = sig2 + MTr2**2/SB2 * (
     &    + GF*sqrt2/pi**3*Alfas_MT*(toplog*(3*toplog - 6)
     &        - 6*sqrt(mix) + mix*(-3*toplog + 3/4D0*mix))
     &    - 9*GF**2/(16*pi**4)*MTr2* tmplog*(Xt + tmplog) )

* The one-loop leading-log contributions from all other sectors:
* [NB: MSQ is used here instead of MSusy.]
	Pb = Nc*(1 + 4*Qb*SW2*(1 + 2*Qb*SW2))
	Pf = Nc*(Ng - 1)*(2 - SW2*(4 - 8*(Qt**2 + Qb**2)*SW2))
     $    + Ng*(2 - SW2*(4 - 8*SW2))
	Pg = -44 + SW2*(106 - 62*SW2)
	Pg_ = 10 + SW2*(34 - 26*SW2)
	P1h = (1 - 2*SW2*CW2 - 9*C2B**2)*C2B**2
	P2h = -10 + 2*SW2*CW2
	P2h_ = 8 - SW2*(22 - 10*SW2)
	tmplog = log(MSQ2/MZ2)
	tmp = MB2/(MZ2*CB2)
	pref = GF*MZ2**2/(12*sqrt2*pi**2)
	pref2 = GF*Nc/(4*sqrt2*pi**2)*MB2/MSQ2
	sig1 = sig1
     &    - pref*CB2
     &      *(6*Nc*tmp*(2*tmp - 1) + Pb + Pf + Pg + P2h)*tmplog
     &    - pref2*Af(4, 3)
     &      *(4*MB2*MbLR/CB2*(1 - Af(4, 3)*MbLR/(12*MSQ2))
     &        - MZ2*(MbLR + Af(4, 3)/3D0))
	sig12 = sig12
     &    - pref*SB*CB*(3*Nc*tmp - Pb - Pf - Pg_ - P2h_)*tmplog
     &    + .5D0*pref2
     &      *(4*MB2*MUE*MbLR/CB2*(1 - Af(4, 3)*MbLR/(6*MSQ2))
     &        - MZ2*TB*(MbLR*(Af(4, 3) + MUE/TB)
     &                  + (MUE**2 + Af(4, 3)**2)/3D0))
	sig2 = sig2
     &    - pref*SB2*(Pb + Pf + Pg + P2h)*tmplog
     &    + pref2*MUE
     &      *(MB2*MUE*MbLR**2/(3*CB2*MSQ2)
     &        + MZ2*TB*(MbLR + MUE*TB/3D0))
	if(MA0 .gt. MZ) then
	  tmplog = log(MA02/MZ2)
	  sig1 = sig1 - pref*CB2*(P1h - P2h)*tmplog
	  sig12 = sig12 - pref*SB*CB*(P1h + P2h_)*tmplog
	  sig2 = sig2 - pref*SB2*(P1h - P2h)*tmplog
	endif

#endif COMPLEX_PARAMETERS

	tmp = (MA02 + MZ2 - sig2 - sig1)/2D0
	tmp2 = sqrt(((MA02 + MZ2)**2 + (sig1 - sig2)**2)/4D0
     &    + (.5D0*(MA02 - MZ2)*(sig1 - sig2) - MA02*MZ2*C2B)*C2B
     &    + sig12*((MA02 + MZ2)*S2B + sig12))

	Mh02 = tmp - tmp2
	if(Mh02 .lt. 0) then
	  print *, "mssm_ini: negative Mh0^2 detected."
	  return 1
	endif
	Mh0 = sqrt(Mh02)

#ifndef NO_EXCLUSION_LIMITS
	if(Mh0 .lt. Mh0_LOWERBOUND) then
	  print *, "mssm_ini: Mh0 = ", Mh0,
     +      " < Mh0_LOWERBOUND = ", Mh0_LOWERBOUND
	  return 1
	endif
#endif

	MHH2 = tmp + tmp2
	MHH = sqrt(MHH2)

	if(MA0 .le. 250 .and. MSQ .ge. 250) then
	  MHp2 = MA02 + MW2
     &      + Alfa*MW2/(12*pi*SW2)
     &        *(Nc*(Ng - 1) + Ng - 9 + 15*SW2/CW2)*log(MSQ2/MW2)
     &      + Nc*Alfa/(8*pi*SW2*MW2)
     &        *(2*MTr2*MB2/(SB2*CB2)
     &          - MW2*(MTr2/SB2 + MB2/CB2 - 2/3D0*MW2))
     &        *log(MSQ2/MTr2)
	else
	  MHp2 = MA02 + MW2
	endif
	MHp = sqrt(MHp2)
	end

      SUBROUTINE DCHHRE(MAXDIM,NDIM,NUMFUN,MDIV,A,B,MINPTS,MAXPTS,
     +                  EPSABS,EPSREL,KEY,NW,RESTAR,NUM,MAXSUB,MINSUB,
     +                  KEYF,IFAIL,WTLENG)
C***BEGIN PROLOGUE DCHHRE
C***PURPOSE  DCHHRE checks the validity of the
C            input parameters to DCUHRE.
C***DESCRIPTION
C            DCHHRE computes NUM, MAXSUB, MINSUB, KEYF, WTLENG and
C            IFAIL as functions of the input parameters to DCUHRE,
C            and checks the validity of the input parameters to DCUHRE.
C
C   ON ENTRY
C
C     MAXDIM Integer.
C            The maximum allowed number of dimensions.
C     NDIM   Integer.
C            Number of variables. 1 < NDIM <= MAXDIM.
C     NUMFUN Integer.
C            Number of components of the integral.
C     MDIV   Integer.
C            MDIV is the number of subregions that are divided in
C            each subdivision step in DADHRE.
C            MDIV is chosen default to 1.
C            For efficient execution on parallel computers
C            with NPROC processors MDIV should be set equal to
C            the smallest integer such that MOD(2*MDIV,NPROC) = 0.
C     A      Real array of dimension NDIM.
C            Lower limits of integration.
C     B      Real array of dimension NDIM.
C            Upper limits of integration.
C     MINPTS Integer.
C            Minimum number of function evaluations.
C     MAXPTS Integer.
C            Maximum number of function evaluations.
C            The number of function evaluations over each subregion
C            is NUM.
C            If (KEY = 0 or KEY = 1) and (NDIM = 2) Then
C              NUM = 65
C            Elseif (KEY = 0 or KEY = 2) and (NDIM = 3) Then
C              NUM = 127
C            Elseif (KEY = 0 and NDIM > 3) or (KEY = 3) Then
C              NUM = 1 + 4*2*NDIM + 2*NDIM*(NDIM-1) + 4*NDIM*(NDIM-1) +
C                    4*NDIM*(NDIM-1)*(NDIM-2)/3 + 2**NDIM
C            Elseif (KEY = 4) Then
C              NUM = 1 + 3*2*NDIM + 2*NDIM*(NDIM-1) + 2**NDIM
C            MAXPTS >= 3*NUM and MAXPTS >= MINPTS
C     EPSABS Real.
C            Requested absolute error.
C     EPSREL Real.
C            Requested relative error.
C     KEY    Integer.
C            Key to selected local integration rule.
C            KEY = 0 is the default value.
C                  For NDIM = 2 the degree 13 rule is selected.
C                  For NDIM = 3 the degree 11 rule is selected.
C                  For NDIM > 3 the degree  9 rule is selected.
C            KEY = 1 gives the user the 2 dimensional degree 13
C                  integration rule that uses 65 evaluation points.
C            KEY = 2 gives the user the 3 dimensional degree 11
C                  integration rule that uses 127 evaluation points.
C            KEY = 3 gives the user the degree 9 integration rule.
C            KEY = 4 gives the user the degree 7 integration rule.
C                  This is the recommended rule for problems that
C                  require great adaptivity.
C     NW     Integer.
C            Defines the length of the working array WORK.
C            Let MAXSUB denote the maximum allowed number of subregions
C            for the given values of MAXPTS, KEY and NDIM.
C            MAXSUB = (MAXPTS-NUM)/(2*NUM) + 1
C            NW should be greater or equal to
C            MAXSUB*(2*NDIM+2*NUMFUN+2) + 17*NUMFUN + 1
C            For efficient execution on parallel computers
C            NW should be chosen greater or equal to
C            MAXSUB*(2*NDIM+2*NUMFUN+2) + 17*NUMFUN*MDIV + 1
C            where MDIV is the number of subregions that are divided in
C            each subdivision step.
C            MDIV is default set internally in DCUHRE equal to 1.
C            For efficient execution on parallel computers
C            with NPROC processors MDIV should be set equal to
C            the smallest integer such that MOD(2*MDIV,NPROC) = 0.
C     RESTAR Integer.
C            If RESTAR = 0, this is the first attempt to compute
C            the integral.
C            If RESTAR = 1, then we restart a previous attempt.
C
C   ON RETURN
C
C     NUM    Integer.
C            The number of function evaluations over each subregion.
C     MAXSUB Integer.
C            The maximum allowed number of subregions for the
C            given values of MAXPTS, KEY and NDIM.
C     MINSUB Integer.
C            The minimum allowed number of subregions for the given
C            values of MINPTS, KEY and NDIM.
C     IFAIL  Integer.
C            IFAIL = 0 for normal exit.
C            IFAIL = 2 if KEY is less than 0 or KEY greater than 4.
C            IFAIL = 3 if NDIM is less than 2 or NDIM greater than
C                      MAXDIM.
C            IFAIL = 4 if KEY = 1 and NDIM not equal to 2.
C            IFAIL = 5 if KEY = 2 and NDIM not equal to 3.
C            IFAIL = 6 if NUMFUN less than 1.
C            IFAIL = 7 if volume of region of integration is zero.
C            IFAIL = 8 if MAXPTS is less than 3*NUM.
C            IFAIL = 9 if MAXPTS is less than MINPTS.
C            IFAIL = 10 if EPSABS < 0 and EPSREL < 0.
C            IFAIL = 11 if NW is too small.
C            IFAIL = 12 if unlegal RESTAR.
C     KEYF   Integer.
C            Key to selected integration rule.
C     WTLENG Integer.
C            The number of generators of the chosen integration rule.
C
C***ROUTINES CALLED-NONE
C***END PROLOGUE DCHHRE
C
C   Global variables.
C
      INTEGER NDIM,NUMFUN,MDIV,MINPTS,MAXPTS,KEY,NW,MINSUB,MAXSUB
      INTEGER RESTAR,NUM,KEYF,IFAIL,MAXDIM,WTLENG
      DOUBLE PRECISION A(NDIM),B(NDIM),EPSABS,EPSREL
C
C   Local variables.
C
      INTEGER LIMIT,J
C
C***FIRST EXECUTABLE STATEMENT DCHHRE
C
      IFAIL = 0
C
C   Check on legal KEY.
C
      IF (KEY.LT.0 .OR. KEY.GT.4) THEN
          IFAIL = 2
          GO TO 999
      END IF
C
C   Check on legal NDIM.
C
      IF (NDIM.LT.2 .OR. NDIM.GT.MAXDIM) THEN
          IFAIL = 3
          GO TO 999
      END IF
C
C   For KEY = 1, NDIM must be equal to 2.
C
      IF (KEY.EQ.1 .AND. NDIM.NE.2) THEN
          IFAIL = 4
          GO TO 999
      END IF
C
C   For KEY = 2, NDIM must be equal to 3.
C
      IF (KEY.EQ.2 .AND. NDIM.NE.3) THEN
          IFAIL = 5
          GO TO 999
      END IF
C
C   For KEY = 0, we point at the selected integration rule.
C
      IF (KEY.EQ.0) THEN
          IF (NDIM.EQ.2) THEN
              KEYF = 1
          ELSE IF (NDIM.EQ.3) THEN
              KEYF = 2
          ELSE
              KEYF = 3
          ENDIF
      ELSE
          KEYF = KEY
      ENDIF
C
C   Compute NUM and WTLENG as a function of KEYF and NDIM.
C
      IF (KEYF.EQ.1) THEN
          NUM = 65
          WTLENG = 14
      ELSE IF (KEYF.EQ.2) THEN
          NUM = 127
          WTLENG = 13
      ELSE IF (KEYF.EQ.3) THEN
          NUM = 1 + 4*2*NDIM + 2*NDIM* (NDIM-1) + 4*NDIM* (NDIM-1) +
     +          4*NDIM* (NDIM-1)* (NDIM-2)/3 + 2**NDIM
          WTLENG = 9
          IF (NDIM.EQ.2) WTLENG = 8
      ELSE IF (KEYF.EQ.4) THEN
          NUM = 1 + 3*2*NDIM + 2*NDIM* (NDIM-1) + 2**NDIM
          WTLENG = 6
      END IF
C
C   Compute MAXSUB.
C
      MAXSUB = (MAXPTS-NUM)/ (2*NUM) + 1
C
C   Compute MINSUB.
C
      MINSUB = (MINPTS-NUM)/ (2*NUM) + 1
      IF (MOD(MINPTS-NUM,2*NUM).NE.0) THEN
          MINSUB = MINSUB + 1
      END IF
      MINSUB = MAX(2,MINSUB)
C
C   Check on positive NUMFUN.
C
      IF (NUMFUN.LT.1) THEN
          IFAIL = 6
          GO TO 999
      END IF
C
C   Check on legal upper and lower limits of integration.
C
      DO 10 J = 1,NDIM
          IF (A(J)-B(J).EQ.0) THEN
              IFAIL = 7
              GO TO 999
          END IF
10    CONTINUE
C
C   Check on MAXPTS < 3*NUM.
C
      IF (MAXPTS.LT.3*NUM) THEN
          IFAIL = 8
          GO TO 999
      END IF
C
C   Check on MAXPTS >= MINPTS.
C
      IF (MAXPTS.LT.MINPTS) THEN
          IFAIL = 9
          GO TO 999
      END IF
C
C   Check on legal accuracy requests.
C
      IF (EPSABS.LT.0 .AND. EPSREL.LT.0) THEN
          IFAIL = 10
          GO TO 999
      END IF
C
C   Check on big enough double precision workspace.
C
      LIMIT = MAXSUB* (2*NDIM+2*NUMFUN+2) + 17*MDIV*NUMFUN + 1
      IF (NW.LT.LIMIT) THEN
          IFAIL = 11
          GO TO 999
      END IF
C
C    Check on legal RESTAR.
C
      IF (RESTAR.NE.0 .AND. RESTAR.NE.1) THEN
          IFAIL = 12
          GO TO 999
      END IF
999   RETURN
C
C***END DCHHRE
C
      END

	program test
	implicit none
	double precision res
	double precision integrand
	external integrand

	call gauss(res, integrand, 3, 3)
	print *, "integral = ", res
	end

************************************************************************

	double precision function integrand(X)
	implicit none
	double precision X(10)

	integrand = sin(X(1))*cos(X(2))*exp(X(3))
	end

************************************************************************

	include "ndimgauss_scalar.f"

* lumi_hadron.F
* parton luminosity for a hadron collider
* this file is part of FormCalc
* last modified 30 Nov 11 th

* This code links to the LHAPDF library.
* The following preprocessor variables are used:
*
* - PARTON1, PARTON2 are the PDG parton codes,
* - SCALE determines the factorization scale,
* - PDFSET specifies the file name of the PDF-set to be used.


#define PARTON_T -1
#define PARTON_X -2
#define MINVAR PARTON_X

#define HAVE_ALPHASPDF


************************************************************************

	subroutine LumiDefaults(argc, argv)
	implicit none
	integer argc
	character*128 argv(*)

#include "xsection.h"

	integer partonsign
	common /hadron/ partonsign

	if( Lower(SQRTS) .ne. Upper(SQRTS) )
     &    stop "Cannot handle a range of beam energies"

	if( Lower(SQRTS) .eq. 2000 ) then
	  partonsign = -1
	else if( Lower(SQRTS) .eq. 14000 ) then
	  partonsign = 1
	else
	  stop "Unknown collider"
	endif

	call InitPDFsetByName(PDFSET)
	call InitPDF(PDFMEM)
	end


************************************************************************

	subroutine LumiIni(fail)
	implicit none
	integer fail

#include "xsection.h"

	call SetEnergy(fail, Var(SQRTS))
	if( fail .ne. 0 ) return

	Lower(PARTON_T) = threshold/sqrtS
	Upper(PARTON_T) = 1
	Step(PARTON_T) = 0

	Lower(PARTON_X) = 0
	Upper(PARTON_X) = 1
	Step(PARTON_X) = 0
	end


************************************************************************

	subroutine Luminosity(fac)
	implicit none
	RealType fac

#include "xsection.h"

	RealType xPDF(-6:6), tPDF(-6:6)
	RealType tau, x, xrange
	integer fail

	integer partonsign
	common /hadron/ partonsign

	call SetEnergy(fail, Var(PARTON_T)*Var(SQRTS))
	if( fail .ne. 0 ) then
	  fac = 0
	  return
	endif

	tau = Var(PARTON_T)**2
	xrange = 1 - tau
	x = tau + xrange*Var(PARTON_X)

	if( x .lt. 1D-10 .or. x .gt. (1 - 1D-10) ) then
	  fac = 0
	  return
	endif

	call evolvePDF(x, scale, xPDF)
	call evolvePDF(tau/x, scale, tPDF)

	fac = fac*xrange/(Var(PARTON_T)*x)*
     &    ( tPDF(partonsign*PARTON1)*xPDF(PARTON2) +
     &      xPDF(partonsign*PARTON2)*tPDF(PARTON1) )
#if PARTON1 != PARTON2
     &    * 2
#endif
	end

* CTAcut.F
* the FormCalc wrapper for the CutTools one-point function
* this file is part of FormCalc
* last modified 3 Aug 11 th


	double complex function CTAcut(rank, num, numeps, m)
	implicit none
	integer rank
	external num, numeps
	double precision m

	double precision pj(0:3,1)
	logical stable, forcemp
	double complex res(0:2), res1
	external CTmpnum

	double precision rootsvalue, muscale
	common /cuttools_para/ rootsvalue, muscale

	pj(0,1) = 0
	pj(1,1) = 0
	pj(2,1) = 0
	pj(3,1) = 0

	PRINT *, "CTAcut:", rank
	PRINT *, "m1=", m

	call ctsxcut(rootsvalue, muscale, 1, num, CTmpnum,
     &    rank, pj, m, res, res1, stable, forcemp)
	CTAcut = res(0)
	PRINT *, "CTAcut=", CTAcut
	end

      SUBROUTINE DTRHRE(DVFLAG,NDIM,NUMFUN,SBRGNS,VALUES,ERRORS,CENTRS,
     +                  HWIDTS,GREATE,ERROR,VALUE,CENTER,HWIDTH,DIR)
C***BEGIN PROLOGUE DTRHRE
C***PURPOSE DTRHRE maintains a heap of subregions.
C***DESCRIPTION DTRHRE maintains a heap of subregions.
C            The subregions are ordered according to the size
C            of the greatest error estimates of each subregion(GREATE).
C
C   PARAMETERS
C
C     DVFLAG Integer.
C            If DVFLAG = 1, we remove the subregion with
C            greatest error from the heap.
C            If DVFLAG = 2, we insert a new subregion in the heap.
C     NDIM   Integer.
C            Number of variables.
C     NUMFUN Integer.
C            Number of components of the integral.
C     SBRGNS Integer.
C            Number of subregions in the heap.
C     VALUES Real array of dimension (NUMFUN,SBRGNS).
C            Used to store estimated values of the integrals
C            over the subregions.
C     ERRORS Real array of dimension (NUMFUN,SBRGNS).
C            Used to store the corresponding estimated errors.
C     CENTRS Real array of dimension (NDIM,SBRGNS).
C            Used to store the center limits of the stored subregions.
C     HWIDTS Real array of dimension (NDIM,SBRGNS).
C            Used to store the hwidth limits of the stored subregions.
C     GREATE Real array of dimension SBRGNS.
C            Used to store the greatest estimated errors in
C            all subregions.
C     ERROR  Real array of dimension NUMFUN.
C            Used as intermediate storage for the error of a subregion.
C     VALUE  Real array of dimension NUMFUN.
C            Used as intermediate storage for the estimate
C            of the integral over a subregion.
C     CENTER Real array of dimension NDIM.
C            Used as intermediate storage for the center of
C            the subregion.
C     HWIDTH Real array of dimension NDIM.
C            Used as intermediate storage for the half width of
C            the subregion.
C     DIR    Integer array of dimension SBRGNS.
C            DIR is used to store the directions for
C            further subdivision.
C
C***ROUTINES CALLED-NONE
C***END PROLOGUE DTRHRE
C
C   Global variables.
C
      INTEGER DVFLAG,NDIM,NUMFUN,SBRGNS
      DOUBLE PRECISION VALUES(NUMFUN,*),ERRORS(NUMFUN,*)
      DOUBLE PRECISION CENTRS(NDIM,*)
      DOUBLE PRECISION HWIDTS(NDIM,*)
      DOUBLE PRECISION GREATE(*)
      DOUBLE PRECISION ERROR(NUMFUN),VALUE(NUMFUN)
      DOUBLE PRECISION CENTER(NDIM),HWIDTH(NDIM)
      DOUBLE PRECISION DIR(*)
C
C   Local variables.
C
C   GREAT  is used as intermediate storage for the greatest error of a
C          subregion.
C   DIRECT is used as intermediate storage for the direction of further
C          subdivision.
C   SUBRGN Position of child/parent subregion in the heap.
C   SUBTMP Position of parent/child subregion in the heap.
C
      INTEGER J,SUBRGN,SUBTMP
      DOUBLE PRECISION GREAT,DIRECT
C
C***FIRST EXECUTABLE STATEMENT DTRHRE
C
C   Save values to be stored in their correct place in the heap.
C
      GREAT = GREATE(SBRGNS)
      DIRECT = DIR(SBRGNS)
      DO 5 J = 1,NUMFUN
          ERROR(J) = ERRORS(J,SBRGNS)
          VALUE(J) = VALUES(J,SBRGNS)
5     CONTINUE
      DO 10 J = 1,NDIM
          CENTER(J) = CENTRS(J,SBRGNS)
          HWIDTH(J) = HWIDTS(J,SBRGNS)
10    CONTINUE
C
C    If DVFLAG = 1, we will remove the region
C    with greatest estimated error from the heap.
C
      IF (DVFLAG.EQ.1) THEN
          SBRGNS = SBRGNS - 1
          SUBRGN = 1
20        SUBTMP = 2*SUBRGN
          IF (SUBTMP.LE.SBRGNS) THEN
              IF (SUBTMP.NE.SBRGNS) THEN
C
C   Find max. of left and right child.
C
                  IF (GREATE(SUBTMP).LT.GREATE(SUBTMP+1)) THEN
                      SUBTMP = SUBTMP + 1
                  END IF
              END IF
C
C   Compare max.child with parent.
C   If parent is max., then done.
C
              IF (GREAT.LT.GREATE(SUBTMP)) THEN
C
C   Move the values at position subtmp up the heap.
C
                  GREATE(SUBRGN) = GREATE(SUBTMP)
                  DO 25 J = 1,NUMFUN
                      ERRORS(J,SUBRGN) = ERRORS(J,SUBTMP)
                      VALUES(J,SUBRGN) = VALUES(J,SUBTMP)
25                CONTINUE
                  DIR(SUBRGN) = DIR(SUBTMP)
                  DO 30 J = 1,NDIM
                      CENTRS(J,SUBRGN) = CENTRS(J,SUBTMP)
                      HWIDTS(J,SUBRGN) = HWIDTS(J,SUBTMP)
30                CONTINUE
                  SUBRGN = SUBTMP
                  GO TO 20
              END IF
          END IF
      ELSE IF (DVFLAG.EQ.2) THEN
C
C   If DVFLAG = 2, then insert new region in the heap.
C
          SUBRGN = SBRGNS
40        SUBTMP = SUBRGN/2
          IF (SUBTMP.GE.1) THEN
C
C   Compare max.child with parent.
C   If parent is max, then done.
C
              IF (GREAT.GT.GREATE(SUBTMP)) THEN
C
C   Move the values at position subtmp down the heap.
C
                  GREATE(SUBRGN) = GREATE(SUBTMP)
                  DO 45 J = 1,NUMFUN
                      ERRORS(J,SUBRGN) = ERRORS(J,SUBTMP)
                      VALUES(J,SUBRGN) = VALUES(J,SUBTMP)
45                CONTINUE
                  DIR(SUBRGN) = DIR(SUBTMP)
                  DO 50 J = 1,NDIM
                      CENTRS(J,SUBRGN) = CENTRS(J,SUBTMP)
                      HWIDTS(J,SUBRGN) = HWIDTS(J,SUBTMP)
50                CONTINUE
                  SUBRGN = SUBTMP
                  GO TO 40
              END IF
          END IF
      END IF
C
C    Insert the saved values in their correct places.
C
      IF (SBRGNS.GT.0) THEN
          GREATE(SUBRGN) = GREAT
          DO 55 J = 1,NUMFUN
              ERRORS(J,SUBRGN) = ERROR(J)
              VALUES(J,SUBRGN) = VALUE(J)
55        CONTINUE
          DIR(SUBRGN) = DIRECT
          DO 60 J = 1,NDIM
              CENTRS(J,SUBRGN) = CENTER(J)
              HWIDTS(J,SUBRGN) = HWIDTH(J)
60        CONTINUE
      END IF
C
C***END DTRHRE
C
      RETURN
      END

      SUBROUTINE DFSHRE(NDIM,CENTER,HWIDTH,X,G,NUMFUN,FUNSUB,FULSMS,
     +                  FUNVLS)
C***BEGIN PROLOGUE DFSHRE
C***KEYWORDS fully symmetric sum
C***PURPOSE  To compute fully symmetric basic rule sums
C***AUTHOR   Alan Genz, Computer Science Department, Washington
C            State University, Pullman, WA 99163-1210 USA
C***LAST MODIFICATION 88-04-08
C***DESCRIPTION DFSHRE computes a fully symmetric sum for a vector
C            of integrand values over a hyper-rectangular region.
C            The sum is fully symmetric with respect to the center of
C            the region and is taken over all sign changes and
C            permutations of the generators for the sum.
C
C   ON ENTRY
C
C   NDIM   Integer.
C          Number of variables.
C   CENTER Real array of dimension NDIM.
C          The coordinates for the center of the region.
C   HWIDTH Real Array of dimension NDIM.
C          HWIDTH(I) is half of the width of dimension I of the region.
C   X      Real Array of dimension NDIM.
C          A work array.
C   G      Real Array of dimension NDIM.
C          The generators for the fully symmetric sum. These MUST BE
C          non-negative and non-increasing.
C   NUMFUN Integer.
C          Number of components for the vector integrand.
C   FUNSUB Externally declared subroutine.
C          For computing the components of the integrand at a point X.
C          It must have parameters (NDIM, X, NUMFUN, FUNVLS).
C           Input Parameters:
C            X      Real array of dimension NDIM.
C                   Defines the evaluation point.
C            NDIM   Integer.
C                   Number of variables for the integrand.
C            NUMFUN Integer.
C                   Number of components for the vector integrand.
C           Output Parameters:
C            FUNVLS Real array of dimension NUMFUN.
C                   The components of the integrand at the point X.
C   ON RETURN
C
C   FULSMS Real array of dimension NUMFUN.
C          The values for the fully symmetric sums for each component
C          of the integrand.
C   FUNVLS Real array of dimension NUMFUN.
C          A work array.
C
C***ROUTINES CALLED: FUNSUB
C
C***END PROLOGUE DFSHRE
C
C   Global variables.
C
      EXTERNAL FUNSUB
      INTEGER NDIM,NUMFUN
      DOUBLE PRECISION CENTER(NDIM),HWIDTH(NDIM),X(NDIM),G(NDIM),
     +                 FULSMS(NUMFUN),FUNVLS(NUMFUN)
C
C   Local variables.
C
      INTEGER IXCHNG,LXCHNG,I,J,L
      DOUBLE PRECISION GL,GI
C
C***FIRST EXECUTABLE STATEMENT DFSHRE
C
      DO 10 J = 1,NUMFUN
          FULSMS(J) = 0
10    CONTINUE
C
C     Compute centrally symmetric sum for permutation of G
C
20    DO 30 I = 1,NDIM
          X(I) = CENTER(I) + G(I)*HWIDTH(I)
30    CONTINUE
40    CALL FUNSUB(NDIM,X,NUMFUN,FUNVLS)
      DO 50 J = 1,NUMFUN
          FULSMS(J) = FULSMS(J) + FUNVLS(J)
50    CONTINUE
      DO 60 I = 1,NDIM
          G(I) = - G(I)
          X(I) = CENTER(I) + G(I)*HWIDTH(I)
          IF (G(I).LT.0) GO TO 40
60    CONTINUE
C
C       Find next distinct permutation of G and loop back for next sum.
C       Permutations are generated in reverse lexicographic order.
C
      DO 80 I = 2,NDIM
          IF (G(I-1).GT.G(I)) THEN
              GI = G(I)
              IXCHNG = I - 1
              DO 70 L = 1, (I-1)/2
                  GL = G(L)
                  G(L) = G(I-L)
                  G(I-L) = GL
                  IF (GL.LE.GI) IXCHNG = IXCHNG - 1
                  IF (G(L).GT.GI) LXCHNG = L
70            CONTINUE
              IF (G(IXCHNG).LE.GI) IXCHNG = LXCHNG
              G(I) = G(IXCHNG)
              G(IXCHNG) = GI
              GO TO 20
          END IF
80    CONTINUE
C
C     Restore original order to generators
C
      DO 90 I = 1,NDIM/2
          GI = G(I)
          G(I) = G(NDIM-I+1)
          G(NDIM-I+1) = GI
90    CONTINUE
C
C***END DFSHRE
C
      END

* Fcut.F
* the FormCalc wrapper for the CutTools six-point function
* this file is part of FormCalc
* last modified 21 Oct 09 th


	double complex function Fcut(rank, num,
     &    p1, p2, p3, p4, p5, m1, m2, m3, m4, m5, m6)
	implicit none
	integer rank
	external num
	integer*8 p1, p2, p3, p4, p5
	double precision m1, m2, m3, m4, m5, m6

	double precision pi(0:3,0:5), mi(6)
	external mpnum

	pi(0,0) = 0
	pi(1,0) = 0
	pi(2,0) = 0
	pi(3,0) = 0
	call MomDecode(p1, pi(0,1))
	call MomDecode(p2, pi(0,2))
	call MomDecode(p3, pi(0,3))
	call MomDecode(p4, pi(0,4))
	call MomDecode(p5, pi(0,5))

	mi(1) = m1
	mi(2) = m2
	mi(3) = m3
	mi(4) = m4
	mi(5) = m5
	mi(6) = m6

c	call ctsxcut(6, num, mpnum, rank, pi, mi, Fcut)
	call ctsxcut(6, num, mpnum, 6, pi, mi, Fcut)
	end

* IndexEps.F
* this file is part of FormCalc
* last modified 26 Jan 07 th


	integer function IndexEps(i, j, k)
	implicit none
	integer i, j, k

#define signbit(i) ibits(i,31,1)

	integer cmp, x
	cmp(x) = 2*signbit(x) - signbit(ior(x, -x))

	IndexEps = cmp(j - i)*cmp(j - k)*cmp(k - i)
	end

* CTDcut.F
* the FormCalc wrapper for the CutTools four-point function
* this file is part of FormCalc
* last modified 3 Aug 11 th


	double complex function CTDcut(rank, num, numeps,
     &    p1, p2, p3, m1, m2, m3, m4)
	implicit none
	integer rank
	external num, numeps
	integer*8 p1, p2, p3
	double precision m1, m2, m3, m4

	double precision pj(0:3,4), mj(4)
	logical stable, forcemp
	double complex res(0:2), res1
	external CTmpnum

	double precision rootsvalue, muscale
	common /cuttools_para/ rootsvalue, muscale

	pj(0,1) = 0
	pj(1,1) = 0
	pj(2,1) = 0
	pj(3,1) = 0
	call CTMomDecode(p1, pj(0,2))
	call CTMomDecode(p2, pj(0,3))
	call CTMomDecode(p3, pj(0,4))

	mj(1) = m1
	mj(2) = m2
	mj(3) = m3
	mj(4) = m4

	PRINT *, "CTDcut:", rank
	PRINT *, "p1=", pj(0,2)
	PRINT *, "   ", pj(1,2)
	PRINT *, "   ", pj(2,2)
	PRINT *, "   ", pj(3,2)
	PRINT *, "p2=", pj(0,3)
	PRINT *, "   ", pj(1,3)
	PRINT *, "   ", pj(2,3)
	PRINT *, "   ", pj(3,3)
	PRINT *, "p3=", pj(0,4)
	PRINT *, "   ", pj(1,4)
	PRINT *, "   ", pj(2,4)
	PRINT *, "   ", pj(3,4)
	PRINT *, "m1=", m1
	PRINT *, "m2=", m2
	PRINT *, "m3=", m3
	PRINT *, "m4=", m4

	call ctsxcut(rootsvalue, muscale, 4, num, CTmpnum,
     &    rank, pj, mj, res, res1, stable, forcemp)
	CTDcut = res(0)
	PRINT *, "CTDcut=", CTDcut
	end

* Error.F
* print the error messages and return the error code
* this file is part of FormCalc
* last modified 29 Oct 08 th


	subroutine m_(error, lineno, file, msg)
	implicit none
	integer error, lineno
	character*(*) file, msg

	if( lineno .gt. 0 ) error = lineno

101	format(3A)
	if( lineno .gt. 0 ) then
	  print 101, file, " error: ", msg
	else if( lineno .eq. 0 ) then
	  print 101, file, " warning: ", msg
	else
	  print 101, file, ": ", msg
	endif
	end

* softphoton.F
* routines for the treatment of soft-photon radiation
* this file is part of FormCalc
* last modified 30 Nov 11 th


************************************************************************
** SoftPhotonFactor adds up the contributions from soft-photon emission
** off the different legs.  The result then has to be multiplied with
** the Born cross-section.

	RealType function SoftPhotonFactor()
	implicit none

#include "xsection.h"

	RealType PhaseSpaceIntegral
	external PhaseSpaceIntegral

	integer i, j

	RealType loglambda
	common /infrared/ loglambda

	RealType charge(LEGS), r

* not a very nice solution, the following, but necessary
* because there may be no "/" in a constant in the data
* statement (such as in 2/3D0)
#if LEGS == 3
	RealType ch1, ch2, ch3
	parameter (ch1 = CHARGE1)
	parameter (ch2 = CHARGE2)
	parameter (ch3 = CHARGE3)
	data charge / ch1, ch2, ch3 /
#elif LEGS == 4
	RealType ch1, ch2, ch3, ch4
	parameter (ch1 = CHARGE1)
	parameter (ch2 = CHARGE2)
	parameter (ch3 = CHARGE3)
	parameter (ch4 = CHARGE4)
	data charge / ch1, ch2, ch3, ch4 /
#elif LEGS == 5
	RealType ch1, ch2, ch3, ch4, ch5
	parameter (ch1 = CHARGE1)
	parameter (ch2 = CHARGE2)
	parameter (ch3 = CHARGE3)
	parameter (ch4 = CHARGE4)
	parameter (ch5 = CHARGE5)
	data charge / ch1, ch2, ch3, ch4, ch5 /
#else
#error No definition for LEGS external legs
#endif

	loglambda = log(4*(ESOFTMAX)**2/getlambda())

	SoftPhotonFactor = 0
	do i = 1, LEGS
	  do j = i, LEGS
	    r = charge(i)*charge(j)
	    if( r .ne. 0 ) SoftPhotonFactor = SoftPhotonFactor +
     &        sign(1, LEGS_IN - i)*sign(1, LEGS_IN - j)*
     &        r*PhaseSpaceIntegral(i, j)
	  enddo
	enddo
	SoftPhotonFactor = -4*pi*Alfa/(2*pi)**3*SoftPhotonFactor
	end


************************************************************************
** PhaseSpaceIntegral calculates the integral over the soft photon's
** phase space.  See A. Denner, Fortschr. d. Physik, 41 (1993) 4.

	RealType function PhaseSpaceIntegral(i, j)
	implicit none
	integer i, j

#include "xsection.h"

	RealType mi, ki0, ki, kidelta, kilog
	RealType mj, kj0, kj, kjdelta, kjlog
	RealType kikj, alpha, d, vi

	RealType loglambda
	common /infrared/ loglambda

	mi = momspec(SPEC_M, i)
	ki0 = momspec(SPEC_E, i)
	ki = momspec(SPEC_K, i)
	kidelta = momspec(SPEC_DELTAK, i)
	kilog = log(kidelta/(ki0 + ki))

	if( i .eq. j ) then
	  if( ki .lt. 1D-14 ) then
	    PhaseSpaceIntegral = pi*(loglambda - 2)
	  else
	    PhaseSpaceIntegral = pi*(loglambda + ki0/ki*kilog)
	  endif
	  return
	endif

	mj = momspec(SPEC_M, j)
	kj0 = momspec(SPEC_E, j)
	kj = momspec(SPEC_K, j)
	kjdelta = momspec(SPEC_DELTAK, j)
	kjlog = log(kjdelta/(kj0 + kj))

	kikj = Re(Pair(k(i), k(j)))

	d = sqrt((kikj - mi*mj)*(kikj + mi*mj))
	alpha = (kikj + d)/mi**2
	if( alpha*ki0 .lt. kj0 ) alpha = (kikj - d)/mi**2

	d = 1/((alpha*mi - mj)*(alpha*mi + mj))
	vi = 2*(alpha*ki0 - kj0)*d

	PhaseSpaceIntegral = 4*pi*alpha*kikj*d * Re(
     &    log(mi/mj*abs(alpha))*loglambda +
     &    .25D0*(kilog - kjlog)*(kilog + kjlog) +
     &    Li2omx((ki0 + ki)*alpha*vi) + Li2omx(kidelta*alpha*vi) -
     &    Li2omx((kj0 + kj)*vi) - Li2omx(kjdelta*vi) )
	end

      SUBROUTINE D09HRE(NDIM,WTLENG,W,G,ERRCOF,RULPTS)
C***BEGIN PROLOGUE D09HRE
C***KEYWORDS basic integration rule, degree 9
C***PURPOSE  To initialize a degree 9 basic rule and null rules.
C***AUTHOR   Alan Genz, Computer Science Department, Washington
C            State University, Pullman, WA 99163-1210 USA
C***LAST MODIFICATION 88-05-20
C***DESCRIPTION  D09HRE initializes a degree 9 integration rule,
C            two degree 7 null rules, one degree 5 null rule and one
C            degree 3 null rule for the hypercube [-1,1]**NDIM.
C
C   ON ENTRY
C
C   NDIM   Integer.
C          Number of variables.
C   WTLENG Integer.
C          The number of weights in each of the rules.
C
C   ON RETURN
C   W      Real array of dimension (5,WTLENG).
C          The weights for the basic and null rules.
C          W(1,1),...,W(1,WTLENG) are weights for the basic rule.
C          W(I,1),...,W(I,WTLENG), for I > 1 are null rule weights.
C   G      Real array of dimension (NDIM, WTLENG).
C          The fully symmetric sum generators for the rules.
C          G(1, J), ..., G(NDIM, J) are the are the generators for the
C          points associated with the Jth weights.
C   ERRCOF Real array of dimension 6.
C          Heuristic error coefficients that are used in the
C          error estimation in BASRUL.
C   RULPTS Real array of dimension WTLENG.
C          A work array.
C
C***REFERENCES A. Genz and A. Malik,
C             "An Imbedded Family of Fully Symmetric Numerical
C              Integration Rules",
C              SIAM J Numer. Anal. 20 (1983), pp. 580-588.
C***ROUTINES CALLED-NONE
C***END PROLOGUE D09HRE
C
C   Global variables
C
      INTEGER NDIM,WTLENG
      DOUBLE PRECISION W(5,WTLENG),G(NDIM,WTLENG),ERRCOF(6)
      DOUBLE PRECISION RULPTS(WTLENG)
C
C   Local Variables
C
      DOUBLE PRECISION RATIO,LAM0,LAM1,LAM2,LAM3,LAMP,TWONDM
      INTEGER I,J
C
C***FIRST EXECUTABLE STATEMENT D09HRE
C
C
C     Initialize generators, weights and RULPTS
C
      DO 30 J = 1,WTLENG
          DO 10 I = 1,NDIM
              G(I,J) = 0
10        CONTINUE
          DO 20 I = 1,5
              W(I,J) = 0
20        CONTINUE
          RULPTS(J) = 2*NDIM
30    CONTINUE
      TWONDM = 2**NDIM
      RULPTS(WTLENG) = TWONDM
      IF (NDIM.GT.2) RULPTS(8) = (4*NDIM* (NDIM-1)* (NDIM-2))/3
      RULPTS(7) = 4*NDIM* (NDIM-1)
      RULPTS(6) = 2*NDIM* (NDIM-1)
      RULPTS(1) = 1
C
C     Compute squared generator parameters
C
      LAM0 = 0.4707
      LAM1 = 4/ (15-5/LAM0)
      RATIO = (1-LAM1/LAM0)/27
      LAM2 = (5-7*LAM1-35*RATIO)/ (7-35*LAM1/3-35*RATIO/LAM0)
      RATIO = RATIO* (1-LAM2/LAM0)/3
      LAM3 = (7-9* (LAM2+LAM1)+63*LAM2*LAM1/5-63*RATIO)/
     +       (9-63* (LAM2+LAM1)/5+21*LAM2*LAM1-63*RATIO/LAM0)
      LAMP = 0.0625
C
C     Compute degree 9 rule weights
C
      W(1,WTLENG) = 1/ (3*LAM0)**4/TWONDM
      IF (NDIM.GT.2) W(1,8) = (1-1/ (3*LAM0))/ (6*LAM1)**3
      W(1,7) = (1-7* (LAM0+LAM1)/5+7*LAM0*LAM1/3)/
     +         (84*LAM1*LAM2* (LAM2-LAM0)* (LAM2-LAM1))
      W(1,6) = (1-7* (LAM0+LAM2)/5+7*LAM0*LAM2/3)/
     +         (84*LAM1*LAM1* (LAM1-LAM0)* (LAM1-LAM2)) -
     +         W(1,7)*LAM2/LAM1 - 2* (NDIM-2)*W(1,8)
      W(1,4) = (1-9* ((LAM0+LAM1+LAM2)/7- (LAM0*LAM1+LAM0*LAM2+
     +         LAM1*LAM2)/5)-3*LAM0*LAM1*LAM2)/
     +         (18*LAM3* (LAM3-LAM0)* (LAM3-LAM1)* (LAM3-LAM2))
      W(1,3) = (1-9* ((LAM0+LAM1+LAM3)/7- (LAM0*LAM1+LAM0*LAM3+
     +         LAM1*LAM3)/5)-3*LAM0*LAM1*LAM3)/
     +         (18*LAM2* (LAM2-LAM0)* (LAM2-LAM1)* (LAM2-LAM3)) -
     +         2* (NDIM-1)*W(1,7)
      W(1,2) = (1-9* ((LAM0+LAM2+LAM3)/7- (LAM0*LAM2+LAM0*LAM3+
     +         LAM2*LAM3)/5)-3*LAM0*LAM2*LAM3)/
     +         (18*LAM1* (LAM1-LAM0)* (LAM1-LAM2)* (LAM1-LAM3)) -
     +         2* (NDIM-1)* (W(1,7)+W(1,6)+ (NDIM-2)*W(1,8))
C
C     Compute weights for 2 degree 7, 1 degree 5 and 1 degree 3 rules
C
      W(2,WTLENG) = 1/ (108*LAM0**4)/TWONDM
      IF (NDIM.GT.2) W(2,8) = (1-27*TWONDM*W(2,9)*LAM0**3)/ (6*LAM1)**3
      W(2,7) = (1-5*LAM1/3-15*TWONDM*W(2,WTLENG)*LAM0**2* (LAM0-LAM1))/
     +          (60*LAM1*LAM2* (LAM2-LAM1))
      W(2,6) = (1-9* (8*LAM1*LAM2*W(2,7)+TWONDM*W(2,WTLENG)*LAM0**2))/
     +         (36*LAM1*LAM1) - 2*W(2,8)* (NDIM-2)
      W(2,4) = (1-7* ((LAM1+LAM2)/5-LAM1*LAM2/3+TWONDM*W(2,
     +         WTLENG)*LAM0* (LAM0-LAM1)* (LAM0-LAM2)))/
     +         (14*LAM3* (LAM3-LAM1)* (LAM3-LAM2))
      W(2,3) = (1-7* ((LAM1+LAM3)/5-LAM1*LAM3/3+TWONDM*W(2,
     +         WTLENG)*LAM0* (LAM0-LAM1)* (LAM0-LAM3)))/
     +         (14*LAM2* (LAM2-LAM1)* (LAM2-LAM3)) - 2* (NDIM-1)*W(2,7)
      W(2,2) = (1-7* ((LAM2+LAM3)/5-LAM2*LAM3/3+TWONDM*W(2,
     +         WTLENG)*LAM0* (LAM0-LAM2)* (LAM0-LAM3)))/
     +         (14*LAM1* (LAM1-LAM2)* (LAM1-LAM3)) -
     +         2* (NDIM-1)* (W(2,7)+W(2,6)+ (NDIM-2)*W(2,8))
      W(3,WTLENG) = 5/ (324*LAM0**4)/TWONDM
      IF (NDIM.GT.2) W(3,8) = (1-27*TWONDM*W(3,9)*LAM0**3)/ (6*LAM1)**3
      W(3,7) = (1-5*LAM1/3-15*TWONDM*W(3,WTLENG)*LAM0**2* (LAM0-LAM1))/
     +          (60*LAM1*LAM2* (LAM2-LAM1))
      W(3,6) = (1-9* (8*LAM1*LAM2*W(3,7)+TWONDM*W(3,WTLENG)*LAM0**2))/
     +         (36*LAM1*LAM1) - 2*W(3,8)* (NDIM-2)
      W(3,5) = (1-7* ((LAM1+LAM2)/5-LAM1*LAM2/3+TWONDM*W(3,
     +         WTLENG)*LAM0* (LAM0-LAM1)* (LAM0-LAM2)))/
     +         (14*LAMP* (LAMP-LAM1)* (LAMP-LAM2))
      W(3,3) = (1-7* ((LAM1+LAMP)/5-LAM1*LAMP/3+TWONDM*W(3,
     +         WTLENG)*LAM0* (LAM0-LAM1)* (LAM0-LAMP)))/
     +         (14*LAM2* (LAM2-LAM1)* (LAM2-LAMP)) - 2* (NDIM-1)*W(3,7)
      W(3,2) = (1-7* ((LAM2+LAMP)/5-LAM2*LAMP/3+TWONDM*W(3,
     +         WTLENG)*LAM0* (LAM0-LAM2)* (LAM0-LAMP)))/
     +         (14*LAM1* (LAM1-LAM2)* (LAM1-LAMP)) -
     +         2* (NDIM-1)* (W(3,7)+W(3,6)+ (NDIM-2)*W(3,8))
      W(4,WTLENG) = 2/ (81*LAM0**4)/TWONDM
      IF (NDIM.GT.2) W(4,8) = (2-27*TWONDM*W(4,9)*LAM0**3)/ (6*LAM1)**3
      W(4,7) = (2-15*LAM1/9-15*TWONDM*W(4,WTLENG)*LAM0* (LAM0-LAM1))/
     +         (60*LAM1*LAM2* (LAM2-LAM1))
      W(4,6) = (1-9* (8*LAM1*LAM2*W(4,7)+TWONDM*W(4,WTLENG)*LAM0**2))/
     +         (36*LAM1*LAM1) - 2*W(4,8)* (NDIM-2)
      W(4,4) = (2-7* ((LAM1+LAM2)/5-LAM1*LAM2/3+TWONDM*W(4,
     +         WTLENG)*LAM0* (LAM0-LAM1)* (LAM0-LAM2)))/
     +         (14*LAM3* (LAM3-LAM1)* (LAM3-LAM2))
      W(4,3) = (2-7* ((LAM1+LAM3)/5-LAM1*LAM3/3+TWONDM*W(4,
     +         WTLENG)*LAM0* (LAM0-LAM1)* (LAM0-LAM3)))/
     +         (14*LAM2* (LAM2-LAM1)* (LAM2-LAM3)) - 2* (NDIM-1)*W(4,7)
      W(4,2) = (2-7* ((LAM2+LAM3)/5-LAM2*LAM3/3+TWONDM*W(4,
     +         WTLENG)*LAM0* (LAM0-LAM2)* (LAM0-LAM3)))/
     +         (14*LAM1* (LAM1-LAM2)* (LAM1-LAM3)) -
     +         2* (NDIM-1)* (W(4,7)+W(4,6)+ (NDIM-2)*W(4,8))
      W(5,2) = 1/ (6*LAM1)
C
C     Set generator values
C
      LAM0 = SQRT(LAM0)
      LAM1 = SQRT(LAM1)
      LAM2 = SQRT(LAM2)
      LAM3 = SQRT(LAM3)
      LAMP = SQRT(LAMP)
      DO 40 I = 1,NDIM
          G(I,WTLENG) = LAM0
40    CONTINUE
      IF (NDIM.GT.2) THEN
          G(1,8) = LAM1
          G(2,8) = LAM1
          G(3,8) = LAM1
      END IF
      G(1,7) = LAM1
      G(2,7) = LAM2
      G(1,6) = LAM1
      G(2,6) = LAM1
      G(1,5) = LAMP
      G(1,4) = LAM3
      G(1,3) = LAM2
      G(1,2) = LAM1
C
C     Compute final weight values.
C     The null rule weights are computed from differences between
C     the degree 9 rule weights and lower degree rule weights.
C
      W(1,1) = TWONDM
      DO 70 J = 2,5
          DO 50 I = 2,WTLENG
              W(J,I) = W(J,I) - W(1,I)
              W(J,1) = W(J,1) - RULPTS(I)*W(J,I)
50        CONTINUE
70    CONTINUE
      DO 80 I = 2,WTLENG
          W(1,I) = TWONDM*W(1,I)
          W(1,1) = W(1,1) - RULPTS(I)*W(1,I)
80    CONTINUE
C
C     Set error coefficients
C
      ERRCOF(1) = 5
      ERRCOF(2) = 5
      ERRCOF(3) = 1.
      ERRCOF(4) = 5
      ERRCOF(5) = 0.5
      ERRCOF(6) = 0.25
C
C***END D09HRE
C
      END

      SUBROUTINE DINHRE(NDIM,KEY,WTLENG,W,G,ERRCOF,RULPTS,SCALES,NORMS)
C***BEGIN PROLOGUE DINHRE
C***PURPOSE DINHRE computes abscissas and weights of the integration
C            rule and the null rules to be used in error estimation.
C            These are computed as functions of NDIM and KEY.
C***DESCRIPTION DINHRE will for given values of NDIM and KEY compute or
C            select the correct values of the abscissas and
C            corresponding weights for different
C            integration rules and null rules and assign them to
C            G and W.
C            The heuristic error coefficients ERRCOF
C            will be computed as a function of KEY.
C            Scaling factors SCALES and normalization factors NORMS
C            used in the error estimation are computed.
C
C
C   ON ENTRY
C
C     NDIM   Integer.
C            Number of variables.
C     KEY    Integer.
C            Key to selected local integration rule.
C     WTLENG Integer.
C            The number of weights in each of the rules.
C
C   ON RETURN
C
C     W      Real array of dimension (5,WTLENG).
C            The weights for the basic and null rules.
C            W(1,1), ...,W(1,WTLENG) are weights for the basic rule.
C            W(I,1), ...,W(I,WTLENG), for I > 1 are null rule weights.
C     G      Real array of dimension (NDIM,WTLENG).
C            The fully symmetric sum generators for the rules.
C            G(1,J),...,G(NDIM,J) are the generators for the points
C            associated with the the Jth weights.
C     ERRCOF Real array of dimension 6.
C            Heuristic error coefficients that are used in the
C            error estimation in BASRUL.
C            It is assumed that the error is computed using:
C             IF (N1*ERRCOF(1) < N2 and N2*ERRCOF(2) < N3)
C               THEN ERROR = ERRCOF(3)*N1
C               ELSE ERROR = ERRCOF(4)*MAX(N1, N2, N3)
C             ERROR = ERROR + EP*(ERRCOF(5)*ERROR/(ES+ERROR)+ERRCOF(6))
C            where N1-N3 are the null rules, EP is the error for
C            the parent
C            subregion and ES is the error for the sibling subregion.
C     RULPTS Real array of dimension WTLENG.
C            A work array containing the number of points produced by
C            each generator of the selected rule.
C     SCALES Real array of dimension (3,WTLENG).
C            Scaling factors used to construct new null rules,
C            N1, N2 and N3,
C            based on a linear combination of two successive null rules
C            in the sequence of null rules.
C     NORMS  Real array of dimension (3,WTLENG).
C            2**NDIM/(1-norm of the null rule constructed by each of
C            the scaling factors.)
C
C***ROUTINES CALLED  D132RE,D113RE,D07HRE,D09HRE
C***END PROLOGUE DINHRE
C
C   Global variables.
C
      INTEGER NDIM,KEY,WTLENG
      DOUBLE PRECISION G(NDIM,WTLENG),W(5,WTLENG),ERRCOF(6)
      DOUBLE PRECISION RULPTS(WTLENG),SCALES(3,WTLENG)
      DOUBLE PRECISION NORMS(3,WTLENG)
C
C   Local variables.
C
      INTEGER I,J,K
      DOUBLE PRECISION WE(14)
C
C***FIRST EXECUTABLE STATEMENT DINHRE
C
C   Compute W, G and ERRCOF.
C
      IF (KEY.EQ.1) THEN
          CALL D132RE(WTLENG,W,G,ERRCOF,RULPTS)
      ELSE IF (KEY.EQ.2) THEN
          CALL D113RE(WTLENG,W,G,ERRCOF,RULPTS)
      ELSE IF (KEY.EQ.3) THEN
          CALL D09HRE(NDIM,WTLENG,W,G,ERRCOF,RULPTS)
      ELSE IF (KEY.EQ.4) THEN
          CALL D07HRE(NDIM,WTLENG,W,G,ERRCOF,RULPTS)
      END IF
C
C   Compute SCALES and NORMS.
C
      DO 100 K = 1,3
          DO 50 I = 1,WTLENG
              IF (W(K+1,I).NE.0) THEN
                  SCALES(K,I) = - W(K+2,I)/W(K+1,I)
              ELSE
                  SCALES(K,I) = 100
              END IF
              DO 30 J = 1,WTLENG
                  WE(J) = W(K+2,J) + SCALES(K,I)*W(K+1,J)
30            CONTINUE
              NORMS(K,I) = 0
              DO 40 J = 1,WTLENG
                  NORMS(K,I) = NORMS(K,I) + RULPTS(J)*ABS(WE(J))
40            CONTINUE
              NORMS(K,I) = 2**NDIM/NORMS(K,I)
50        CONTINUE
100   CONTINUE
      RETURN
C
C***END DINHRE
C
      END

* vegas.F
* VEGAS Monte Carlo integration of a vector either with ordinary random
* numbers or with quasi-random numbers
* based on code by M. Martinez, J. Illana, J. Bossert, and A. Vicini
* this file is part of FormCalc
* last modified 14 Sep 01 th

* NDIM is the maximum number of dimensions the integrand may have.
* Note: if your Fortran compiler allows, replace NDIM by ndim
* (i.e. #define NDIM ndim) to dimension the arrays dynamically.
*#define NDIM 3

* NCOMP is the number of components of the integrand vector.
*#define NCOMP 2

* If DEBUG is defined, the error is printed out after each iteration
* so that one can tune the parameters for a particular integral.
#define DEBUG

* RNG determines which random-number generator is used:
* - 1 uses Fortran's ran(...) function,
* - 2 uses a Faure quasi-random sequence,
* - 3 uses a Sobol quasi-random sequence (default).
#define RNG 3


************************************************************************
** vegas integrates a vector in the ndim-dimensional unit hypercube
** using the Monte-Carlo method. The NCOMP-dimensional integrand is
** invoked via the subroutine func(ndim, x, NCOMP, result). After
** sampling ncall points, the grid is refined. This is called one
** iteration. The iterations loop terminates if the relative error is
** below accuracy, or after maxiter iterations.

** Caution: the refinement of the grid is done only with respect to
** the highest component of the integrand vector.

	subroutine vegas(func, result, accuracy, ndim,
     +    ncall, maxiter, neval)
	implicit none
	double precision result(NCOMP), accuracy
	integer ndim, ncall, maxiter, neval
	external func

	double precision fun(NCOMP), sfun(NCOMP), sfun2(NCOMP)
	double precision sint(NCOMP), sweight(NCOMP)
	double precision fun2, sint2, weight
	double precision r, dr, xo, xn, err
	integer iter, call, dim, grid, g, c

	integer ngrid
	parameter (ngrid = 100)

	double precision xi(ngrid, NDIM), d(ngrid, NDIM)
	double precision x(NDIM), imp(ngrid), tmp(ngrid - 1)
	integer pos(NDIM)

	call inirandom(maxiter*ncall, ndim)
	iter = 0
	neval = 0
	do c = 1, NCOMP
	  sint(c) = 0
	  sweight(c) = 0
	enddo
	sint2 = 0

* define the initial distribution of intervals
	do grid = 1, ngrid
	  r = dble(grid)/ngrid
	  do dim = 1, ndim
	    xi(grid, dim) = r
	  enddo
	enddo

* iterations loop
1	continue
	iter = iter + 1

* initialize iteration variables
	do c = 1, NCOMP
	  sfun(c) = 0
	  sfun2(c) = 0
	enddo
	do dim = 1, ndim
	  do grid = 1, ngrid
	    d(grid, dim) = 0
	  enddo
	enddo

	do call = 1, ncall
	  weight = 1D0/ncall

* compute the point position
	  call getrandom(x)
	  do dim = 1, ndim
	    r = x(dim)*ngrid + 1
	    grid = int(r)
	    xo = 0
	    if(grid .gt. 1) xo = xi(grid - 1, dim)
	    xn = xi(grid, dim) - xo
	    x(dim) = xo + (r - grid)*xn
	    pos(dim) = grid
	    weight = weight*xn*ngrid
	  enddo

* compute the function value
	  call func(ndim, x, NCOMP, fun)
	  do c = 1, NCOMP
	    fun2 = fun(c)*weight
	    sfun(c) = sfun(c) + fun2
	    fun2 = fun2**2
	    sfun2(c) = sfun2(c) + fun2
	  enddo
	  do dim = 1, ndim
	    d(pos(dim), dim) = d(pos(dim), dim) + fun2
	  enddo
	enddo
	neval = neval + ncall

* compute the integral and error values
	do c = 1, NCOMP
	  fun2 = sfun(c)**2
	  r = sfun2(c)*ncall - fun2
	  if(r .ne. 0) then
	    weight = fun2/abs(r)*(ncall - 1)
	    sweight(c) = sweight(c) + weight
	    sint(c) = sint(c) + sfun(c)*weight
	  endif
	  if(sweight(c) .eq. 0) then
	    result(c) = 0
	  else
	    result(c) = sint(c)/sweight(c)
	  endif
	enddo
	sint2 = sint2 + fun2
	err = sqrt(sint2/(sweight(NCOMP)*iter))/abs(result(NCOMP))
#ifdef DEBUG
	print *, "iteration ", iter, "  error ", err
#endif
	if(result(NCOMP) .eq. 0 .or. err .lt. accuracy) return
	if(iter .gt. maxiter) then
	  print *,
     +      "Warning: VEGAS failed to reach the desired accuracy."
	  print *, "Remaining relative error: ", err
	  return
	endif

* redefine the grid (importance sampling)
* - smooth the f^2 value stored for each interval
	do dim = 1, ndim
	  xo = d(1, dim)
	  xn = d(2, dim)
	  d(1, dim) = .5D0*(xo + xn)
	  x(dim) = d(1, dim)
	  do grid = 2, ngrid - 1
	    r = xo + xn
	    xo = xn
	    xn = d(grid + 1, dim)
	    d(grid, dim) = (r + xn)/3D0
	    x(dim) = x(dim) + d(grid, dim)
	  enddo
	  d(ngrid, dim) = .5D0*(xo + xn)
	  x(dim) = x(dim) + d(ngrid, dim)
	enddo

* - compute the importance function of each interval
	do dim = 1, ndim
	  r = 0
	  do grid = 1, ngrid
	    imp(grid) = 0
	    if(d(grid, dim) .gt. 0) then
	      xo = x(dim)/d(grid, dim)
	      imp(grid) = ((xo - 1)/xo/log(xo))**1.5D0
	    endif
	    r = r + imp(grid)
	  enddo
	  r = r/ngrid

* - redefine the size of each interval
	  dr = 0
	  xn = 0
	  g = 0
	  do grid = 1, ngrid - 1
	    do while(dr .lt. r)
	      g = g + 1
	      dr = dr + imp(g)
	      xo = xn
	      xn = xi(g, dim)
	    enddo
	    dr = dr - r
	    tmp(grid) = xn - (xn - xo)*dr/imp(g)
	  enddo
	  do grid = 1, ngrid - 1
	    xi(grid, dim) = tmp(grid)
	  enddo
	  xi(ngrid, dim) = 1
	enddo

	goto 1
	end


#if RNG == 1

************************************************************************
** inirandom sets up the random-number generator to produce at most
** max dims-dimensional quasi-random vectors

	subroutine inirandom(max, dims)
	implicit none
	integer max, dims

	integer ndim
	common /rngdata/ ndim

	ndim = dims
	end


************************************************************************
** getrandom is a subtractive Mitchell-Moore random-number generator.
** The algorithm is n(i) = (n(i - 24) - n(i - 55)) mod m, implemented
** as a circular array with n(i + 55) = n(i) and m = 2^30 in this
** version. The array n has been initialized by setting n(i) = i and
** running the algorithm 100,000 times. Code by Ronald Kleiss.

	subroutine getrandom(array)
	implicit none
	double precision array(*)

	integer ndim
	common /rngdata/ ndim

	integer dim, j, k, l, m, n(55)
	parameter (m = 2**30)
	data k /55/, l /31/
	data n /
     +    980629335, 889272121, 422278310,1042669295, 531256381,
     +    335028099,  47160432, 788808135, 660624592, 793263632,
     +    998900570, 470796980, 327436767, 287473989, 119515078,
     +    575143087, 922274831,  21914605, 923291707, 753782759,
     +    254480986, 816423843, 931542684, 993691006, 343157264,
     +    272972469, 733687879, 468941742, 444207473, 896089285,
     +    629371118, 892845902, 163581912, 861580190,  85601059,
     +    899226806, 438711780, 921057966, 794646776, 417139730,
     +    343610085, 737162282,1024718389,  65196680, 954338580,
     +    642649958, 240238978, 722544540, 281483031,1024570269,
     +    602730138, 915220349, 651571385, 405259519, 145115737 /

	do dim = 1, ndim
	  k = mod(k, 55) + 1
	  l = mod(l, 55) + 1
	  j = n(l) - n(k)
	  if(j .lt. 0) j = j + m
	  n(k) = j
	  array(dim) = dble(j)/m
	enddo
	end

#elif RNG == 2

************************************************************************
** inirandom sets up the random-number generator to produce a Faure
** sequence of at most max dims-dimensional quasi-random vectors.
** Adapted from ACM TOMS algorithm 659, see
** http://www.acm.org/pubs/citations/journals/toms/1988-14-1/p88-bratley

	subroutine inirandom(max, dims)
	implicit none
	integer max, dims

	integer coeff(0:19, 0:19)
	integer ndim, prime, nextn, testn, digits
	common /rngdata/ coeff, ndim, prime, nextn, testn, digits

	integer i, j, h

	integer primes(40)
	save primes

	data primes /
     +    1, 2, 3, 5, 5, 7, 7, 11, 11, 11, 11,
     +    13, 13, 17, 17, 17, 17, 19, 19,
     +    23, 23, 23, 23, 29, 29, 29, 29,
     +    29, 29, 31, 31, 37, 37, 37, 37,
     +    37, 37, 41, 41, 41 /

	ndim = dims
	prime = primes(dims)
	testn = prime**4
	nextn = testn - 1
	digits = 3

	h = nint(log(dble(max + testn))/log(dble(prime)))
	coeff(0, 0) = 1
	do j = 1, h
	  coeff(j, 0) = 1
	  coeff(j, j) = 1
	enddo
	do j = 1, h
	  do i = j + 1, h
	    coeff(i, j) =
     +        mod(coeff(i - 1, j) + coeff(i - 1, j - 1), prime)
	  enddo
	enddo
	end


************************************************************************
** getrandom generates a vector of random numbers

	subroutine getrandom(array)
	implicit none
	double precision array(*)

	integer coeff(0:19, 0:19)
	integer ndim, prime, nextn, testn, digits
	common /rngdata/ coeff, ndim, prime, nextn, testn, digits

	integer y(0:19), digit, dim, d, k, p
	double precision r

	p = testn
	k = nextn
	do digit = digits, 0, -1
	  p = p/prime
	  d = mod(k, p)
	  y(digit) = (k - d)/p
	  k = d
	enddo

	r = 0
	do digit = digits, 0, -1
	  r = (r + y(digit))/prime
	enddo
	array(1) = r

	do dim = 2, ndim
	  r = 0
	  p = 1
	  do digit = 0, digits
	    k = 0
	    do d = digit, digits
	      k = k + coeff(d, digit)*y(d)
	    enddo
	    y(digit) = mod(k, prime)
	    p = p*prime
	    r = r + dble(y(digit))/p
	  enddo
	  array(dim) = r
	enddo

	nextn = nextn + 1
	if(nextn .eq. testn) then
	   testn = testn*prime
	   digits = digits + 1
	endif
	end

#else

************************************************************************
** inirandom sets up the random-number generator to produce a Sobol
** sequence of at most max dims-dimensional quasi-random vectors.
** Adapted from ACM TOMS algorithm 659, see
** http://www.acm.org/pubs/citations/journals/toms/1988-14-1/p88-bratley

	subroutine inirandom(max, dims)
	implicit none
	integer max, dims

	integer v(40, 30), lastq(40)
	integer ndim, count, norm
	common /rngdata/ v, lastq, ndim, count, norm

	integer bits, powers, degree, newv, dim, bit, deg, k

	integer poly(2:40), vinit(2:40, 1:8)
	save poly, vinit

	data poly / 3, 7, 11, 13, 19, 25, 37, 59, 47,
     +    61, 55, 41, 67, 97, 91, 109, 103, 115, 131,
     +    193, 137, 145, 143, 241, 157, 185, 167, 229, 171,
     +    213, 191, 253, 203, 211, 239, 247, 285, 369, 299 /

	data (vinit(dim, 1), dim = 2, 40) / 39*1 /
	data (vinit(dim, 2), dim = 3, 40) /
     +          1, 3, 1, 3, 1, 3, 3, 1,
     +    3, 1, 3, 1, 3, 1, 1, 3, 1, 3,
     +    1, 3, 1, 3, 3, 1, 3, 1, 3, 1,
     +    3, 1, 1, 3, 1, 3, 1, 3, 1, 3 /
	data (vinit(dim, 3), dim = 4, 40) /
     +             7, 5, 1, 3, 3, 7, 5,
     +    5, 7, 7, 1, 3, 3, 7, 5, 1, 1,
     +    5, 3, 3, 1, 7, 5, 1, 3, 3, 7,
     +    5, 1, 1, 5, 7, 7, 5, 1, 3, 3 /
	data (vinit(dim, 4), dim = 6, 40) /
     +                  1, 7, 9, 13, 11,
     +    1, 3, 7, 9, 5, 13, 13, 11, 3, 15,
     +    5, 3, 15, 7, 9, 13, 9, 1, 11, 7,
     +    5, 15, 1, 15, 11, 5, 3, 1, 7, 9 /
	data (vinit(dim, 5), dim = 8, 40) /
     +                            9, 3, 27,
     +    15, 29, 21, 23, 19, 11, 25, 7, 13, 17,
     +    1, 25, 29, 3, 31, 11, 5, 23, 27, 19,
     +    21, 5, 1, 17, 13, 7, 15, 9, 31, 9 /
	data (vinit(dim, 6), dim = 14, 40) /
     +            37, 33, 7, 5, 11, 39, 63,
     +    27, 17, 15, 23, 29, 3, 21, 13, 31, 25,
     +    9, 49, 33, 19, 29, 11, 19, 27, 15, 25 /
	data (vinit(dim, 7), dim = 20, 40) /
     +                                  13,
     +    33, 115, 41, 79, 17, 29, 119, 75, 73, 105,
     +    7, 59, 65, 21, 3, 113, 61, 89, 45, 107 /
	data (vinit(dim, 8), dim = 38, 40) / 7, 23, 39 /

	k = max
	bits = 0
	do while(k .ne. 0)
	  bits = bits + 1
	  k = ishft(k, -1)
	enddo

	do bit = 1, bits
	  v(1, bit) = 1
	enddo

	do dim = 2, dims
	  powers = poly(dim)

	  k = powers
	  degree = -1
	  do while(k .ne. 0)
	    degree = degree + 1
	    k = ishft(k, -1)
	  enddo

	  do bit = 1, degree
	    v(dim, bit) = vinit(dim, bit)
	  enddo

	  do bit = degree + 1, bits
	    newv = v(dim, bit - degree)
	    k = powers
	    do deg = degree, 1, -1
	      if(btest(k, 0))
     +          newv = ieor(newv, ishft(v(dim, bit - deg), deg))
	      k = ishft(k, -1)
	    enddo
	    v(dim, bit) = newv
	  enddo
	enddo

	do bit = 1, bits - 1
	  do dim = 1, dims
	    v(dim, bit) = ishft(v(dim, bit), bits - bit)
	  enddo
	enddo
	norm = ishft(1, bits)

	count = 0
	ndim = dims
	do dim = 1, dims
	  lastq(dim) = 0
	enddo
	end


************************************************************************
** getrandom generates a vector of random numbers

	subroutine getrandom(array)
	implicit none
	double precision array(*)

	integer v(40, 30), lastq(40)
	integer ndim, count, norm
	common /rngdata/ v, lastq, ndim, count, norm

	integer c, zerobit, dim

	c = count
	zerobit = 1
	do while(btest(c, 0))
	  zerobit = zerobit + 1
	  c = ishft(c, -1)
	enddo

	do dim = 1, ndim
	  lastq(dim) = ieor(lastq(dim), v(dim, zerobit))
	  array(dim) = dble(lastq(dim))/norm
	enddo

	count = count + 1
	end

#endif

* SxS.F
* computes Spinor.Spinor
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


	ComplexType function SxS(a, b)
	implicit none
	integer a, b

	ComplexType spi(2, 1)
	common /vectors/ spi

#define A(x) spi(x, a)
#define B(x) spi(x, b)

	SxS = A(1)*B(1) + A(2)*B(2)
	end

* mpnum.F
* a dummy multiprecision numerator function
* this file is part of FormCalc
* last modified 21 Oct 09 th


	subroutine mpnum(q1in, qt2, res)
	implicit none
	double precision q1in(0:3), qt2
	double complex res

	integer ini
	data ini /0/
	save ini

	if( ini .eq. 0 ) then
	  print *, "MP version not yet available"
	  ini = 1
	endif

	res = 0
	end

* Ecut.F
* the FormCalc wrapper for the CutTools five-point function
* this file is part of FormCalc
* last modified 21 Oct 09 th


	double complex function Ecut(rank, num,
     &    p1, p2, p3, p4, m1, m2, m3, m4, m5)
	implicit none
	integer rank
	external num
	integer*8 p1, p2, p3, p4
	double precision m1, m2, m3, m4, m5

	double precision pi(0:3,0:4), mi(5)
	external mpnum

	pi(0,0) = 0
	pi(1,0) = 0
	pi(2,0) = 0
	pi(3,0) = 0
	call MomDecode(p1, pi(0,1))
	call MomDecode(p2, pi(0,2))
	call MomDecode(p3, pi(0,3))
	call MomDecode(p4, pi(0,4))

	mi(1) = m1
	mi(2) = m2
	mi(3) = m3
	mi(4) = m4
	mi(5) = m5

c	call ctsxcut(5, num, mpnum, rank, pi, mi, Ecut)
	call ctsxcut(5, num, mpnum, 5, pi, mi, Ecut)
	end

* 1to2.F
* the kinematics for a 1 -> 2 process
* this file is part of FormCalc
* last modified 31 Jan 06 th


* some definitions for xsection.F
#define LEGS 3
#define LEGS_IN 1
#define LEGS_OUT 2
#define MASS_IN MASS1
#define MASS_OUT MASS2 + MASS3
#define TYPES TYPE1, TYPE2, TYPE3

* this defines the order of integrations:
#define XCOSTH 1
#define MAXVAR XCOSTH

#include LUMI


************************************************************************

	subroutine KinIni(fail)
	implicit none
	integer fail

#include "xsection.h"

	Lower(XCOSTH) = 0
	Upper(XCOSTH) = 1
	if( Lower(SQRTS) .gt. Upper(SQRTS) ) then
	  Step(XCOSTH) = XCOSTHSTEP
	else
	  Step(XCOSTH) = 0
	endif

	fail = 0
	end


************************************************************************

	subroutine InitialState
	implicit none

#include "model.h"

	call VecSet(1, DBLE(MASS1), 0D0, 0D0, 0D0, 1D0)
	end


************************************************************************

	subroutine FinalState(fac)
	implicit none
	double precision fac

#include "util.h"
#include "xsection.h"

	double precision p, ex,ey,ez, msum, minv
	integer key

	p = 0
	ex = 0
	ey = 0
	ez = 1
	minv = sqrtS
	msum = MASS_OUT

	key = 0
#ifdef COSTHCUT
	CutMin(XCOSTH) = -(1 - COSTHCUT)
	CutMax(XCOSTH) = +(1 - COSTHCUT)
	key = key + Cut(CUT_COSTH, CUT_MIN + CUT_MAX)
#endif

	call Split(2, DBLE(MASS2), p, ex,ey,ez, minv, msum,
     &    fac, key, Var(FIXED), Var(XCOSTH), Var(TRIVIAL))

	call VecSet(3, DBLE(MASS3), p, ex,ey,ez)
	end

* Acut.F
* the FormCalc wrapper for the CutTools one-point function
* this file is part of FormCalc
* last modified 21 Oct 09 th


	double complex function Acut(rank, num, m)
	implicit none
	integer rank
	external num
	double precision m

	double precision pi(0:3,0:0)
	external mpnum

	pi(0,0) = 0
	pi(1,0) = 0
	pi(2,0) = 0
	pi(3,0) = 0

	PRINT *, "Acut:", rank
	PRINT *, "m1=", m

c	call ctsxcut(1, num, mpnum, rank, pi, m, Acut)
	call ctsxcut(1, num, mpnum, 1, pi, m, Acut)
	PRINT *, "Acut=", Acut
	end

* spectrum.f
* compute the CompAZ spectrum
* use e.g. in gnuplot as plot "< ./spectrum 250" with lines
* last modified 2 Feb 05 th


	program spectrum
	implicit none

	double precision energy, fraction
	character*100 argv

	double precision CompAZ
	integer iargc
	external iargc, CompAZ

	if( iargc() .ne. 1 ) then
	  call getarg(0, argv)
	  print *, "Usage: spectrum E"
	  print *, "Compute the CompAZ spectrum for energy E"
	  return
	endif

	call getarg(1, argv)
	read(argv, *) energy

	do fraction = 0, 1, .01
	  print *, fraction, CompAZ(fraction, energy, 0)
	enddo
	end

* Eigen2x2.F
* diagonalization of a Hermitian 2-by-2 matrix
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "diag-f.h"


	subroutine Eigen2x2(fail, m, msq, U, M11, M22, M12)
	implicit none
	integer fail
	RealType m(2), msq(2)
	ComplexType U(2,2)
	RealType M11, M22
	ComplexType M12

	RealType M12sq, delta, t, c, m1, m2
	ComplexType s

	M12sq = DBLE(M12)**2 + DIMAG(M12)**2
	t = .5D0*(M11 - M22)
	t = 1/(t + sign(sqrt(t**2 + M12sq), t))

	delta = t*M12sq
	m1 = M11 + delta
	m2 = M22 - delta

	c = 1/sqrt(delta*t + 1)
	s = c*t*M12

	if( m1 .gt. m2 ) then
	  msq(1) = m2
	  msq(2) = m1
	  U(1,1) = -DCONJG(s)
	  U(2,2) = s
	  U(1,2) = c
	  U(2,1) = c
	else
	  msq(1) = m1
	  msq(2) = m2
	  U(1,1) = c
	  U(2,2) = c
	  U(1,2) = s
	  U(2,1) = -DCONJG(s)
	endif

	if( msq(1) .lt. 0 ) then
	  print *, "Negative mass-squares."
	  fail = 1
	  return
	endif

	m(1) = sqrt(msq(1))
	m(2) = sqrt(msq(2))
	fail = 0
	end

* AlphaS.F
* AlphaS computes the strong coupling constant at a given scale.
* Code is transcribed from I. Hinchliffe's Java applet at
* http://www-theory.lbl.gov/~ianh/alpha/alpha.html.
* this file is part of FormCalc
* last modified 30 Nov 11 th


	subroutine AlphaS(as, nf, scale)
	implicit none
	RealType as, scale
	integer nf

#include "decl.h"

* the betas and deltas are calculated as follows:
*
* beta0[nf_] := 11 - 2/3 nf
* beta1[nf_] := 51 - 19/3 nf
* beta2[nf_] := 2857 - 5033/9 nf + 325/27 nf^2
*
* delta0[nf_] := (beta0[nf] - beta0[nf + 1])/(2 beta0[nf])
* delta10[nf_] := beta1[nf]/beta0[nf]^2
* delta11[nf_] := (beta1[nf]/beta0[nf] -
*   beta1[nf + 1]/beta0[nf + 1])/beta0[nf]
* delta20[nf_] := (28/9 -
*   8 (beta1[nf + 1]/beta0[nf + 1])^2 + beta2[nf + 1]/beta0[nf + 1] +
*   8 (beta1[nf]/beta0[nf])^2 - beta2[nf]/beta0[nf])/
*   (4 beta0[nf + 1] beta0[nf])
* delta21[nf_] := 2 beta1[nf + 1]/beta0[nf + 1]^2 delta11[nf]

	RealType beta3_0, beta3_1, beta3_2
	parameter (beta3_0 = 9)
	parameter (beta3_1 = 32)
	parameter (beta3_2 = 3863/3D0)

	RealType beta4_0, beta4_1, beta4_2
	parameter (beta4_0 = 25/3D0)
	parameter (beta4_1 = 77/3D0)
	parameter (beta4_2 = 21943/27D0)

	RealType beta5_0, beta5_1, beta5_2
	parameter (beta5_0 = 23/3D0)
	parameter (beta5_1 = 58/3D0)
	parameter (beta5_2 = 9769/27D0)

	RealType beta6_0, beta6_1, beta6_2
	parameter (beta6_0 = 7)
	parameter (beta6_1 = 13)
	parameter (beta6_2 = -65)

	RealType delta54_0, delta54_10, delta54_11
	RealType delta54_20, delta54_21
	parameter (delta54_0  =  .040000000000000000000D0)
	parameter (delta54_10 = -.030817842663873271183D0)
	parameter (delta54_11 =  .066991304347826086957D0)
	parameter (delta54_20 = -.086878340429029341662D0)
	parameter (delta54_21 =  .044069893975507520342D0)

	RealType delta43_0, delta43_10, delta43_11
	RealType delta43_20, delta43_21
	parameter (delta43_0  =  .037037037037037037037D0)
	parameter (delta43_10 = -.030404361930322301228D0)
	parameter (delta43_11 =  .052839506172839506173D0)
	parameter (delta43_20 = -.057313053497942386831D0)
	parameter (delta43_21 =  .039058962962962962963D0)

	RealType beta0, beta1, beta2, lam, t, b, c, l

	RealType lam5, asMZ
	save lam5, asMZ
	data lam5 /204D-3/, asMZ /.1176D0/
* the 5-flavour scale lam5 reproduces alpha_s(MZ) = .1176

	do while( abs(asMZ - AlfasMZ) .gt. 1D-4 )
	  t = 2*log(MZ/lam5)
	  c = 2*beta5_1/beta5_0**2/t
	  l = c*log(t)
	  b = c**2*(beta5_2*beta5_0/(8*beta5_1**2) - 1)
	  asMZ = 4*pi/beta5_0/t*(1 + l*(l - c - 1) + b)
* Newton step is (as - AlfasMZ)/as'
	  lam5 = lam5*(1 - beta5_0/(8*pi)*t**2*(asMZ - AlfasMZ)/
     &      (1 + c*(c + 1) + l*(3*l - 5*c - 2) + 3*b))
	enddo

	if( scale .lt. .5D0 ) then
	  as = 1D10
	  return
	endif

	if( scale .gt. MT ) then
	  nf = 6
	  beta0 = beta6_0
	  beta1 = beta6_1
	  beta2 = beta6_2
	  t = MT/lam5
	  lam = lam5*t**(-2/21D0)*(2*log(t))**(-107/1127D0)
	else if( scale .gt. MB ) then
	  nf = 5
	  beta0 = beta5_0
	  beta1 = beta5_1
	  beta2 = beta5_2
	  lam = lam5
	else
	  t = 2*log(MB/lam5)
	  l = log(t)
	  lam = lam5*exp(delta54_0*t +
     &      delta54_11*l + delta54_10 +
     &      (delta54_21*l + delta54_20)/t)
	  if( scale .gt. MC ) then
	    nf = 4
	    beta0 = beta4_0
	    beta1 = beta4_1
	    beta2 = beta4_2
	  else
	    nf = 3
	    beta0 = beta3_0
	    beta1 = beta3_1
	    beta2 = beta3_2
	    t = 2*log(MC/lam)
	    l = log(t)
	    lam = lam*exp(delta43_0*t +
     &        delta43_11*l + delta43_10 +
     &        (delta43_21*l + delta43_20)/t)
	  endif
	endif

	t = 2*log(scale/lam)
	c = 2*beta1/(beta0**2*t)
	l = c*log(t)
	b = c**2*(beta2*beta0/(8*beta1**2) - 1)
	as = 4*pi/(beta0*t)*(1 + l*(l - c - 1) + b)
	end

* CTCcut.F
* the FormCalc wrapper for the CutTools three-point function
* this file is part of FormCalc
* last modified 3 Aug 11 th


	double complex function CTCcut(rank, num, numeps,
     &    p1, p2, m1, m2, m3)
	implicit none
	integer rank
	external num, numeps
	integer*8 p1, p2
	double precision m1, m2, m3

	double precision pj(0:3,3), mj(3)
	logical stable, forcemp
	double complex res(0:2), res1
	external CTmpnum

	double precision rootsvalue, muscale
	common /cuttools_para/ rootsvalue, muscale

	pj(0,1) = 0
	pj(1,1) = 0
	pj(2,1) = 0
	pj(3,1) = 0
	call CTMomDecode(p1, pj(0,2))
	call CTMomDecode(p2, pj(0,3))

	mj(1) = m1
	mj(2) = m2
	mj(3) = m3

	PRINT *, "Ccut:", rank
	PRINT *, "p1=", pj(0,2)
	PRINT *, "   ", pj(1,2)
	PRINT *, "   ", pj(2,2)
	PRINT *, "   ", pj(3,2)
	PRINT *, "p2=", pj(0,3)
	PRINT *, "   ", pj(1,3)
	PRINT *, "   ", pj(2,3)
	PRINT *, "   ", pj(3,3)
	PRINT *, "m1=", m1
	PRINT *, "m2=", m2
	PRINT *, "m3=", m3

	call ctsxcut(rootsvalue, muscale, 3, num, CTmpnum,
     &    rank, pj, mj, res, res1, stable, forcemp)
	CTCcut = res(0)
	PRINT *, "Ccut=", CTCcut
	end

* xsection.F
* routines to compute the cross-section
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "decl.h"

#include "process.h"

#include MODEL

#ifdef BREMSSTRAHLUNG
#include "softphoton.F"
#endif

************************************************************************
** ProcessIni translates the polarization string into bit-encoded
** helicities, determines the averaging factor, and initializes the
** model defaults.

	subroutine ProcessIni(fail, pol,
     &    sqrtSfrom, sqrtSto, sqrtSstep,
     &    argc, argv)
	implicit none
	integer fail, argc
	character*(*) pol
	character*128 argv(*)
	RealType sqrtSfrom, sqrtSto, sqrtSstep

#include "xsection.h"

#if U77EXT
#define len_trim lnblnk
	integer lnblnk
	external lnblnk
#endif

	integer i, c, bits, df

#define SCALAR Z'001'
#define FERMION Z'10A'
#define PHOTON Z'20A'
#define GLUON PHOTON
#define VECTOR Z'20E'
#define GRAVITINO Z'31B'
#define GRAVITON Z'41B'
#define TENSOR Z'41F'

	integer type(LEGS)
	data type /TYPES/

	if( len_trim(pol) .ne. LEGS ) then
	  fail = 1
	  return
	endif

	df = 2**(LEGS)

	do i = 1, LEGS
	  bits = iand(type(i), 255)
	  c = ior(ichar(pol(i:i)), 32)
	  if( c .eq. ichar('t') ) then
	    c = ior(c, ibits(bits, 3, 1))
	    bits = iand(bits, 16+8+2+1)
	  else if( c .eq. ichar('p') ) then
	    bits = iand(bits, 16)
	  else if( c .eq. ichar('+') ) then
	    bits = iand(bits, 8)
	  else if( c .eq. ichar('l') ) then
	    bits = iand(bits, 4)
	  else if( c .eq. ichar('-') ) then
	    bits = iand(bits, 2)
	  else if( c .eq. ichar('m') ) then
	    bits = iand(bits, 1)
	  else if( c .ne. ichar('u') ) then
	    bits = 0
	  endif

	  if( bits .eq. 0 ) then
	    Error(fail, "Invalid polarization for leg "/ /Digit(i))
	    return
	  endif

	  if( i .le. LEGS_IN ) df = df*(ibits(bits, 4, 1) +
     &      ibits(bits, 3, 1) + ibits(bits, 2, 1) +
     &      ibits(bits, 1, 1) + ibits(bits, 0, 1))

#ifdef DIRACFERMIONS
	  if( type(i) .eq. FERMION ) then
	    df = df/2
	    bits = 1
	  endif
#endif

	  pol(i:i) = char(c)
	  helicities = helicities*32 + bits
	enddo

	Lower(SQRTS) = sqrtSfrom
	Upper(SQRTS) = sqrtSto
	Step(SQRTS) = sqrtSstep

	Var(FIXED) = 0
	Step(FIXED) = 1

	Var(TRIVIAL) = 0
	Step(TRIVIAL) = 0

	avgfac = 2**(LEGS)*Re(COLOURFACTOR)*Re(IDENTICALFACTOR)/df
	sqrtS = -1
	threshold = -1
	scale = -1
	sqrtSinvalid = 1

	call ltini

#ifdef CUTTOOLS
* args are:
* 1. rootsvalue = arbitrary OPP scale of the order of the scale of the process
* 2. limitvalue = upper limit of precision above which the mp routines activate
* 3. idig       = max number of digits of the mp routines
* 4. scaloop    = scalar integrals (1 is LoopTools)
* 5. muscale    = the renormalization scale
* 6. thrs       = internal collinear IR threshold for avh_olo
	rootsvalue = sqrtSfrom
	muscale = getmudim()
	call ctsinit(rootsvalue, 1D-2, 0, 1, muscale, 1D-6)
#endif

#ifdef SAMURAI
* args are:
* 1. imeth = "diag" (numerators) or "tree" (products of tree amps)
* 2. isca = 1 (QCDloop) or 2 (OneLOop)
* 3. verbosity = 0, 1, 2, 3
* 4. itest = 0 (none), 1 (powertest), 2 (nntest), 3 (lnntest)
	call initsamurai("diag", 2, 1, 1)
#endif

	call ModelDefaults(argc, argv)
	call LumiDefaults(argc, argv)

	fail = 0
	end


************************************************************************
** ProcessExi wraps up the calculation, e.g. prints a summary of
** messages, deallocates arrays etc.

	subroutine ProcessExi
	implicit none

	call ltexi
	end


************************************************************************
** SetEnergy sets the energy for the partonic scattering process.
** All scale-dependent quantities are initialized at SCALE.

	subroutine SetEnergy(fail, newsqrtS)
	implicit none
	integer fail
	RealType newsqrtS

#include "xsection.h"

	RealType oldscale, oldmass_in, oldmass_out
	logical reset
	integer i

	fail = 0
	reset = abs(newsqrtS - sqrtS) .gt. 1D-9
	sqrtS = newsqrtS
	oldscale = max(Re(SCALE), 1D0)

	if( sqrtSinvalid .eq. 1 .or.
     &      btest(flags, BIT_RESET) .or.
     &      abs(oldscale - scale) .gt. 1D-9 ) then
	  oldmass_in = MASS_IN
	  oldmass_out = MASS_OUT

	  do i = 1, 10
	    call ModelVarIni(fail, oldscale)

	    scale = max(Re(SCALE), 1D0)
	    mass_in = MASS_IN
	    mass_out = MASS_OUT

	    if( abs(scale - oldscale) +
     &          abs(mass_in - oldmass_in) +
     &          abs(mass_out - oldmass_out) .lt. 1D-9 ) goto 1

	    oldscale = scale
	    oldmass_in = mass_in
	    oldmass_out = mass_out
	  enddo

1	  threshold = max(mass_in, mass_out)
	  sqrtSinvalid = fail
	  reset = .TRUE.
	endif

	if( reset ) flags = ibset(flags, BIT_RESET)

	if( fail .ne. 0 .or. sqrtS .lt. threshold ) then
	  fail = 1
	else
	  call InitialState
	endif
	end


************************************************************************
** ParameterScan performs the actual calculation.
** It scans over the parameter loops LOOP* declared in run.F.

	subroutine ParameterScan(dir,
     &    serialfrom, serialto, serialstep)
	implicit none
	character*(*) dir
	integer serialfrom, serialto, serialstep

#include "xsection.h"

	integer openlog
	external openlog

	integer serial, next

	next = serialfrom
	serial = 0

#ifdef LOOP1
	LOOP1
#endif
#ifdef LOOP2
	LOOP2
#endif
#ifdef LOOP3
	LOOP3
#endif
#ifdef LOOP4
	LOOP4
#endif
#ifdef LOOP5
	LOOP5
#endif
#ifdef LOOP6
	LOOP6
#endif
#ifdef LOOP7
	LOOP7
#endif
#ifdef LOOP8
	LOOP8
#endif
#ifdef LOOP9
	LOOP9
#endif
#ifdef LOOP10
	LOOP10
#endif
#ifdef LOOP11
	LOOP11
#endif
#ifdef LOOP12
	LOOP12
#endif
#ifdef LOOP13
	LOOP13
#endif
#ifdef LOOP14
	LOOP14
#endif
#ifdef LOOP15
	LOOP15
#endif
#ifdef LOOP16
	LOOP16
#endif
#ifdef LOOP17
	LOOP17
#endif
#ifdef LOOP18
	LOOP18
#endif
#ifdef LOOP19
	LOOP19
#endif
#ifdef LOOP20
	LOOP20
#endif

	serial = serial + 1
	if( serial .lt. next ) goto 1

	call flush(6)
	if( openlog(dir, serial) .eq. 0 ) then
	  call IntegratedCS
	  call flush(6)
	  call closelog
	endif

	next = next + serialstep
	if( next .gt. serialto ) return

1	continue
	end


************************************************************************
** IntegratedCS computes the integrated cross-section at one point in
** parameter space.  The cross-section is differential in all variables
** with non-zero step, i.e. integration variables have step = 0.

	subroutine IntegratedCS
	implicit none

#include "xsection.h"

	integer nvars
	parameter (nvars = MAXVAR - (MINVAR) + 1)

	external DifferentialCS

	RealType result(NCOMP), error(NCOMP), show(nvars)
	integer fail, f, v, nfix, ndim, fix(nvars)

	call ModelConstIni(fail)
	if( fail .ne. 0 ) goto 999

	flags = 2**BIT_RESET + 2**BIT_LOOP

#ifdef MUDIM
	call setmudim(Re(MUDIM))
#endif
#ifdef DELTA
	call setdelta(Re(DELTA))
#endif
#ifdef LAMBDA
	call setlambda(Re(LAMBDA))
#endif
	Divergence = getdelta()
	mudim = getmudim()
	lambda = getlambda()
	if( lambda .eq. -1 ) then
	  epscoeff = -1
	  Finite = 0
	else if( lambda .eq. -2 ) then
	  epscoeff = -2
	  Finite = 0
	else
	  epscoeff = 0
	  Finite = 1
	endif

	call KinIni(fail)
	if( fail .ne. 0 ) goto 999

	nfix = 0
	do v = MINVAR, MAXVAR
	  if( Step(v) .ne. 0 ) then
	    nfix = nfix + 1
	    fix(nfix) = v
	    Var(v) = Lower(v)
	  endif
	enddo

	ndim = nvars - nfix

	call LumiIni(fail)
	if( fail .ne. 0 ) goto 999

	call ModelDigest

#define SHOW print 100,
100	format("|# ", A, "=", F10.4, SP, F10.4, " I")

#ifdef MMA
	call MmaSetPara
#endif

#ifdef PRINT1
	PRINT1
#endif
#ifdef PRINT2
	PRINT2
#endif
#ifdef PRINT3
	PRINT3
#endif
#ifdef PRINT4
	PRINT4
#endif
#ifdef PRINT5
	PRINT5
#endif
#ifdef PRINT6
	PRINT6
#endif
#ifdef PRINT7
	PRINT7
#endif
#ifdef PRINT8
	PRINT8
#endif
#ifdef PRINT9
	PRINT9
#endif
#ifdef PRINT10
	PRINT10
#endif
#ifdef PRINT11
	PRINT11
#endif
#ifdef PRINT12
	PRINT12
#endif
#ifdef PRINT13
	PRINT13
#endif
#ifdef PRINT14
	PRINT14
#endif
#ifdef PRINT15
	PRINT15
#endif
#ifdef PRINT16
	PRINT16
#endif
#ifdef PRINT17
	PRINT17
#endif
#ifdef PRINT18
	PRINT18
#endif
#ifdef PRINT19
	PRINT19
#endif
#ifdef PRINT20
	PRINT20
#endif

#ifdef MMA
	call MmaEndSet
	call MmaSetData
#endif

1	call Cuba(ndim, DifferentialCS, result, error)

	do f = 1, nfix
	  show(f) = Show(fix(f))
	enddo

#ifdef MMA
	call MmaData(show, nfix, result, error, NCOMP)
#else
* Note: "real" data lines are tagged with "|" in the output.
101	format("| ", 10(4G19.10, :, /"|+"))
	print 101, (show(f), f = 1, nfix)

102	format("|+   ", NCOMP G24.15)
	print 102, result
	print 102, error

	call flush(6)
#endif

	do f = nfix, 1, -1
	  v = fix(f)
	  Var(v) = Var(v) + Step(v)
	  if( (Var(v) - Upper(v))/Step(v) .lt. 1D-10 ) goto 1
	  Var(v) = Lower(v)
	enddo

#ifdef MMA
	call MmaEndSet
#else
103	format("|"/"|"/)
	print 103
#endif

999	continue
	end


************************************************************************
** DifferentialCS computes the differential cross-section at x.
** For all integration variables (those with zero step) it factors in
** the Jacobian, too.

	subroutine DifferentialCS(ndim, x, ncomp, result)
	implicit none
	integer ndim, ncomp
	RealType x(ndim), result(ncomp)

#include "xsection.h"

#ifdef BREMSSTRAHLUNG
	RealType SoftPhotonFactor
	external SoftPhotonFactor
#endif

	RealType fac, range, flux
	integer v, d, c

	fac = avgfac
	d = 0
	do v = MINVAR, MAXVAR
	  if( Step(v) .eq. 0 ) then
	    range = Upper(v) - Lower(v)
	    d = d + 1
	    Var(v) = Lower(v) + x(d)*range
	    fac = fac*range
	  endif
	  Show(v) = Var(v)
	enddo

	do c = 1, ncomp
	  result(c) = 0
	enddo

	call Luminosity(fac)
	if( fac .eq. 0 ) return

	call FinalState(fac)
	if( fac .eq. 0 ) return

	if( btest(flags, BIT_RESET) ) then
	  call clearcache
#ifndef NO_RENCONST
	  call CalcRenConst
#endif
	endif

	call SquaredME(result, helicities, flags)

	flags = ibclr(flags, BIT_RESET)

#if LEGS_IN == 1
	flux = 2*sqrtS
#else
	flux = 4/hbar_c2*sqrtS*momspec(SPEC_K, 1)
#endif
	fac = fac/((2*pi)**(3*LEGS_OUT - 4)*2*sqrtS*flux)

	do c = 1, ncomp
	  if( .not. abs(result(c)) .lt. 1D16 ) then
	    Warning("Got strange values from SquaredME:")
	    INFO result
	    INFO "(Did you compute the colour matrix elements?)"
	    stop
	  endif
	  result(c) = result(c)*fac
	enddo

#ifdef BREMSSTRAHLUNG
	result(2) = result(2) + SoftPhotonFactor()*result(1)
#endif

#ifdef WF_RENORMALIZATION
	result(2) = result(2) + (WF_RENORMALIZATION)*result(1)
#endif
	end


************************************************************************
** Cuba is a chooser for the Cuba routines, with special cases
** for ndim = 0 (integrand evaluation) and ndim = 1 (Patterson
** integration).

	subroutine Cuba(ndim, integrand, result, error)
	implicit none
	integer ndim
	external integrand
	RealType result(NCOMP), error(NCOMP)

	integer nregions, neval, fail, c
	RealType prob(NCOMP)

#include "xsection.h"

#define GAUSS 1
#define PATTERSON 2
#define VEGAS 3
#define SUAVE 4
#define DIVONNE 5
#define CUHRE 6

#define FLAGS_LAST 4
#define FLAGS_PSEUDO 8

	if( ndim .eq. 0 ) then

	  call integrand(0, 0D0, NCOMP, result)
	  do c = 1, NCOMP
	    error(c) = 0
	  enddo
	  return

	else if( ndim .eq. 1 ) then

#if METHOD == GAUSS

	  neval = 32
	  call Gauss(NCOMP, 0D0, 1D0, integrand,
     &      neval, result)
	  do c = 1, NCOMP
	    error(c) = -1
	    prob(c) = -1
	  enddo
	  nregions = 1
	  fail = 0
	  INFO "Gauss integration results:"

#else

	  call Patterson(NCOMP, 0D0, 1D0, integrand,
     &      Re(RELACCURACY), Re(ABSACCURACY),
     &      neval, fail, result, error)
	  do c = 1, NCOMP
	    prob(c) = -1
	  enddo
	  nregions = 1
	  INFO "Patterson integration results:"

#endif

	else

#if METHOD == VEGAS

	  call vegas(ndim, NCOMP, integrand, USERDATA,
     &      Re(RELACCURACY), Re(ABSACCURACY),
     &      VERBOSE, SEED, MINEVAL, MAXEVAL,
     &      NSTART, NINCREASE, NBATCH,
     &      GRIDNO, STATEFILE,
     &      neval, fail, result, error, prob)
	  nregions = 1
	  INFO "Vegas integration results:"

#elif METHOD == SUAVE

	  call suave(ndim, NCOMP, integrand, USERDATA,
     &      Re(RELACCURACY), Re(ABSACCURACY),
     &      VERBOSE + FLAGS_LAST, SEED, MINEVAL, MAXEVAL,
     &      NNEW, Re(FLATNESS),
     &      nregions, neval, fail, result, error, prob)
	  INFO "Suave integration results:"

#elif METHOD == DIVONNE

	  call divonne(ndim, NCOMP, integrand, USERDATA,
     &      Re(RELACCURACY), Re(ABSACCURACY),
     &      VERBOSE, SEED, MINEVAL, MAXEVAL,
     &      KEY1, KEY2, KEY3, MAXPASS,
     &      Re(BORDER), Re(MAXCHISQ), Re(MINDEVIATION),
     &      0, NDIM, 0, 0, 0,
     &      nregions, neval, fail, result, error, prob)
	  INFO "Divonne integration results:"

#else

	  call cuhre(ndim, NCOMP, integrand, USERDATA,
     &      Re(RELACCURACY), Re(ABSACCURACY),
     &      VERBOSE + FLAGS_LAST, MINEVAL, MAXEVAL,
     &      KEY,
     &      nregions, neval, fail, result, error, prob)
	  INFO "Cuhre integration results:"

#endif

	endif

	INFO "nregions =", nregions
	INFO "neval    =", neval
	INFO "fail     =", fail

	if( fail .gt. 0 ) then
	  Warning("Failed to reach the desired accuracy")
	else if( fail .lt. 0 ) then
	  Error(fail, "Integration error")
	endif

100	format(I2, G24.15, " +- ", G24.15, "    p = ", F6.3)
	print 100, (c, result(c), error(c), prob(c), c = 1, NCOMP)
	end

* Ccut.F
* the FormCalc wrapper for the CutTools three-point function
* this file is part of FormCalc
* last modified 18 Nov 09 th


	double complex function Ccut(rank, num,
     &    p1, p2, m1, m2, m3)
	implicit none
	integer rank
	external num
	integer*8 p1, p2
	double precision m1, m2, m3

	double precision pi(0:3,0:2), mi(3)
	external mpnum

	pi(0,0) = 0
	pi(1,0) = 0
	pi(2,0) = 0
	pi(3,0) = 0
	call MomDecode(p1, pi(0,1))
	call MomDecode(p2, pi(0,2))

	mi(1) = m1
	mi(2) = m2
	mi(3) = m3

	PRINT *, "Ccut:", rank
	PRINT *, "p1=", pi(0,1)
	PRINT *, "   ", pi(1,1)
	PRINT *, "   ", pi(2,1)
	PRINT *, "   ", pi(3,1)
	PRINT *, "p2=", pi(0,2)
	PRINT *, "   ", pi(1,2)
	PRINT *, "   ", pi(2,2)
	PRINT *, "   ", pi(3,2)
	PRINT *, "m1=", m1
	PRINT *, "m2=", m2
	PRINT *, "m3=", m3

c	call ctsxcut(3, num, mpnum, rank, pi, mi, Ccut)
	call ctsxcut(3, num, mpnum, 3, pi, mi, Ccut)
	PRINT *, "Ccut=", Ccut
	end

* TakagiFactor.F
* computes the Takagi factorization of a complex symmetric matrix
* code adapted from the "Handbook" routines
* (Wilkinson, Reinsch: Handbook for Automatic Computation, p. 202)
* this file is part of the Diag library
* last modified 30 Nov 11 th

#include "diag-f.h"


************************************************************************
** TakagiFactor factorizes a complex symmetric n-by-n matrix
** Input: n, A = n-by-n matrix, complex symmetric
** (only the upper triangle of A needs to be filled).
** Output: d = vector of diagonal values, U = transformation matrix
** these fulfill diag(d) = U^* A U^+ with U unitary.

	subroutine TakagiFactor(n, A,ldA, d, U,ldU, sort)
	implicit none
	integer n, ldA, ldU, sort
	ComplexType A(ldA,*), U(ldU,*)
	RealType d(*)

	integer p, q, j
	RealType red, off, thresh
	RealType sqp, sqq, t, invc
	ComplexType f, x, y
	ComplexType ev(2,MAXDIM)

	integer sweep
	common /nsweeps/ sweep

	if( n .gt. MAXDIM ) then
	  print *, "Dimension too large"
	  d(1) = -999
	  return
	endif

	do p = 1, n
	  ev(1,p) = 0
	  ev(2,p) = A(p,p)
	enddo

	do p = 1, n
	  do q = 1, n
	    U(q,p) = 0
	  enddo
	  U(p,p) = 1
	enddo

	red = .04D0/n**4

	do sweep = 1, 50
	  off = 0
	  do q = 2, n
	    do p = 1, q - 1
	      off = off + Sq(A(p,q))
	    enddo
	  enddo
	  if( .not. off .gt. SYM_EPS ) goto 1

	  thresh = 0
	  if( sweep .lt. 4 ) thresh = off*red

	  do q = 2, n
	    do p = 1, q - 1
	      off = Sq(A(p,q))
	      sqp = Sq(ev(2,p))
	      sqq = Sq(ev(2,q))
	      if( sweep .gt. 4 .and.
     &            off .lt. SYM_EPS*(sqp + sqq) ) then
	        A(p,q) = 0
	      else if( off .gt. thresh ) then
	        t = .5D0*abs(sqp - sqq)
	        if( t .gt. 0 ) then
	          f = sign(1D0, sqp - sqq)*
     &              (ev(2,q)*Conjugate(A(p,q)) +
     &               Conjugate(ev(2,p))*A(p,q))
	        else
	          f = 1
	          if( sqp .ne. 0 ) f = sqrt(ev(2,q)/ev(2,p))
	        endif
	        t = t + sqrt(t**2 + Sq(f))
	        f = f/t

	        ev(1,p) = ev(1,p) + A(p,q)*Conjugate(f)
	        ev(2,p) = A(p,p) + ev(1,p)
	        ev(1,q) = ev(1,q) - A(p,q)*f
	        ev(2,q) = A(q,q) + ev(1,q)

	        t = Sq(f)
	        invc = sqrt(t + 1)
	        f = f/invc
	        t = t/(invc*(invc + 1))

	        do j = 1, p - 1
	          x = A(j,p)
	          y = A(j,q)
	          A(j,p) = x + (Conjugate(f)*y - t*x)
	          A(j,q) = y - (f*x + t*y)
	        enddo

	        do j = p + 1, q - 1
	          x = A(p,j)
	          y = A(j,q)
	          A(p,j) = x + (Conjugate(f)*y - t*x)
	          A(j,q) = y - (f*x + t*y)
	        enddo

	        do j = q + 1, n
	          x = A(p,j)
	          y = A(q,j)
	          A(p,j) = x + (Conjugate(f)*y - t*x)
	          A(q,j) = y - (f*x + t*y)
	        enddo

	        A(p,q) = 0

	        do j = 1, n
	          x = U(p,j)
	          y = U(q,j)
	          U(p,j) = x + (f*y - t*x)
	          U(q,j) = y - (Conjugate(f)*x + t*y)
	        enddo
	      endif
	    enddo
	  enddo

	  do p = 1, n
	    ev(1,p) = 0
	    A(p,p) = ev(2,p)
	  enddo
	enddo

	print *, "Bad convergence in TakagiFactor"

1	continue

* make the diagonal elements nonnegative

	do p = 1, n
	  d(p) = abs(A(p,p))
	  if( d(p) .gt. DBL_EPS .and. d(p) .ne. Re(A(p,p)) ) then
	    f = sqrt(A(p,p)/d(p))
	    do q = 1, n
	      U(p,q) = U(p,q)*f
	    enddo
	  endif
	enddo

	if( sort .eq. 0 ) return

* sort the eigenvalues

	do p = 1, n - 1
	  j = p
	  t = d(p)
	  do q = p + 1, n
	    if( sort*(t - d(q)) .gt. 0 ) then
	      j = q
	      t = d(q)
	    endif
	  enddo

	  if( j .ne. p ) then
	    d(j) = d(p)
	    d(p) = t
	    do q = 1, n
	      x = U(p,q)
	      U(p,q) = U(j,q)
	      U(j,q) = x
	    enddo
	  endif
	enddo
	end

* model_mssm.F
* all parameters for the MSSM are initialized here
* this file is part of FormCalc
* Christian Schappacher, 17 Feb 99
* last modified 30 Nov 11 th


* The input parameters for model_mssm are:

* Higgs sector:
*   TB
*   MA0 or MHp

* Chargino/Neutralino sector:
*   Mino2
*   MUE

* Sfermion sector:
*   MSusy
*   Atau, At, Ab
* If one wants to specify the breaking and mixing in the
* sfermion sector more precisely, the following preprocessor
* variables can be used:
*   MSQ(g), MSU(g), MSD(g), MSL(g), MSE(g) (= MSusy by default)
*   Ae(g) (= Atau by default)
*   Au(g) (= At by default)
*   Ad(g) (= Ab by default)


* The following preprocessor variables can be defined
* (they are usually set in run.F):

* NO_SQUARK_MIXING
*   If defined, sets Atau, At, and Ab such that the off-diagonal entries
*   of the sfermion mixing matrices vanish, i.e. gauge eigenstates =
*   mass eigenstates.

* HIGGS_MASSES can take the values
* TREE -- uses only tree-level Higgs masses,
* SIMPLE -- uses a simple one-loop approximation of the
*    Higgs masses which is valid for all parameters.
* FEYNHIGGS -- invokes FeynHiggs to compute the Higgs masses,
* (undefined) -- uses a fairly precise two-loop approximation,
*    which is valid though only for real parameters.

* SM_HIGGS
*   If defined, reverse-engineers the mixing in the Higgs sector
*   (alpha and beta) such that the MSSM Higgs sector looks like
*   a SM Higgs sector.

* NMFV
*   If defined, initialize also the fully 6x6 mixed sfermion mass
*   matrices with the flavour-violating parameters deltaSf.

* NO_EXCLUSION_LIMITS
*   If defined, the experimental exclusion limits are ignored.

* NO_GUT_RELATION
*   If defined, does not use the GUT relation which relates
*   the gaugino mass paramters.  In this case, Mino1 and Mino3 are
*   also input parameters.


#ifndef Ae
#define Ae(g) Atau
#endif

#ifndef Au
#define Au(g) At
#endif

#ifndef Ad
#define Ad(g) Ab
#endif

#ifndef MSQ
#define MSQ(g) MSusy
#endif

#ifndef MSU
#define MSU(g) MSusy
#endif

#ifndef MSL
#define MSL(g) MSusy
#endif

#ifndef MSD
#define MSD(g) MSusy
#endif

#ifndef MSE
#define MSE(g) MSusy
#endif


* Exclusion limits (only checked if NO_EXCLUSION_LIMITS is not set):

* hep-ex/9910020 (L3)
#define MStop_LOWERBOUND 80

* hep-ex/9910020 (L3)
#define MSbottom_LOWERBOUND 70

* hep-ex/9910020 (L3)
#define MSquark_LOWERBOUND 150

* hep-ex/9910006 (L3)
#define MSlepton_LOWERBOUND 70

* PDG
#define DeltaRho_UPPERBOUND .003D0

#ifdef COMPLEX_PARAMETERS
* Kane & Wang, Phys Lett B488 (2000) 383
#define Mh0_LOWERBOUND 85
#else
* http://lephiggs.web.cern.ch/LEPHIGGS/papers/osaka_note.ps
#define Mh0_LOWERBOUND 91
#endif

* hep-ex/9910007 (L3) and hep-ex/9909051 (OPAL)
#define MNeu_LOWERBOUND 30

* hep-ex/9910007 (L3) and hep-ex/9909051 (OPAL)
#define MCha_LOWERBOUND 90

* hep-ex/9910020 (L3) and PDG
#define MGl_LOWERBOUND 175


#define TREE 100
#define SIMPLE 200
#define FEYNHIGGS 300

#define ModelDefaults SMDefaults
#define ModelConstIni SMConstIni
#define ModelVarIni SMVarIni
#define ModelDigest SMDigest
#include "model_sm.F"
#undef ModelDefaults
#undef ModelConstIni
#undef ModelVarIni
#undef ModelDigest


************************************************************************

	subroutine ModelDefaults(argc, argv)
	implicit none
	integer argc
	character*128 argv(*)

#include "decl.h"

	integer i

	do i = 1, 3*3*3
	  Af_flat(i) = 0
	  Xf_flat(i) = 0
	enddo

#ifdef NMFV
	do i = 1, 6*6*2
	  deltaSf_flat(i) = 0
	enddo
#endif

	TB = -1
	MA0 = -1
	MHp = -1

	call SMDefaults(argc, argv)
	end


************************************************************************

	subroutine ModelConstIni(fail)
	implicit none
	integer fail

#include "decl.h"

	integer nf

	call SMConstIni(fail)
	if( fail .ne. 0 ) return

	call AlphaS(AlfasMT, nf, MT)

	TB2 = TB**2
	CB2 = 1/(1 + TB2)
	SB2 = CB2*TB2
	CB = sqrt(CB2)
	SB = CB*TB
	S2B = 2*TB*CB2
	C2B = (CB - SB)*(CB + SB)

	call SfermionMasses(fail)
	if( fail .ne. 0 ) return

	call CharginoMasses(fail)
	if( fail .ne. 0 ) return

	call NeutralinoMasses(fail)
	if( fail .ne. 0 ) return

	call HiggsMassesConst(fail)
	end


************************************************************************

	subroutine ModelVarIni(fail, scale)
	implicit none
	integer fail
	RealType scale

#include "decl.h"

	call SMVarIni(fail, scale)
	if( fail .ne. 0 ) return

#ifndef NO_GUT_RELATION
* Gluino mass: GUT relation
* we use 1/Alfa(s) approx 1/Alfa(MZ2) - 20/(9*pi)*log(s/MZ2)
	Mino3 = Alfas*(1/AlfaMZ - 40/(9*pi)*log(scale/MZ))*SW2*Mino2
#endif

	MGl = abs(Mino3)
#ifndef NO_EXCLUSION_LIMITS
	if( MGl .lt. MGl_LOWERBOUND ) then
	  Error(fail, "MGl < MGl_LOWERBOUND")
	  return
	endif
#endif
	MGl2 = MGl**2

	SqrtEGl = Mino3
	if( MGl .gt. 1D-14 ) SqrtEGl = sqrt(SqrtEGl/MGl)

	call HiggsMassesVar(fail)
	end


************************************************************************

	subroutine ModelDigest
	implicit none

#include "decl.h"

	call SMDigest

	INFO "MSSM parameters"
	INFO "----------------------------"
	INFO "TB =", TB
	INFO "Mino1 =", Mino1
	INFO "Mino2 =", Mino2
	INFO "Mino3 =", Mino3
	INFO "MUE =", MUE
	INFO "MSusy =", MSusy
	INFO "Atau =", Af(2,3,3)
	INFO "At =", Af(3,3,3)
	INFO "Ab =", Af(4,3,3)
	INFO "----------------------------"
	INFO "Higgs masses:"
#if HIGGS_MASSES == FEYNHIGGS
	INFO "(using FeynHiggs)"
#elif HIGGS_MASSES == TREE
	INFO "(using tree-level Higgs masses)"
#elif HIGGS_MASSES == SIMPLE
	INFO "(using simple approximation)"
#else
	INFO "(using 2-loop approximation)"
#endif
	INFO "Mh0 =", Mh0
	INFO "MHH =", MHH
	INFO "MA0 =", MA0
	INFO "MHp =", MHp
	INFO "----------------------------"
	INFO "Sfermion masses:"
#ifdef NO_SQUARK_MIXING
	INFO "(diagonal sfermion mass matrix: L-R basis)"
#else
	INFO "(non-diagonal sfermion mass matrix: 1-2 basis)"
#endif
	INFO "Sneutrino  e:  ", MSf(1,1,1)
	INFO "           mu: ", MSf(1,1,2)
	INFO "           tau:", MSf(1,1,3)
	INFO "Slepton    e:  ", MSf(1,2,1), MSf(2,2,1)
	INFO "           mu: ", MSf(1,2,2), MSf(2,2,2)
	INFO "           tau:", MSf(1,2,3), MSf(2,2,3)
	INFO "u-Squark   u:  ", MSf(1,3,1), MSf(2,3,1)
	INFO "           c:  ", MSf(1,3,2), MSf(2,3,2)
	INFO "           t:  ", MSf(1,3,3), MSf(2,3,3)
	INFO "d-Squark   d:  ", MSf(1,4,1), MSf(2,4,1)
	INFO "           s:  ", MSf(1,4,2), MSf(2,4,2)
	INFO "           b:  ", MSf(1,4,3), MSf(2,4,3)
#ifdef NMFV
	INFO "u-Squark fv    ", MASf(1,3), MASf(2,3)
	INFO "               ", MASf(3,3), MASf(4,3)
	INFO "               ", MASf(5,3), MASf(6,3)
	INFO "d-Squark fv    ", MASf(1,4), MASf(2,4)
	INFO "               ", MASf(3,4), MASf(4,4)
	INFO "               ", MASf(5,4), MASf(6,4)
#endif
	INFO "----------------------------"
	INFO "Chargino masses:"
	INFO "MCha(1) =", MCha(1)
	INFO "MCha(2) =", MCha(2)
	INFO "----------------------------"
	INFO "Neutralino masses:"
	INFO "MNeu(1) =", MNeu(1)
	INFO "MNeu(2) =", MNeu(2)
	INFO "MNeu(3) =", MNeu(3)
	INFO "MNeu(4) =", MNeu(4)
	INFO "----------------------------"
	INFO "Gluino mass:"
	INFO "MGl =", MGl
	INFO "============================"
	end


*-----------------------------------------------------------------------
* Sfermion sector:

	subroutine SfermionMasses(fail)
	implicit none
	integer fail

#include "decl.h"

	integer t, g
	RealType i3part, qpart

	RealType Qe, Qu, Qd
	parameter (Qe = -1, Qu = 2/3D0, Qd = -1/3D0)

#ifndef NO_EXCLUSION_LIMITS
	RealType DeltaRho, f1f2
	external f1f2
#endif

#ifdef NMFV
	integer as, g2
	ComplexType MX2(6,6), m1, m2, m3

#define MX2_LL(i,j) MX2(i,j)
#define MX2_LR(i,j) MX2(i,j+3)
#define MX2_RL(i,j) Conjugate(MX2(j,i+3))
#define MX2_RR(i,j) MX2(i+3,j+3)

	ComplexType MX2_flat(6*6)
	equivalence (MX2, MX2_flat)
#endif

	i3part = .5D0*MZ2*C2B
	qpart = SW2*MZ2*C2B
	DSf(1,1) = +i3part
	DSf(2,1) = 0
	DSf(2,2) = Qe*qpart
	DSf(1,2) = -i3part - DSf(2,2)
	DSf(2,3) = Qu*qpart
	DSf(1,3) = +i3part - DSf(2,3)
	DSf(2,4) = Qd*qpart
	DSf(1,4) = -i3part - DSf(2,4)

	MUETB(3) = -Conjugate(MUE)/TB
	MUETB(2) = -Conjugate(MUE)*TB
	MUETB(4) = MUETB(2)

	do g = 1, 3
	  MSS(1,2,g) = MSL(g)
	  MSS2(1,2,g) = MSS(1,2,g)**2
	  MSS(2,2,g) = MSE(g)
	  MSS2(2,2,g) = MSS(2,2,g)**2
	  MSS(1,3,g) = MSQ(g)
	  MSS2(1,3,g) = MSS(1,3,g)**2
	  MSS(2,3,g) = MSU(g)
	  MSS2(2,3,g) = MSS(2,3,g)**2
	  MSS(1,4,g) = MSQ(g)
	  MSS2(1,4,g) = MSS(1,4,g)**2
	  MSS(2,4,g) = MSD(g)
	  MSS2(2,4,g) = MSS(2,4,g)**2

#ifdef NO_SQUARK_MIXING
#define Eigen2x2 NoMixing
	  Af(2,g,g) = -MUETB(2)
	  Af(3,g,g) = -MUETB(3)
	  Af(4,g,g) = -MUETB(4)
	  Xf(2,g) = 0
	  Xf(3,g) = 0
	  Xf(4,g) = 0
#else
	  Af(2,g,g) = Ae(g)
	  Xf(2,g) = Af(2,g,g) + MUETB(2)
	  Af(3,g,g) = Au(g)
	  Xf(3,g) = Af(3,g,g) + MUETB(3)
	  Af(4,g,g) = Ad(g)
	  Xf(4,g) = Af(4,g,g) + MUETB(4)
#endif

	  call NoMixing(fail, MSf(1,1,g), MSf2(1,1,g), USf(1,1,1,g),
     &      MSS2(1,2,g) + DSf(1,1), 1D300, DCMPLX(0D0))

	  do t = 2, 4
	    call Eigen2x2(fail, MSf(1,t,g), MSf2(1,t,g), USf(1,1,t,g),
     &        MSS2(1,t,g) + DSf(1,t) + Mf2(t,g),
     &        MSS2(2,t,g) + DSf(2,t) + Mf2(t,g),
     &        Mf(t,g)*Conjugate(Xf(t,g)))
	    if( fail .ne. 0 ) return

	    UCSf(1,1,t,g) = Sq(USf(1,1,t,g))
	    UCSf(2,1,t,g) = Sq(USf(2,1,t,g))
	    UCSf(1,2,t,g) = Sq(USf(1,2,t,g))
	    UCSf(2,2,t,g) = Sq(USf(2,2,t,g))

	    UCSf(3,1,t,g) = USf(1,1,t,g)*USfC(2,1,t,g)
	    UCSf(3,2,t,g) = USf(1,2,t,g)*USfC(2,2,t,g)
	    UCSf(1,3,t,g) = USf(1,1,t,g)*USfC(1,2,t,g)
	    UCSf(2,3,t,g) = USf(2,1,t,g)*USfC(2,2,t,g)
	    UCSf(3,3,t,g) = USf(1,1,t,g)*USfC(2,2,t,g)
	    UCSf(3,4,t,g) = USf(1,2,t,g)*USfC(2,1,t,g)

	    UUSf(1,1,t,g) = USf(1,1,t,g)**2
	    UUSf(2,1,t,g) = USf(2,1,t,g)**2
	    UUSf(1,2,t,g) = USf(1,2,t,g)**2
	    UUSf(2,2,t,g) = USf(2,2,t,g)**2

	    UUSf(3,1,t,g) = USf(1,1,t,g)*USf(2,1,t,g)
	    UUSf(3,2,t,g) = USf(1,2,t,g)*USf(2,2,t,g)
	    UUSf(1,3,t,g) = USf(1,1,t,g)*USf(1,2,t,g)
	    UUSf(2,3,t,g) = USf(2,1,t,g)*USf(2,2,t,g)
	    UUSf(3,3,t,g) = USf(1,1,t,g)*USf(2,2,t,g)
	    UUSf(3,4,t,g) = USf(1,2,t,g)*USf(2,1,t,g)
	  enddo
	enddo

#ifndef NO_EXCLUSION_LIMITS
	if( MSf(1,4,3) .lt. MSbottom_LOWERBOUND ) then
	  Error(fail, "MSf(1,4,3) < MSbottom_LOWERBOUND")
	  return
	endif

	if( MSf(1,3,3) .lt. MStop_LOWERBOUND ) then
	  Error(fail, "MSf(1,3,3) < MStop_LOWERBOUND")
	  return
	endif

	if( MSf(1,2,1) .lt. MSlepton_LOWERBOUND ) then
	  Error(fail, "MSf(1,2,1) < MSlepton_LOWERBOUND")
	  return
	endif

	if( MSf(1,3,1) .lt. MSquark_LOWERBOUND ) then
	  Error(fail, "MSf(1,3,1) < MSquark_LOWERBOUND")
	  return
	endif

	DeltaRho =
     &    USf2(1,1,3,3)*USf2(1,1,4,3)*f1f2(MSf2(1,3,3), MSf2(1,4,3)) +
     &    USf2(1,1,3,3)*USf2(2,1,4,3)*f1f2(MSf2(1,3,3), MSf2(2,4,3)) +
     &    USf2(2,1,3,3)*USf2(1,1,4,3)*f1f2(MSf2(2,3,3), MSf2(1,4,3)) +
     &    USf2(2,1,3,3)*USf2(2,1,4,3)*f1f2(MSf2(2,3,3), MSf2(2,4,3)) -
     &    USf2(1,2,3,3)*USf2(2,2,3,3)*f1f2(MSf2(1,3,3), MSf2(2,3,3)) -
     &    USf2(1,2,4,3)*USf2(2,2,4,3)*f1f2(MSf2(1,4,3), MSf2(2,4,3))

	if( DeltaRho .gt. DeltaRho_UPPERBOUND ) then
	  Error(fail, "DeltaRho > DeltaRho_UPPERBOUND")
	  return
	endif
#endif

#ifdef NMFV
* Note: we compute two sets of squark masses.
* 1) the "regular" ones with only left-right mixing,
* 2) the fully 6x6 mixed ones.
* The "regular" ones are needed for computing the Higgs mass.

	do t = 3, 4
	  MX2_LL(1,1) = MSS2(1,4,1)
	  MX2_LL(2,2) = MSS2(1,4,2)
	  MX2_LL(3,3) = MSS2(1,4,3)
	  MX2_LL(1,2) = MSS(1,4,1)*MSS(1,4,2)*deltaSf_LL(1,2,4)
	  MX2_LL(2,3) = MSS(1,4,2)*MSS(1,4,3)*deltaSf_LL(2,3,4)
	  MX2_LL(1,3) = MSS(1,4,1)*MSS(1,4,3)*deltaSf_LL(1,3,4)
	  if( t .eq. 3 ) then
	    do g2 = 1, 3
	      m1 = MX2_LL(1,1)*CKMC(g2,1) +
     &             MX2_LL(1,2)*CKMC(g2,2) +
     &             MX2_LL(1,3)*CKMC(g2,3)
	      m2 = Conjugate(MX2_LL(1,2))*CKMC(g2,1) +
     &             MX2_LL(2,2)*CKMC(g2,2) +
     &             MX2_LL(2,3)*CKMC(g2,3)
	      m3 = Conjugate(MX2_LL(1,3))*CKMC(g2,1) +
     &             Conjugate(MX2_LL(2,3))*CKMC(g2,2) +
     &             MX2_LL(3,3)*CKMC(g2,3)
	      do g = 1, g2
	        MX2_LL(g,g2) = CKM(g,1)*m1 + CKM(g,2)*m2 + CKM(g,3)*m3
	      enddo
	    enddo
	  endif
	  MX2_LL(1,1) = MX2_LL(1,1) + DSf(1,t) + Mf2(t,1)
	  MX2_LL(2,2) = MX2_LL(2,2) + DSf(1,t) + Mf2(t,2)
	  MX2_LL(3,3) = MX2_LL(3,3) + DSf(1,t) + Mf2(t,3)

	  MX2_RR(1,1) = MSS2(2,t,1) + DSf(2,t) + Mf2(t,1)
	  MX2_RR(2,2) = MSS2(2,t,2) + DSf(2,t) + Mf2(t,2)
	  MX2_RR(3,3) = MSS2(2,t,3) + DSf(2,t) + Mf2(t,3)
	  MX2_RR(1,2) = MSS(2,t,1)*MSS(2,t,2)*deltaSf_RR(1,2,t)
	  MX2_RR(2,3) = MSS(2,t,2)*MSS(2,t,3)*deltaSf_RR(2,3,t)
	  MX2_RR(1,3) = MSS(2,t,1)*MSS(2,t,3)*deltaSf_RR(1,3,t)

	  MX2_LR(1,1) = Mf(t,1)*Xf(t,1)
	  MX2_LR(2,2) = Mf(t,2)*Xf(t,2)
	  MX2_LR(3,3) = Mf(t,3)*Xf(t,3)
	  MX2_LR(1,2) = MSS(1,t,1)*MSS(2,t,2)*deltaSf_LR(1,2,t)
	  Af(t,1,2) = MX2_LR(1,2)/Mf(t,1)
	  MX2_LR(2,3) = MSS(1,t,2)*MSS(2,t,3)*deltaSf_LR(2,3,t)
	  Af(t,2,3) = MX2_LR(2,3)/Mf(t,2)
	  MX2_LR(1,3) = MSS(1,t,1)*MSS(2,t,3)*deltaSf_LR(1,3,t)
	  Af(t,1,3) = MX2_LR(1,3)/Mf(t,1)
	  MX2_LR(2,1) = Conjugate(MSS(2,t,1)*MSS(1,t,2)*deltaSf_RL(1,2,t))
	  Af(t,2,1) = MX2_LR(2,1)/Mf(t,2)
	  MX2_LR(3,2) = Conjugate(MSS(2,t,2)*MSS(1,t,3)*deltaSf_RL(2,3,t))
	  Af(t,3,2) = MX2_LR(3,2)/Mf(t,3)
	  MX2_LR(3,1) = Conjugate(MSS(2,t,1)*MSS(1,t,3)*deltaSf_RL(1,3,t))
	  Af(t,3,1) = MX2_LR(3,1)/Mf(t,3)

	  call HEigensystem(6, MX2,6, MASf2(1,t), UASf(1,1,t),6, 1)

	  if( MASf2(1,t) .lt. 0 ) then
	    Error(fail, "Negative MASf2")
	    return
	  endif

	  do as = 1, 6
	    MASf(as,t) = sqrt(MASf2(as,t))
	  enddo
	enddo
#endif
	end


*-----------------------------------------------------------------------
* this function is needed for the calculation of Delta rho

	RealType function f1f2(m1, m2)
	implicit none
	RealType m1, m2

#include "decl.h"

	RealType f1, f2, logm1m2, c1

	logm1m2 = log(m1/m2)
	c1 = 2*m1*m2/(m1 - m2)*logm1m2
	f1 = m1 + m2 - c1
	f2 = m1 + m2 - c1*(2 + m1/m2*logm1m2)
     &   + (m1 + m2)*m1**2/(m1 - m2)**2 * logm1m2**2
     &   - 2*(m1 - m2) * Li2(1 - m1/m2)

	f1f2 = 3*GF/(8*sqrt2*pi**2) * (f1 + 2/(3*pi)*AlfasMT*f2)
	end


*-----------------------------------------------------------------------
* Chargino sector:

	subroutine CharginoMasses(fail)
	implicit none
	integer fail

#include "decl.h"

	ComplexType X(2,2)

	X(1,1) = Mino2
	X(2,1) = sqrt2*MW*CB
	X(1,2) = sqrt2*MW*SB
	X(2,2) = MUE

	call SVD(2, 2, X,2, MCha, UCha,2, VCha,2, 1)

#ifndef NO_EXCLUSION_LIMITS
	if( MCha(1) .lt. MCha_LOWERBOUND ) then
	  Error(fail, "MCha(1) < MCha_LOWERBOUND")
	  return
	endif
#endif

	MCha2(1) = MCha(1)**2
	MCha2(2) = MCha(2)**2
	end


*-----------------------------------------------------------------------
* Neutralino sector:

	subroutine NeutralinoMasses(fail)
	implicit none
	integer fail

#include "decl.h"

	ComplexType Y(4,4)

#ifndef NO_GUT_RELATION
* GUT relation (Higgs Hunters Guide p. 287)
	Mino1 = 5/3D0*SW2/CW2*Mino2
#endif

	Y(1,1) = Mino1
	Y(2,2) = Mino2
	Y(3,1) = -MZ*SW*CB
	Y(1,3) = Y(3,1)
	Y(4,1) = MZ*SW*SB
	Y(1,4) = Y(4,1)
	Y(3,2) = MZ*CW*CB
	Y(2,3) = Y(3,2)
	Y(4,2) = -MZ*CW*SB
	Y(2,4) = Y(4,2)
	Y(4,3) = -MUE
	Y(3,4) = Y(4,3)
	Y(2,1) = 0
	Y(1,2) = 0
	Y(3,3) = 0
	Y(4,4) = 0

	call TakagiFactor(4, Y,4, MNeu, ZNeu,4, 1)

#ifndef NO_EXCLUSION_LIMITS
	if( MNeu(1) .lt. MNeu_LOWERBOUND ) then
	  Error(fail, "MNeu(1) < MNeu_LOWERBOUND")
	  return
	endif
#endif

	MNeu2(1) = MNeu(1)**2
	MNeu2(2) = MNeu(2)**2
	MNeu2(3) = MNeu(3)**2
	MNeu2(4) = MNeu(4)**2
	end


*-----------------------------------------------------------------------
* Higgs sector:

	subroutine HiggsMassesConst(fail)
	implicit none
	integer fail

#include "decl.h"

	RealType avgMH2, deltaMH2
	integer inputmass
	data inputmass /0/

	if( inputmass .eq. 0 ) then
	  if( MA0 .ge. 0 ) then
	    inputmass = 3
	  else if( MHp .gt. MW ) then
	    inputmass = 4
	  else
	    Error(fail, "Neither MA0 nor MHp given")
	    return
	  endif
	endif

	if( inputmass .eq. 3 ) then
	  MA0tree2 = MA0**2
	  MHptree2 = MA0tree2 + MW2
	else if( inputmass .eq. 4 ) then
	  MA0tree2 = (MHp - MW)*(MHp + MW)
	  MHptree2 = MHp**2
	endif

	avgMH2 = .5D0*(MA0tree2 + MZ2)
	deltaMH2 = sqrt(MA0tree2*MZ2)*C2B
	deltaMH2 = sqrt((avgMH2 - deltaMH2)*(avgMH2 + deltaMH2))
	Mh0tree2 = avgMH2 - deltaMH2
	MHHtree2 = avgMH2 + deltaMH2

	CA2 = .5D0*(SB2*MA0tree2 + CB2*MZ2 - Mh0tree2)/deltaMH2
	CA = sqrt(CA2)
	SA = -SB*CB*avgMH2/(CA*deltaMH2)

#if HIGGS_MASSES != FEYNHIGGS
	Mh02 = Mh0tree2
	MHH2 = MHHtree2
	MA02 = MA0tree2
	MHp2 = MHptree2
#if HIGGS_MASSES != TREE
	call HiggsCorr(fail)
	if( fail .ne. 0 ) return
#endif
	Mh0 = sqrt(Mh02)
	MHH = sqrt(MHH2)
	MA0 = sqrt(MA02)
	MHp = sqrt(MHp2)
#endif

	SA2 = SA**2
	S2A = 2*SA*CA
	C2A = (CA - SA)*(CA + SA)
	SAB = SA*CB + CA*SB
	CAB = CA*CB - SA*SB
	SBA = SB*CA - CB*SA
	SBA2 = SBA**2
	CBA = CB*CA + SB*SA
	CBA2 = CBA**2
	end


*-----------------------------------------------------------------------
* Higgs sector: some parts need to be evaluated in the `Var' part,
* e.g. FeynHiggs needs the gluino mass, which is known only after
* alpha_s(s) is set.

	subroutine HiggsMassesVar(fail)
	implicit none
	integer fail

#include "decl.h"

#if HIGGS_MASSES == FEYNHIGGS
	call FeynHiggs(fail)
	if( fail .ne. 0 ) return
#endif

#ifndef NO_EXCLUSION_LIMITS
	if( Mh0 .lt. Mh0_LOWERBOUND ) then
	  Error(fail, "Mh0 < Mh0_LOWERBOUND")
	  return
	endif
#endif

	MH = Mh0
	MH2 = Mh02

#ifdef SM_HIGGS
* With SM_HIGGS defined, the values of the MSSM parameters are set
* such that the SM is reproduced.  See Higgs Hunters Guide p. 356.
* Note one tricky thing: the Higgs mass Mh0 is first calculated as
* it would be in the MSSM (to get the same value when comparing
* MSSM <-> SM), but then beta is reverse-engineered to be consistent
* with the SM relations.  In other words, we start with the MSSM-
* value of beta, calculate Mh0, and then redefine beta to fulfill
* cos(2 beta) = Mh0/MZ.  In principle, beta could also be fixed such
* that cos(2 beta) = -Mh0/MZ, but this is insignificant here since
* we only need beta to be consistent with the values of Mh0 and MZ.

	C2B = Mh0/MZ
	if( C2B .gt. 1 ) then
	  fail = 4
	  return
	endif
	CB2 = .5D0*(1 + C2B)
	CB = sqrt(CB2)
	SB2 = (1 - CB)*(1 + CB)
	TB2 = SB2/CB2
	TB = sqrt(TB2)
	SB = CB*TB
	S2B = 2*TB*CB2

	SA = -CB
	CA = SB
	SA2 = CB2
	CA2 = SB2
	S2A = -S2B
	C2A = -C2B
	SAB = -C2B
	CAB = S2B
	SBA = 1
	SBA2 = 1
	CBA = 0
	CBA2 = 0
#endif
	end


*-----------------------------------------------------------------------

#if HIGGS_MASSES != FEYNHIGGS && HIGGS_MASSES != TREE

	subroutine HiggsCorr(fail)
	implicit none
	integer fail

#include "decl.h"

	RealType MTr2, Qsusy, Lam
	RealType Xt, topstop, toplog, mix
	RealType Pb, Pf, Pg, Pg_, P1h, P2h, P2h_
	RealType pref, pref2, tmp, tmplog
	RealType sig11, sig12, sig22
	RealType avgMH2, deltaMH2

	RealType MtLR, MbLR
	equivalence (Xf(3,3), MtLR)
	equivalence (Xf(4,3), MbLR)

	integer Nc, Ng
	RealType Qt, Qb
	parameter (Nc = 3, Ng = 3, Qt = 2/3D0, Qb = -1/3D0)

* this is the running top mass:
	MTr2 = MT2/(1 + 4/(3*pi)*AlfasMT)**2

#define SusyScale(mt2) sqrt((MSS2(1,3,3) + mt2)*(MSS2(2,3,3) + mt2))

#if HIGGS_MASSES == SIMPLE

* Simple approximation: (for complex and/or real case)
	Qsusy = SusyScale(MTr2)
	sig22 = -3*GF/(sqrt2*pi**2)*MTr2**2/SB2*log(Qsusy/MTr2)

#else

* FeynHiggsFast approximation: hep-ph/9903404 (only for real case)
	Qsusy = SusyScale(MT2)
	mix = MtLR**2/Qsusy

* The one-loop top/stop contributions:
	Lam = 1/8D0 - SW2*(1/3D0 - 4/9D0*SW2)
	topstop = MT2/Qsusy
	toplog = log(topstop)
	tmp = MZ2/MT2
	sig11 = GF*sqrt2/pi**2*MZ2**2*Lam*CB2 * toplog
	sig12 = -GF*sqrt2/pi**2*MZ2/TB *
     &    (-3/8D0*MT2 + MZ2*Lam*SB2) * toplog
	sig22 = GF*sqrt2/(8*pi**2)*MT2**2/SB2 *
     &    ( tmp*(-2 + 11/10D0*tmp)
     &       + (12 + SB2*tmp*(-6 + 8*Lam*SB2*tmp)) * toplog
     &       + mix*(-12 + 4*tmp + 6*topstop
     &         + mix*(1 + topstop*(-4 + 3*topstop)
     &           + mix*topstop
     &             *(3/5D0 + topstop*(-12/5D0 + 2*topstop)
     &             + mix*topstop
     &               *(3/7D0 + topstop*(-12/7D0 + 3/2D0*topstop))
     &       ))) )

* The dominant two-loop top/stop contributions:
	toplog = log(MTr2/Qsusy)
	tmp = (MSf2(2,3,3) - MSf2(1,3,3))/MTr2
     &    * (USf(1,1,3,3)*USf(2,1,3,3))**2
	tmplog = log(MSf2(2,3,3)/MSf2(1,3,3))
	Xt = tmp*(
     &    tmp*(2 - (MSf2(2,3,3) + MSf2(1,3,3))/
     &             (MSf2(2,3,3) - MSf2(1,3,3))*tmplog)
     &    + 2*tmplog)
	tmplog = log(MSf(2,3,3)*MSf(1,3,3)/MTr2)
	sig22 = sig22 + MTr2**2/SB2 * (
     &    + GF*sqrt2/pi**3*AlfasMT*(toplog*(3*toplog - 6)
     &      - 6*sign(sqrt(mix), MtLR) + mix*(-3*toplog + 3/4D0*mix))
     &    - 9*GF**2/(16*pi**4)*MTr2* tmplog*(Xt + tmplog) )

* The one-loop leading-log contributions from all other sectors:
* [NB: MSQ is used here instead of MSusy.]
	Pb = Nc*(1 + 4*Qb*SW2*(1 + 2*Qb*SW2))
	Pf = Nc*(Ng - 1)*(2 - SW2*(4 - 8*(Qt**2 + Qb**2)*SW2))
     &    + Ng*(2 - SW2*(4 - 8*SW2))
	Pg = -44 + SW2*(106 - 62*SW2)
	Pg_ = 10 + SW2*(34 - 26*SW2)
	P1h = (1 - 2*SW2*CW2 - 9*C2B**2)*C2B**2
	P2h = -10 + 2*SW2*CW2
	P2h_ = 8 - SW2*(22 - 10*SW2)
	tmplog = log(MSS2(1,3,3)/MZ2)
	tmp = MB2/(MZ2*CB2)
	pref = GF*MZ2**2/(12*sqrt2*pi**2)
	pref2 = GF*Nc/(4*sqrt2*pi**2)*MB2/MSS2(1,3,3)
	sig11 = sig11
     &    - pref*CB2
     &      *(6*Nc*tmp*(2*tmp - 1) + Pb + Pf + Pg + P2h)*tmplog
     &    - pref2*Af(4,3,3)
     &      *(4*MB2*MbLR/CB2*(1 - Af(4,3,3)*MbLR/(12*MSS2(1,3,3)))
     &        - MZ2*(MbLR + Af(4,3,3)/3D0))
	sig12 = sig12
     &    - pref*SB*CB*(3*Nc*tmp - Pb - Pf - Pg_ - P2h_)*tmplog
     &    + .5D0*pref2
     &      *(4*MB2*MUE*MbLR/CB2*(1 - Af(4,3,3)*MbLR/(6*MSS2(1,3,3)))
     &        - MZ2*TB*(MbLR*(Af(4,3,3) + MUE/TB)
     &                  + (MUE**2 + Af(4,3,3)**2)/3D0))
	sig22 = sig22
     &    - pref*SB2*(Pb + Pf + Pg + P2h)*tmplog
     &    + pref2*MUE
     &      *(MB2*MUE*MbLR**2/(3*CB2*MSS2(1,3,3))
     &        + MZ2*TB*(MbLR + MUE*TB/3D0))
	if( MA02 .gt. MZ2 ) then
	  tmplog = log(MA02/MZ2)
	  sig11 = sig11 - pref*CB2*(P1h - P2h)*tmplog
	  sig12 = sig12 - pref*SB*CB*(P1h + P2h_)*tmplog
	  sig22 = sig22 - pref*SB2*(P1h - P2h)*tmplog
	endif
#endif

	avgMH2 = .5D0*(MA02 + MZ2 - sig22 - sig11)
	deltaMH2 = .5D0*sqrt(
     &    (C2B*(MA02 - MZ2) + sig11 - sig22)**2 +
     &    (S2B*(MA02 + MZ2) + 2*sig12)**2 )
	Mh02 = avgMH2 - deltaMH2
	MHH2 = avgMH2 + deltaMH2

	if( Mh02 .lt. 0 ) then
	  Error(fail, "Negative Mh0^2")
	  return
	endif

	CA2 = .5D0*(SB2*MA02 + CB2*MZ2 - Mh02 - sig11)/deltaMH2
	CA = sqrt(CA2)
	SA = -.5D0*(SB*CB*(MA02 + MZ2) + sig12)/(CA*deltaMH2)

	if( MA0 .le. 250 .and. MSS(1,3,3) .ge. 250 ) then
	  MHp2 = MHp2 +
     &      Alfa*MW2/(12*pi*SW2)*
     &        (Nc*(Ng - 1) + Ng - 9 + 15*SW2/CW2)*
     &        log(MSS2(1,3,3)/MW2) +
     &      Nc*Alfa/(8*pi*SW2*MW2)*
     &        (2*MTr2*MB2/(SB2*CB2)
     &          - MW2*(MTr2/SB2 + MB2/CB2 - 2/3D0*MW2))*
     &        log(MSS2(1,3,3)/MTr2)
	endif
	end

#endif


*-----------------------------------------------------------------------

#if HIGGS_MASSES == FEYNHIGGS

	subroutine FeynHiggs(fail)
	implicit none
	integer fail

#include "decl.h"

	integer mssmpart, fieldren, tanbren, higgsmix, p2approx
	integer looplevel, runningMT, botResum, tlCplxApprox
	parameter (mssmpart = 4)
	parameter (fieldren = 0)
	parameter (tanbren = 0)
	parameter (higgsmix = 2)
	parameter (p2approx = 0)
	parameter (looplevel = 2)
	parameter (runningMT = 1)
	parameter (botResum = 1)
	parameter (tlCplxApprox = 3)

	RealType scalefactor
	RealType Qtau, Qt, Qb
	parameter (scalefactor = 1)
	parameter (Qtau = 0)
	parameter (Qt = 0)
	parameter (Qb = 0)

	ComplexType SAeff

	call FHSetFlags(fail, mssmpart, fieldren, tanbren, higgsmix,
     &    p2approx, looplevel, runningMT, botResum, tlCplxApprox)
	if( fail .ne. 0 ) return

	call FHSetSMPara(fail,
     &    1/Alfa, AlfasMZ, GF,
     &    ME, MU, MD, MM, MC, MS, ML, MBatMB,
     &    MW, MZ,
#ifdef NO_CKM
     &    0D0, 0D0, 0D0, 0D0)
#else
     &    CKMlambda, CKMA, CKMrhobar, CKMetabar)
#endif
	if( fail .ne. 0 ) return

	call FHSetPara(fail, scalefactor,
     &    MT, TB, MA0, MHp,
     &    MSS(1,2,3), MSS(2,2,3), MSS(1,3,3), MSS(2,3,3), MSS(2,4,3),
     &    MSS(1,2,2), MSS(2,2,2), MSS(1,3,2), MSS(2,3,2), MSS(2,4,2),
     &    MSS(1,2,1), MSS(2,2,1), MSS(1,3,1), MSS(2,3,1), MSS(2,4,1),
     &    MUE,
     &    Af(2,3,3), Af(3,3,3), Af(4,3,3),
     &    Af(2,2,2), Af(3,2,2), Af(4,2,2),
     &    Af(2,1,1), Af(3,1,1), Af(4,1,1),
     &    Mino1, Mino2, Mino3,
     &    Qtau, Qt, Qb)
        if( fail .ne. 0 ) return

#ifdef NMFV
	call FHSetNMFV(fail,
     &    deltaLL12, deltaLL23, deltaLL13,
     &    deltaLRuc, deltaLRct, deltaLRut,
     &    deltaRLuc, deltaRLct, deltaRLut,
     &    deltaRRuc, deltaRRct, deltaRRut,
     &    deltaLRds, deltaLRsb, deltaLRdb,
     &    deltaRLds, deltaRLsb, deltaRLdb,
     &    deltaRRds, deltaRRsb, deltaRRdb)
	if( fail .ne. 0 ) return
#endif

	call FHHiggsCorr(fail, MHiggs, SAeff, UHiggs, ZHiggs)

	MHiggs2(1) = MHiggs(1)**2
	MHiggs2(2) = MHiggs(2)**2
	MHiggs2(3) = MHiggs(3)**2
	MHiggs2(4) = MHiggs(4)**2
	end

#endif

* CTMomDecode.F
* form a linear combination of momenta in CutTools conventions
* and return it as a Minkowski four-vector
* the momenta's (integer*1) prefactors are encoded as the
* bytes of an integer*8
* this file is part of FormCalc
* last modified 7 Dec 10 th


	subroutine CTMomDecode(code, p)
	implicit none
	integer*8 code
	double precision p(0:3)

	integer i
	double complex a(2,2)

	integer*8 c
	integer*1 f
	equivalence (f, c)

	double complex vec(2,2, 1)
	common /vectors/ vec

	a(1,1) = 0
	a(2,1) = 0
	a(1,2) = 0
	a(2,2) = 0

	c = code
	i = 1

	do while( c .ne. 0 )
	  i = i + 8
	  a(1,1) = a(1,1) + f*vec(1,1,i)
	  a(2,1) = a(2,1) + f*vec(2,1,i)
	  a(1,2) = a(1,2) + f*vec(1,2,i)
	  a(2,2) = a(2,2) + f*vec(2,2,i)
	  c = ishft(c, -8)
	enddo

	p(0) = .5D0*DBLE(a(1,1) + a(2,2))
	p(3) = .5D0*DBLE(a(1,1) - a(2,2))
	p(1) = .5D0*DBLE(a(2,1) + a(1,2))
	p(2) = .5D0*DIMAG(a(2,1) - a(1,2))
	end

* CTmpnum.F
* a dummy multiprecision numerator function
* this file is part of FormCalc
* last modified 2 Dec 10 th


	subroutine CTmpnum(q1in, res)
	implicit none
	double precision q1in(0:3)
	double complex res

	integer ini
	data ini /0/
	save ini

	if( ini .eq. 0 ) then
	  print *, "MP version not yet available"
	  ini = 1
	endif

	res = 0
	end

#include "types.h"


	RealType function CompAZ(x, E, icase)
	implicit none
	RealType x, E
	integer icase

* Input parameters:
* -----------------
*
*   x             Fraction of beam energy carried by photon  ( 0 < x < 1 )
*
*   E             Electron beam energy [GeV]
*
*   icase         Choice of output distribution:
*
*   icase = 0     Full spectra - sum of three contributions
*           1     Main contribution from direct Compton process
*           2     Contribution from scattering with 2 photons
*           3     Contribution from scattering on secondary electrons
*
*          10     Polarization of the full spectra
*          11     Polarization of the 1st component (direct Compton)
*          12     Polarization of the 2nd component (two photon)
*          13     Polarization of the 3rd component (secondary electron)
*
*          20     Effective z parameter
*          21     maximum x value for direct Compton
*          22     maximum x value for scattering with 2 photons

* Parameters of the distribution, partly fitted to the spectra from V. Telnov
	RealType par(14)
	data par /
     &    18.08800D0    ,                         ! Laser parameter
     &      .06594662D0 ,    .7060851D0 ,         ! Nonlinear corrections
     &      .7115863D0  ,   -.6776124D0 ,  0D0 ,  ! Total normalization
     &      .5540019D0  ,  37.38912D0   ,         ! 2nd component fraction
     &      .7257064D0  ,    .517959D0  ,         ! 3rd component fraction
     &     3.315865D0   ,    .387423D0  ,         ! Corrections
     &      .85D0       ,   1.00D0        /       ! Polarizations

	RealType Ee, z0, xi, z
	RealType Tot, Tot2, Tot3
	RealType Br2, gpow, pole, poll, pol, pole2

	RealType xmax, xmax2, g
	RealType gflux1, gflux2, gflux3, gflux
	RealType pol1, pol2, pol3, ptot
	RealType g1, g2, dg, p1, p2, dp
	RealType ymin, ymin2, ymax, y1, y2, dy

	logical DoPolar

	integer iy, ny
	parameter (ny = 100)

	RealType CompAZc, CompAZp
	external CompAZc, CompAZp

* Check input flag
	if( .NOT. ((icase .GE. 0  .and. icase .LE. 3 ) .or.
     &             (icase .GE. 10 .and. icase .LE. 13) .or.
     &             (icase .GE. 20 .and. icase .LE. 22)) ) then
	  print *, "CompAZ: Invalid distribution flag ", icase
	  CompAZ = 0
	  return
	endif

* Check input energy
	if( E .lt. 50 .or. E .gt. 500 ) then
	  print *, "CompAZ: Beam energy outside range 50..500: ", E
	  CompAZ = 0
	  return
	endif

* Polarisation calculation flag

	DoPolar = (icase .GE. 10 .and. icase .LE. 13) 

* Set parameter values for given energy
* -------------------------------------

* Beam energy in TeV
	Ee = e/1000D0

* Nominal value of z = 4*Ee*El/me^2
	z0 = par(1)*Ee

* correction nonlinear effects
	xi = par(2) + par(3)*Ee

* effective z
	z = z0/(1 + xi)

* Maximum x values for different contributions
	xmax = z/(1 + z)
	xmax2 = 2*z/(1 + 2*z)

	if( icase .eq. 20 ) then
	  CompAZ = z
	  return
	else if( icase .eq. 21 ) then
	  CompAZ = xmax
	  return
	else if( icase .eq. 22 ) then
	  CompAZ = xmax2
	  return
	endif

* normalization of main compton component
	Tot = par(4) + Ee*(par(5) + Ee*par(6))

* normalization of additional contributions
	Tot2 = Tot*par(7)*(1 - exp(-xi*xi*par(8)))
	Tot3 = Tot*(par(9) + Ee*par(10))

* Corrections to Compton spectra
	Br2 = par(11)
	gpow = par(12)

* Electron/laser polarisation
	Pole = par(13)
	poll = par(14)

	Pol = Pole*poll

* Leading Compton term
* --------------------

	gflux1 = 0
	pol1 = 0

	if( x .gt. 0 .and. x .le. xmax .and. Tot .gt. 0 ) then
	  gflux1 = CompAZc(x, z, Pol)
	  g = z/x - z - 1
	  if( g .gt. 0 ) then
	    g = sqrt(g)
	  else
	    g = 0
	  endif

	  gflux1 = gflux1*exp( -Br2 * g*g/8D0 )

	  if( DoPolar ) pol1 = CompAZp(x, poll, Pole, z)
	endif

	if( icase .eq. 1 ) then
	   CompAZ = Tot*gflux1
	   return
	else if( icase .eq. 11) then
	   CompAZ = pol1
	   return
	endif

* Scattering on 2 photons
* -----------------------

	gflux2 = 0
	pol2 = 0
	
	if( x .gt. 0 .and. x .lt. xmax2 .and. Tot2 .gt. 0 ) then
	  gflux2 = CompAZc(x, 2*z, Pol)
	  g = 2*z/x - 2*z - 1
	  if( g .gt. 0 ) then
	    g = sqrt(g)
	  else
	    g = 0
	  endif

	  gflux2 = gflux2*exp( -Br2 * g*g/8D0 )* g**gpow

	  if( DoPolar .and. x .gt. xmax ) then
	    pol2 = CompAZp(x, poll, Pole, 2*z)
	  else if( DoPolar ) then
	    pol2 = CompAZp(xmax, poll, Pole, 2*z)
	  endif
	endif

	if( icase .eq. 2 ) then
	  CompAZ = Tot2*gflux2
	  return
	else if( icase .eq. 12 ) then
	  CompAZ = pol2
	  return
	endif

* Electron rescattering
* ---------------------

	gflux3 = 0
	pol3 = 0
	
	if( x .gt. 0 .and. x .le. xmax .and. Tot3 .gt. 0 ) then
	  ymin = .5D0*x*(1 + sqrt(4/x/z + 1))

	  ymin2 = 1/(z + 1)
	  if( ymin2 .gt. ymin ) ymin = ymin2

	  ymax = 1

	  if( ymax .gt. ymin ) then
	    pole2 = 0

	    y1 = ymin
	    y2 = y1

* To avoid numerical problems
	    y1 = y1*1.0001D0

	    g1 = log(y1*z + 1)/log(z + 1)/y1 *
     &        CompAZc(x/y1, y1*z, pole2*poll)*CompAZc(1 - y1, z, Pol)

	    if( DoPolar ) p1 = CompAZp(x/y1, poll, pole2, y1*z)

	    dy = (ymax - ymin)/ny

	    do iy = 1, ny       
	      y2 = y2 + dy
	      g2 = log(y2*z + 1)/log(z + 1)/y2 *
     &          CompAZc(x/y2, y2*z, pole2*poll)*CompAZc(1 - y2, z, Pol)
	      
	      dg = .5D0*(g1 + g2)*dy
	      gflux3 = gflux3 + dg

	      if( DoPolar ) then
	        p2 = CompAZp(x/y2, poll, pole2, y2*z)
	        dp = .5D0*(g1*p1 + g2*p2)*dy
	        pol3 = pol3 + dp
	        p1 = p2
	      endif

	      y1 = y2
	      g1 = g2
	    enddo
	  endif
	endif

	if( icase .eq. 3 ) then
	  CompAZ = Tot3*gflux3
	  return
	else if( icase .eq. 13 .and. gflux3 .gt. 0 ) then
	  CompAZ = pol3/gflux3
	  return
	else if( icase .eq. 13 ) then
	  CompAZ = 0
	  return
	endif

	gflux = Tot*gflux1 + Tot2*gflux2 + Tot3*gflux3

	if( icase .eq. 0 ) then
	  CompAZ = gflux
	else if( gflux .gt. 0 .and. icase .eq. 10 ) then
	  ptot = Tot*gflux1*pol1 + Tot2*gflux2*pol2 + Tot3*pol3
	  CompAZ = ptot/gflux
	else
	  CompAZ = 0
	endif
	end


************************************************************************
** 'Ideal' spectrum of compton backscattered photons

	RealType function CompAZc(x, z, Pol)
	implicit none
	RealType x, z, Pol

	RealType xmax, l, r, y, gflux, norm

	xmax = z/(1 + z)

	if( x .lt. 0 .or. x .gt. xmax ) then
	  CompAZc = 0
	  return
	endif

* Flux normalisation (corrected!  formula in paper is wrong)
	l = log(1 + z)
	norm = (16 + z*(32 + z*(18 + z)))/(2*z*(z + 1)**2) +
     &    (1 - 4/z - 8/z**2)*l +
     &    Pol*(2 + z*z/(2*(z + 1)**2) - (1 + 2/z)*l)

* Additional variables, for easier calculation
	r = x/(1 - x)
	y = 1 - x + 1/(1 - x)

* Photon flux, as given in hep-ph/9508397
	gflux = y + 4*r/z*(r/z - 1) + Pol*r*(2 - x)*(2*r/z - 1)

	CompAZc = gflux/norm
	end


************************************************************************
** Calculate spectrum of compton backscattered photons

	RealType function CompAZp(x, Pl, Pb, z)
	implicit none
	RealType x, Pl, Pb, z

	RealType xmax, r, y, gflux, gpol, Pol

	xmax = z/(1 + z)

	if( x .lt. 0 .or. x .gt. xmax ) then
	  CompAZp = 0
	  return
	endif

	Pol = Pl*Pb
	r = x/(1 - x)
	y = 1 - x + 1/(1 - x)

* Photon polarized flux
	gpol = Pb*r*(1 + (1 - x)*(2*r/z - 1)**2) + Pl*y*(2*r/z - 1)

* Photon flux
	gflux = y + 4*r/z*(r/z - 1) + Pol*r*(2 - x)*(2*r/z - 1)

	CompAZp = gpol/gflux
	end

* PrintVec.F
* print out the Minkowskian representation of a vector
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


* Note: the arguments a, b specify the vector's position in
* the array vec, NOT the vector itself.  The macros k, e, ec, s
* (defined in util.h) convert from 1...LEGS to a, b.

	subroutine PrintVec(a, s)
	implicit none
	integer a
	character*(*) s

	ComplexType vec(2,2, 1)
	common /vectors/ vec

#define A(i,j) vec(i,j,a)

	print *, s, " =", .5D0*(A(1,1) + A(2,2))
	print *, "    ", .5D0*(A(1,2) + A(2,1))
	print *, "    ", (0D0,.5D0)*(A(1,2) - A(2,1))
	print *, "    ", .5D0*(A(1,1) - A(2,2))
	end

* run.F
* defines parameter settings for one run, then includes main.F
* this file is part of FormCalc
* last modified 2 Feb 06 th


* Whether to run in debugging mode

#define DEBUG


* Uncomment the following to check UV- and IR-finiteness

c#define DELTA 1D7
c#define MUDIM 1D100
c#define LAMBDA 1D10

* The following sets all ren. constants to zero for debugging

c#define CalcRenConst ZeroRenConst


* The model initialization code is included here.  Options for the
* model_XXX.F file (e.g. NO_SQUARK_MIXING for model_mssm.F) must be
* defined before the #include line.

* options for model_sm.F:
c#define NO_CKM

* options for model_mssm.F:
c#define NO_SQUARK_MIXING
c#define HIGGS_MASSES TREE
c#define HIGGS_MASSES SIMPLE
c#define HIGGS_MASSES FEYNHIGGS
c#define SM_HIGGS
c#define FLAVOUR_VIOLATION
c#define NO_EXCLUSION_LIMITS

* options for model_thdm.F:
c#define MODEL_TYPE_I
c#define MODEL_TYPE_II
c#define NO_EXCLUSION_LIMITS

#define MODEL "model_mssm.F"


* You can define LOOP[1..15] for scanning the parameter space.
* LOOP1 will be the outermost loop.  Do not remove #defines which
* are not needed.  Note that all loops terminate at label 1, e.g.
*	#define LOOP1 do 1 MH = 100, 500, 200
* For a fixed parameter, use something like #define LOOP1 MH = 300.

#define LOOP1 TB = 1.5D0
#define LOOP2 MA0 = 700
#define LOOP3 MSusy = 1000
#define LOOP4 MUE = -1000
#define LOOP5 M_2 = 100
#define LOOP6 At = MSusy
#define LOOP7 Ab = At
#define LOOP8 Atau = At
#define LOOP9
#define LOOP10
#define LOOP11
#define LOOP12
#define LOOP13
#define LOOP14
#define LOOP15


* PRINT[1..5] defines output statements with which changes in 
* parameters (typically the ones included in the scan) can be 
* written to the output file and screen.  For example,
*	PRINT "MH=", MH, "MT=", MT
* writes out the values of MH and MT in each pass of the loop.
* Only real parameters are allowed (use DBLE and DIMAG for complex
* ones) and a string identifier must be given as in the example above.

#define PRINT1 SHOW "TB", TB
#define PRINT2 SHOW "MA0", MA0
#define PRINT3 SHOW "M_2", ReM_2
#define PRINT4 SHOW "MUE", ReMUE
#define PRINT5 SHOW "MSusy", MSusy
#define PRINT6 SHOW "At", ReAt
#define PRINT7
#define PRINT8
#define PRINT9
#define PRINT10
#define PRINT11
#define PRINT12
#define PRINT13
#define PRINT14
#define PRINT15


* Cuts and increments.  May be defined in terms of sqrtS, the CMS energy.

#define SQRTSSTEP 10

* a) 2-particle phase space:

#define COSTHCUT .01D0
#ifdef DEBUG
#define XCOSTHSTEP 1/3D0
#else
#define XCOSTHSTEP .02D0
#endif

* b) 3-particle phase-space:

#define XMREM5STEP .1D0
#define E5MIN ESOFTMAX
#define COSTH5CUT 0


* The integration parameters:
* - the desired relative and absolute accuracy

#define RELACCURACY 1D-3
#define ABSACCURACY 1D-10

* The multidimensional integration routines also need

#define METHOD DIVONNE
#define VERBOSE 1
#define MINEVAL 0
#define MAXEVAL 50000

* for Vegas:
#define NSTART 1000
#define NINCREASE 500

* for Suave:
#define NNEW 1000
#define FLATNESS 50

* for Divonne:
#define KEY1 47
#define KEY2 1
#define KEY3 1
#define MAXPASS 5
#define BORDER 1D-6
#define MAXCHISQ 10
#define MINDEVIATION .25D0

* for Cuhre:
#define KEY 0

* Now go for it:

#include "main.F"

* Split.F
* splits a parent momentum into two child momenta
* loosely based on code by T. Fritzsche
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


* The first child momentum is stored in vector i, the second
* replaces the input variables such that repeated invocation
* builds up the entire phase-space.

* on entry:
*   minv = available invariant mass
*   msum = sum of particle masses 1..n
*   p (ex,ey,ez) = parent momentum
*   xmrem = the fraction of invariant mass that goes into
*     child particles 2..n
*   xcosth and xphi, the fractions of costh and phi which
*     specify the direction relative to (ex,ey,ez) in the CMS
*     frame of the child particles

* on exit:
*   vector i is assigned child particle 1
*   minv = invariant mass remaining for child particles 2..n
*   msum = sum of particle masses 2..n
*   p (ex,ey,ez) = sum of momenta of child particles 2..n


* NB: the following enumeration must match the one in xsection.h
#define Var(v) v(1)
#define Show(v) v(2)
#define Lower(v) v(3)
#define Upper(v) v(4)
#define Step(v) v(5)
#define CutMin(v) v(6)
#define CutMax(v) v(7)

#define Test(c, m) iand(key, (m)*(c)) .ne. 0
#define Zero(c, m) key = iand(key, not((m)*(c)))
#define MomQ(m) ibits(key, m-1, 1)

#define CUT_MIN 1
#define CUT_MAX 2

#define CUT_COSTH 4
#define CUT_COSTHCMS 16
#define CUT_COSTH_E 64
#define CUT_COSTH_K 65
#define CUT_MREM 256
#define CUT_MREM_E 1024
#define CUT_MREM_K 1025
#define CUT_MREM_ET 4096
#define CUT_MREM_KT 4097
#define CUT_MREM_RAP 16384
#define CUT_MREM_PRAP 16385

#define CUT_ANY CUT_MIN + CUT_MAX
#define CUT_COSTH_INDIRECT CUT_COSTHCMS + CUT_COSTH_E
#define CUT_MREM_INDIRECT CUT_MREM_E + CUT_MREM_ET + CUT_MREM_RAP

	subroutine Split(i, m, p, ex, ey, ez, minv, msum,
     &    fac, cutkey, xmrem, xcosth, xphi)
	implicit none
	integer i, cutkey
	RealType m, p, ex, ey, ez, minv, msum
	RealType fac, xmrem(*), xcosth(*), xphi(*)

	RealType costh, sinth, cosphi, sinphi
	RealType bmrem(2), bcosth(2)
	RealType fxz, fyz, fxy
	RealType fx, fy, fz
	RealType nx, ny, nz
	RealType ref, cut, c0, c1, c2, a, b
	RealType r, r0, r0costh, rz, r1
	RealType m2, mrem, k, k10, q, qe, qn
	integer key

	RealType rpart(0:1)
	equivalence (rpart(0), r0), (rpart(1), r)

	RealType pi
	parameter (pi = 3.1415926535897932384626433832795029D0)

	RealType ksq, mremsq
	ksq() = (2*c1*(sqrt(c0*(c0 + c2*m2) + (c1*m2)**2) - c1*m2) -
     &    c0*c2)/((2*c1 - c2)*(2*c1 + c2))
	mremsq() = m2 + minv*(minv - 2*sqrt(ksq() + m2))

	key = cutkey

* simultaneous indirect cuts on mrem and costh are not allowed:
	if( Test(CUT_COSTH_INDIRECT, CUT_ANY) .and.
     &      Test(CUT_MREM_INDIRECT, CUT_ANY) )
     &    stop "Illegal key"

* rotate the unit vector e = (ex,ey,ez) into the desired direction:
* rotate by theta in the e-n-plane and then by phi around e.

	if( Step(xphi) .eq. 0 ) fac = 2*pi*fac
	Show(xphi) = 2*pi*Var(xphi)
	cosphi = cos(Show(xphi))
	sinphi = sin(Show(xphi))

	fx = ex
	fy = ey
	fz = ez
	fxz = fx**2 + fz**2
	fyz = fy**2 + fz**2
	if( fyz .lt. fxz ) then
	  fxz = sqrt(fxz)
	  nx = (-cosphi*fx*fy - sinphi*fz)/fxz
	  ny = cosphi*fxz
	  nz = (-cosphi*fy*fz + sinphi*fx)/fxz
	else
	  fyz = sqrt(fyz)
	  nx = cosphi*fyz
	  ny = (-cosphi*fx*fy + sinphi*fz)/fyz
	  nz = (-cosphi*fx*fz - sinphi*fy)/fyz
	endif

	r = p/minv
	r0 = sqrt(r**2 + 1)
	m2 = m**2

	msum = msum - m
	bmrem(1) = msum
	bmrem(2) = minv - m

* direct cut on mrem
	if( Test(CUT_MREM, CUT_MIN) ) then
	  bmrem(1) = max(bmrem(1), CutMin(xmrem))
	  Zero(CUT_MREM, CUT_MIN)
	endif
	if( Test(CUT_MREM, CUT_MAX) ) then
	  bmrem(2) = min(bmrem(2), CutMax(xmrem))
	  Zero(CUT_MREM, CUT_MAX)
	endif

	bcosth(1) = -1
	bcosth(2) = 1

* direct cut on costh
	if( Test(CUT_COSTH, CUT_MIN) ) then
	  bcosth(1) = max(bcosth(1), CutMin(xcosth))
	  Zero(CUT_COSTH, CUT_MIN)
	endif
	if( Test(CUT_COSTH, CUT_MAX) ) then
	  bcosth(2) = min(bcosth(2), CutMax(xcosth))
	  Zero(CUT_COSTH, CUT_MAX)
	endif

* indirect cuts on costh:
* - costh(CMS) cut
* - energy cut
* - momentum cut

	if( Test(CUT_COSTH_INDIRECT, CUT_ANY) ) then
	  mrem = bmrem(1) + Var(xmrem)*(bmrem(2) - bmrem(1))
	  k10 = .5D0*(minv - (mrem - m)*(mrem + m)/minv)
	  k = sqrt((k10 - m)*(k10 + m))

	  if( Test(CUT_COSTHCMS, CUT_MIN) ) then
	    if( k .ne. 0 ) then
	      costh = CutMin(xcosth)
	      sinth = (1 - costh)*(1 + costh)
	      if( sinth .ge. 0 ) then
	        sinth = sqrt(sinth)
	        cut = max((k - m*r*sinth)*(k + m*r*sinth), 0D0)
	        cut = (costh*sqrt(cut) - k10*r0*r*sinth**2)/
     &            (k*((r*sinth)**2 + 1))
	        bcosth(1) = max(bcosth(1), cut)
	      endif
	    endif
	    Zero(CUT_COSTHCMS, CUT_MIN)
	  else if( Test(CUT_COSTH_E, CUT_MIN) ) then
	    if( k*r .ne. 0 ) then
	      cut = CutMin(xcosth)
	      if( MomQ(CUT_MIN) .ne. 0 ) cut = sqrt(cut**2 + m2)
	      bcosth(1) = max(bcosth(1), (cut - k10*r0)/(k*r))
	    endif
	    Zero(CUT_COSTH_K, CUT_MIN)
	  endif

	  if( Test(CUT_COSTHCMS, CUT_MAX) ) then
	    if( k .ne. 0 ) then
	      costh = CutMin(xcosth)
	      sinth = (1 - costh)*(1 + costh)
	      if( sinth .ge. 0 ) then
	        sinth = sqrt(sinth)
	        cut = max((k - m*r*sinth)*(k + m*r*sinth), 0D0)
	        cut = (costh*sqrt(cut) - k10*r0*r*sinth**2)/
     &            (k*((r*sinth)**2 + 1))
	        bcosth(2) = min(bcosth(2), cut)
	      endif
	    endif
	    Zero(CUT_COSTHCMS, CUT_MAX)
	  else if( Test(CUT_COSTH_E, CUT_MAX) ) then
	    if( k*r .ne. 0 ) then
	      cut = CutMax(xcosth)
	      if( MomQ(CUT_MAX) .ne. 0 ) cut = sqrt(cut**2 + m2)
	      bcosth(2) = min(bcosth(2), (cut - k10*r0)/(k*r))
	    endif
	    Zero(CUT_COSTH_K, CUT_MAX)
	  endif
	endif

	bcosth(2) = bcosth(2) - bcosth(1)
	if( bcosth(2) .lt. 0 ) then
	  fac = 0
	  return
	endif
	if( Step(xcosth) .eq. 0 ) fac = fac*bcosth(2)
	costh = bcosth(1) + Var(xcosth)*bcosth(2)
	Show(xcosth) = costh

	r0costh = r0*costh
	sinth = sqrt((1 - costh)*(1 + costh))

* indirect cuts on mrem:
* - energy cut
* - momentum cut
* - transverse-energy cut
* - transverse-momentum cut
* - rapidity cut
* - pseudo-rapidity cut

	if( Test(CUT_MREM_INDIRECT, CUT_ANY) ) then
	  rz = r*fz
	  r1 = sqrt(r**2*(1 + costh**2) + 1)

	  if( Test(CUT_MREM_E, CUT_MIN) ) then
	    c1 = r*r0costh
	    c2 = r1**2
	    ref = m*rpart(MomQ(CUT_MIN))
	    if( CutMin(xmrem) .gt. ref ) then
	      c0 = (CutMin(xmrem) - ref)*(CutMin(xmrem) + ref)
	      cut = mremsq()
	      if( cut .gt. 0 ) bmrem(2) = min(bmrem(2), sqrt(cut))
	    endif
	    Zero(CUT_MREM_K, CUT_MIN)
	  else if( Test(CUT_MREM_ET, CUT_MIN) ) then
	    fxy = fx**2 + fy**2
	    c1 = r*(r0costh*fxy - sinth*fz*nz)
	    a = sqrt((r1 - rz)*(r1 + rz))
	    b = r0costh*fz + sinth*nz
	    c2 = (a - b)*(a + b)
	    ref = m*sqrt(r**2*fxy + (1 - MomQ(CUT_MIN)))
	    if( CutMin(xmrem) .gt. ref ) then
	      c0 = (CutMin(xmrem) - ref)*(CutMin(xmrem) + ref)
	      cut = mremsq()
	      if( cut .gt. 0 ) bmrem(2) = min(bmrem(2), sqrt(cut))
	    endif
	    Zero(CUT_MREM_KT, CUT_MIN)
	  else if( Test(CUT_MREM_RAP, CUT_MIN) ) then
	    cut = tanh(CutMin(xmrem))
	    ref = rpart(MomQ(CUT_MIN))*cut
	    if( ref .gt. rz ) then
	      c0 = m2*(ref - rz)*(ref + rz)
	      c1 = r*(sinth*fz*nz - r0costh*(cut - fz)*(cut + fz))
	      c2 = (r0costh*fz + sinth*nz)**2 -
     &          (cut*r1 - rz)*(cut*r1 + rz)
	      cut = mremsq()
	      if( cut .gt. 0 ) then
	        cut = sqrt(cut)
	        if( c2 .gt. 0 ) then
	          bmrem(1) = max(bmrem(1), cut)
	        else
	          bmrem(2) = min(bmrem(2), cut)
	        endif
	      endif
	    endif
	    Zero(CUT_MREM_PRAP, CUT_MIN)
	  endif

	  if( Test(CUT_MREM_E, CUT_MAX) ) then
	    c1 = r*r0costh
	    c2 = r1**2
	    ref = m*rpart(MomQ(CUT_MAX))
	    if( CutMax(xmrem) .gt. ref ) then
	      c0 = (CutMax(xmrem) - ref)*(CutMax(xmrem) + ref)
	      cut = mremsq()
	      if( cut .gt. 0 ) bmrem(1) = max(bmrem(1), sqrt(cut))
	    endif
	    Zero(CUT_MREM_K, CUT_MAX)
	  else if( Test(CUT_MREM_ET, CUT_MAX) ) then
	    fxy = fx**2 + fy**2
	    c1 = r*(r0costh*fxy - sinth*fz*nz)
	    a = sqrt((r1 - rz)*(r1 + rz))
	    b = r0costh*fz + sinth*nz
	    c2 = (a - b)*(a + b)
	    ref = m*sqrt(r**2*fxy + (1 - MomQ(CUT_MAX)))
	    if( CutMax(xmrem) .gt. ref ) then
	      c0 = (CutMax(xmrem) - ref)*(CutMax(xmrem) + ref)
	      cut = mremsq()
	      if( cut .gt. 0 ) bmrem(1) = max(bmrem(1), sqrt(cut))
	    endif
	    Zero(CUT_MREM_KT, CUT_MAX)
	  else if( Test(CUT_MREM_RAP, CUT_MAX) ) then
	    cut = tanh(CutMax(xmrem))
	    ref = rpart(MomQ(CUT_MAX))*cut
	    if( ref .gt. rz ) then
	      c0 = m2*(ref - rz)*(ref + rz)
	      c1 = r*(sinth*fz*nz - r0costh*(cut - fz)*(cut + fz))
	      c2 = (r0costh*fz + sinth*nz)**2 -
     &          (cut*r1 - rz)*(cut*r1 + rz)
	      cut = mremsq()
	      if( cut .gt. 0 ) then
	        cut = sqrt(cut)
	        if( c2 .gt. 0 ) then
	          bmrem(2) = min(bmrem(2), cut)
	        else
	          bmrem(1) = max(bmrem(1), cut)
	        endif
	      endif
	    endif
	    Zero(CUT_MREM_PRAP, CUT_MAX)
	  endif
	endif

	bmrem(2) = bmrem(2) - bmrem(1)
	if( bmrem(2) .lt. 0 ) then
	  fac = 0
	  return
	endif
	if( Step(xmrem) .eq. 0 ) fac = fac*bmrem(2)
	mrem = bmrem(1) + Var(xmrem)*bmrem(2)
	Show(xmrem) = mrem

	k10 = .5D0*(minv - (mrem - m)*(mrem + m)/minv)
	k = sqrt((k10 - m)*(k10 + m))
	fac = .5D0*k*fac

* k is in the CMS of the decay minv -> m + mrem and must finally
* be boosted into the CMS of the entire process

	qe = k10*r + k*r0costh
	qn = k*sinth
	q = sqrt(qe**2 + qn**2)
	if( q .ne. 0 ) then
	  fx = (qe*fx + qn*nx)/q
	  fy = (qe*fy + qn*ny)/q
	  fz = (qe*fz + qn*nz)/q
	endif
	call VecSet(i, m, q, fx, fy, fz)

	fx = p*ex - q*fx
	fy = p*ey - q*fy
	fz = p*ez - q*fz
	p = sqrt(fx**2 + fy**2 + fz**2)
	if( p .ne. 0 ) then
	  ex = fx/p
	  ey = fy/p
	  ez = fz/p
	endif

	minv = mrem
	end

* fortranflush.F
* C-callable function to flush the Fortran stdout (unit 6)
* this file is part of FormCalc
* last modified 3 Dec 08 th


	subroutine fortranflush()
	implicit none

	call flush(6)
	end

* main.F
* this is the main program for the generated Fortran code,
* it scans the command line and then invokes ParameterScan
* this file is part of FormCalc
* last modified 30 Nov 11 th


#include "xsection.F"

#ifndef MMA

	program main
	implicit none

#if U77EXT
	integer iargc, lnblnk
	external iargc, lnblnk
#endif

	RealType sqrtSfrom, sqrtSto, sqrtSstep
	integer serialfrom, serialto, serialstep
	integer argc, next, fail
	character*LEGS pol
	character*128 argv(5), tmp
	character*512 dir

#ifdef DEBUG
c	call setfpu
#endif

	call getarg(0, dir)
	next = len_trim(dir) + 1

	argc = 0
1	call getarg(argc + 1, dir(next:))
	if( dir(next:next) .eq. ':' ) then
	  argc = argc + 1
	  argv(argc) = dir(next+1:)
	  next = next + len_trim(dir(next:))
	  goto 1
	endif

	pol = dir(next:)

	sqrtSfrom = -1
	sqrtSto = 0
	sqrtSstep = SQRTSSTEP
	call getarg(argc + 2, tmp)
	read(tmp, *, iostat=fail, end=991, err=999)
     &    sqrtSfrom, sqrtSto, sqrtSstep
991	if( sqrtSfrom .eq. -1 ) goto 999

	call ProcessIni(fail, pol,
     &    sqrtSfrom, sqrtSto, sqrtSstep,
     &    argc, argv)
	if( fail .ne. 0 ) goto 999

	if( sqrtSto .eq. 0 ) then
100	  format(".", A, ".", I5.5)
	  write(dir(next:), 100) pol, int(sqrtSfrom)
	else
101	  format(".", A, ".", I5.5, ",", I5.5, ",", I5.5)
	  write(dir(next:), 101) pol,
     &      int(sqrtSfrom), int(sqrtSto), int(sqrtSstep)
	endif

	serialfrom = 0
	serialto = 2**30
	serialstep = 1
	if( argc + 3 .le. iargc() ) then
	  call getarg(argc + 3, tmp)
	  serialfrom = -1
	  read(tmp, *, iostat=fail, end=992, err=999)
     &      serialfrom, serialto, serialstep
992	  if( serialfrom .eq. -1 ) goto 999
	endif

	call ParameterScan(dir, serialfrom, serialto, serialstep)

	call ProcessExi
	goto 2

99	format (/"USAGE:  ", A, " [:args] p1...p", I1,
     &    " sqrtSfrom[,to[,step]] [serialfrom[,to[,step]]]"
     &    //"p1..", I1, " = +  for right-circular polarization"
     &    /"        -  for left-circular       ''"
     &    /"        l  for longitudinal        ''"
     &    /"        t  for transverse          ''"
     &    /"        u  for unpolarized particle"
     &    //"sqrtSfrom = compute the differential cross-section"
     &    /"sqrtSfrom,to,step = compute the total cross-section"
     &    //"serialfrom,to,step = range of serial numbers"/)

999	call getarg(0, tmp)
	print 99, tmp(1:len_trim(tmp)), LEGS, LEGS
	stop

2	continue
	end

#endif

* HEigensystem.F
* diagonalization of a Hermitian n-by-n matrix using the Jacobi algorithm
* code adapted from the "Handbook" routines for complex A
* (Wilkinson, Reinsch: Handbook for Automatic Computation, p. 202)
* this file is part of the Diag library
* last modified 30 Nov 11 th

#include "diag-f.h"


************************************************************************
** HEigensystem diagonalizes a Hermitian n-by-n matrix.
** Input: n, A = n-by-n matrix, Hermitian
** (only the upper triangle of A needs to be filled).
** Output: d = vector of eigenvalues, U = transformation matrix
** these fulfill diag(d) = U A U^+ = U A U^-1 with U unitary.

	subroutine HEigensystem(n, A,ldA, d, U,ldU, sort)
	implicit none
	integer n, ldA, ldU, sort
	ComplexType A(ldA,*), U(ldU,*)
	RealType d(*)

	integer p, q, j
	RealType red, off, thresh
	RealType t, delta, invc, s
	ComplexType x, y, Apq
	RealType ev(2,MAXDIM)

	integer sweep
	common /nsweeps/ sweep

	if( n .gt. MAXDIM ) then
	  print *, "Dimension too large"
	  d(1) = -999
	  return
	endif

	do p = 1, n
	  ev(1,p) = 0
	  ev(2,p) = Re(A(p,p))
	  d(p) = ev(2,p)
	enddo

	do p = 1, n
	  do q = 1, n
	    U(q,p) = 0
	  enddo
	  U(p,p) = 1
	enddo

	red = .04D0/n**4

	do sweep = 1, 50
	  off = 0
	  do q = 2, n
	    do p = 1, q - 1
	      off = off + Sq(A(p,q))
	    enddo
	  enddo
	  if( .not. off .gt. SYM_EPS ) goto 1

	  thresh = 0
	  if( sweep .lt. 4 ) thresh = off*red

	  do q = 2, n
	    do p = 1, q - 1
	      Apq = A(p,q)
	      off = Sq(Apq)
	      if( sweep .gt. 4 .and. off .lt.
     &              SYM_EPS*(ev(2,p)**2 + ev(2,q)**2) ) then
	        A(p,q) = 0
	      else if( off .gt. thresh ) then
	        t = .5D0*(ev(2,p) - ev(2,q))
	        t = 1/(t + sign(sqrt(t**2 + off), t))

	        delta = t*off
	        ev(1,p) = ev(1,p) + delta
	        ev(2,p) = d(p) + ev(1,p)
	        ev(1,q) = ev(1,q) - delta
	        ev(2,q) = d(q) + ev(1,q)

	        invc = sqrt(delta*t + 1)
	        s = t/invc
	        t = delta/(invc + 1)

	        do j = 1, p - 1
	          x = A(j,p)
	          y = A(j,q)
	          A(j,p) = x + s*(Conjugate(Apq)*y - t*x)
	          A(j,q) = y - s*(Apq*x + t*y)
	        enddo

	        do j = p + 1, q - 1
	          x = A(p,j)
	          y = A(j,q)
	          A(p,j) = x + s*(Apq*Conjugate(y) - t*x)
	          A(j,q) = y - s*(Apq*Conjugate(x) + t*y)
	        enddo

	        do j = q + 1, n
	          x = A(p,j)
	          y = A(q,j)
	          A(p,j) = x + s*(Apq*y - t*x)
	          A(q,j) = y - s*(Conjugate(Apq)*x + t*y)
	        enddo

	        A(p,q) = 0

	        do j = 1, n
	          x = U(p,j)
	          y = U(q,j)
	          U(p,j) = x + s*(Apq*y - t*x)
	          U(q,j) = y - s*(Conjugate(Apq)*x + t*y)
	        enddo
	      endif
	    enddo
	  enddo

	  do p = 1, n
	    ev(1,p) = 0
	    d(p) = ev(2,p)
	  enddo
	enddo

	print *, "Bad convergence in HEigensystem"

1	if( sort .eq. 0 ) return

* sort the eigenvalues

	do p = 1, n - 1
	  j = p
	  t = d(p)
	  do q = p + 1, n
	    if( sort*(t - d(q)) .gt. 0 ) then
	      j = q
	      t = d(q)
	    endif
	  enddo

	  if( j .ne. p ) then
	    d(j) = d(p)
	    d(p) = t
	    do q = 1, n
	      x = U(p,q)
	      U(p,q) = U(j,q)
	      U(j,q) = x
	    enddo
	  endif
	enddo
	end

* NoMixing.f
* same invocation as Eigen2x2, but ignores M12 (i.e., no mixing)
* used for testing
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "diag-f.h"


	subroutine NoMixing(fail, m, msq, U, M11, M22, M12)
	implicit none
	integer fail
	RealType m(2), msq(2)
	ComplexType U(2,2)
	RealType M11, M22
	ComplexType M12

	if( M11 .gt. M22 ) then
	  msq(1) = M22
	  msq(2) = M11
	  U(1,1) = 0
	  U(2,2) = 0
	  U(1,2) = 1
	  U(2,1) = 1
	else
	  msq(1) = M11
	  msq(2) = M22
	  U(1,1) = 1
	  U(2,2) = 1
	  U(1,2) = 0
	  U(2,1) = 0
	endif

	if( msq(1) .lt. 0 ) then
	  print *, "Negative mass-squares."
	  fail = 1
	  return
	endif

	m(1) = sqrt(msq(1))
	m(2) = sqrt(msq(2))
	fail = 0
	end

* model_sm.F
* all parameters for the Standard Model are initialized here
* this file is part of FormCalc
* last modified 2 Feb 06 th


	subroutine ModelDefaults
	implicit none

#include "model.h"

#ifdef NO_CKM

	CKM(1,1) = 1
	CKM(2,2) = 1
	CKM(3,3) = 1
	CKM(2,1) = 0
	CKM(3,1) = 0
	CKM(1,2) = 0
	CKM(3,2) = 0
	CKM(1,3) = 0
	CKM(2,3) = 0

#else

	double precision s12, s23, s13, delta13
	double precision c12, c23, c13
	double complex s13c

	parameter (s12 = .2243D0)
	parameter (s23 = .0413D0)
	parameter (s13 = .0037D0)
	parameter (delta13 = 60*degree)

	c12 = sqrt((1 - s12)*(1 + s12))
	c23 = sqrt((1 - s23)*(1 + s23))
	c13 = sqrt((1 - s13)*(1 + s13))
	s13c = s13*exp(cI*delta13)

	CKM(1,1) = c12*c13
	CKM(2,1) = -s12*c23 - c12*s23*s13c
	CKM(3,1) = s12*s23 - c12*c23*s13c
	CKM(1,2) = s12*c13
	CKM(2,2) = c12*c23 - s12*s23*s13c
	CKM(3,2) = -c12*s23 - s12*c23*s13c
	CKM(1,3) = DCONJG(s13c)
	CKM(2,3) = s23*c13
	CKM(3,3) = c23*c13

#endif

	Mf(1,1) = 0
	Mf(2,1) = ME
	Mf(3,1) = MU
	Mf(4,1) = MD
	Mf(1,2) = 0
	Mf(2,2) = MM
	Mf(3,2) = MC
	Mf(4,2) = MS
	Mf(1,3) = 0
	Mf(2,3) = ML
	Mf(3,3) = MT
	Mf(4,3) = MB

	Mf2(1,1) = 0
	Mf2(2,1) = ME2
	Mf2(3,1) = MU2
	Mf2(4,1) = MD2
	Mf2(1,2) = 0
	Mf2(2,2) = MM2
	Mf2(3,2) = MC2
	Mf2(4,2) = MS2
	Mf2(1,3) = 0
	Mf2(2,3) = ML2
	Mf2(3,3) = MT2
	Mf2(4,3) = MB2
	end


************************************************************************

	subroutine ModelConstIni(fail)
	implicit none
	integer fail

#include "model.h"

	EL = sqrt(4*pi*Alfa)
	SW = sqrt(SW2)

	MH2 = MH**2

	sm_digest = .FALSE.
	fail = 0
	end


************************************************************************

	subroutine ModelVarIni(fail, scale)
	implicit none
	integer fail
	double precision scale

#include "model.h"

	double precision alphasPDF
	external alphasPDF

	Alfas = alphasPDF(scale)
	Alfas2 = Alfas**2
	GS = sqrt(4*pi*Alfas)

	fail = 0
	if( sm_digest ) return
	sm_digest = .TRUE.

	INFO "============================"
	INFO "SM parameters"
	INFO "----------------------------"
	INFO "1/Alfa =", 1/Alfa
	INFO "Alfas =", Alfas
	INFO "GF =", GF
	INFO "SW2 =", SW2
	INFO "----------------------------"
	INFO "Gauge-boson masses:"
	INFO "MW =", MW
	INFO "MZ =", MZ
	INFO "----------------------------"
	INFO "Fermion masses:"
	INFO "ME =", ME
	INFO "MM =", MM
	INFO "ML =", ML
	INFO "MU =", MU
	INFO "MC =", MC
	INFO "MT =", MT
	INFO "MD =", MD
	INFO "MS =", MS
	INFO "MB =", MB
	INFO "----------------------------"
	INFO "Higgs mass:"
	INFO "MH =", MH
	INFO "============================"
	end


#ifndef HAVE_ALPHASPDF

************************************************************************
** alphasPDF (same name as in LHAPDF) computes the strong coupling
** constant at a given scale.  Code is transcribed from Java applet by
** I. Hinchliffe at http://www-theory.lbl.gov/~ianh/alpha/alpha.html.

	double precision function alphasPDF(scale)
	implicit none
	double precision scale

#include "model.h"

* the betas and deltas are calculated as follows:
*
* beta0[nf_] := 11 - 2/3 nf
* beta1[nf_] := 51 - 19/3 nf
* beta2[nf_] := 2857 - 5033/9 nf + 325/27 nf^2
*
* delta0[nf_] := (beta0[nf] - beta0[nf + 1])/(2 beta0[nf])
* delta10[nf_] := beta1[nf]/beta0[nf]^2
* delta11[nf_] := (beta1[nf]/beta0[nf] -
*   beta1[nf + 1]/beta0[nf + 1])/beta0[nf]
* delta20[nf_] := (28/9 -
*   8 (beta1[nf + 1]/beta0[nf + 1])^2 + beta2[nf + 1]/beta0[nf + 1] +
*   8 (beta1[nf]/beta0[nf])^2 - beta2[nf]/beta0[nf])/
*   (4 beta0[nf + 1] beta0[nf])
* delta21[nf_] := 2 beta1[nf + 1]/beta0[nf + 1]^2 delta11[nf]

	double precision beta3_0, beta3_1, beta3_2
	parameter (beta3_0 = 9)
	parameter (beta3_1 = 32)
	parameter (beta3_2 = 3863/3D0)

	double precision beta4_0, beta4_1, beta4_2
	parameter (beta4_0 = 25/3D0)
	parameter (beta4_1 = 77/3D0)
	parameter (beta4_2 = 21943/27D0)

	double precision beta5_0, beta5_1, beta5_2
	parameter (beta5_0 = 23/3D0)
	parameter (beta5_1 = 58/3D0)
	parameter (beta5_2 = 9769/27D0)

	double precision beta6_0, beta6_1, beta6_2
	parameter (beta6_0 = 7)
	parameter (beta6_1 = 13)
	parameter (beta6_2 = -65)

	double precision delta54_0, delta54_10, delta54_11
	double precision delta54_20, delta54_21
	parameter (delta54_0  =  .040000000000000000000D0)
	parameter (delta54_10 = -.030817842663873271183D0)
	parameter (delta54_11 =  .066991304347826086957D0)
	parameter (delta54_20 = -.086878340429029341662D0)
	parameter (delta54_21 =  .044069893975507520342D0)

	double precision delta43_0, delta43_10, delta43_11
	double precision delta43_20, delta43_21
	parameter (delta43_0  =  .037037037037037037037D0)
	parameter (delta43_10 = -.030404361930322301228D0)
	parameter (delta43_11 =  .052839506172839506173D0)
	parameter (delta43_20 = -.057313053497942386831D0)
	parameter (delta43_21 =  .039058962962962962963D0)

	double precision lam5
	parameter (lam5 = 199D-3)
* The 5-flavour scale lam5 is chosen to reproduce the
* "world average" alpha_s(MZ) = .1172.  The 1-sigma interval
* on alpha_s(MZ) corresponds to 177 MeV < lam5 < 223 MeV.

	double precision b0, b1, b2, lam, t, logt, c

	if( scale .lt. .5D0 ) then
	  alphasPDF = 1D10
	  return
	endif

	if( scale .gt. MT ) then
	  b0 = beta6_0
	  b1 = beta6_1
	  b2 = beta6_2
	  t = MT/lam5
	  lam = lam5*t**(-2/21D0)*(2*log(t))**(-107/1127D0)
	else if( scale .gt. MB ) then
	  b0 = beta5_0
	  b1 = beta5_1
	  b2 = beta5_2
	  lam = lam5
	else
	  t = 2*log(MB/lam5)
	  logt = log(t)
	  lam = lam5*exp(delta54_0*t +
     &      delta54_11*logt + delta54_10 +
     &      (delta54_21*logt + delta54_20)/t)
	  if( scale .gt. MC ) then
	    b0 = beta4_0
	    b1 = beta4_1
	    b2 = beta4_2
	  else
	    b0 = beta3_0
	    b1 = beta3_1
	    b2 = beta3_2
	    t = 2*log(MC/lam)
	    logt = log(t)
	    lam = lam*exp(delta43_0*t +
     &        delta43_11*logt + delta43_10 +
     &        (delta43_21*logt + delta43_20)/t)
	  endif
	endif

	t = 2*log(scale/lam)
	logt = log(t)
	c = 2*b1/b0**2/t

	alphasPDF = 4*pi/(t*b0)*(1 - logt*c +
     &    ((logt - .5D0)**2 + b2*b0/(8*b1**2) - 5/4D0)*c**2)
	end

#endif

* Bcut.F
* the FormCalc wrapper for the CutTools two-point function
* this file is part of FormCalc
* last modified 21 Oct 09 th


	double complex function Bcut(rank, num, p, m1, m2)
	implicit none
	integer rank
	external num
	integer*8 p
	double precision m1, m2

	double precision pi(0:3,0:1), mi(2)
	external mpnum

	pi(0,0) = 0
	pi(1,0) = 0
	pi(2,0) = 0
	pi(3,0) = 0
	call MomDecode(p, pi(0,1))

	mi(1) = m1
	mi(2) = m2

	PRINT *, "Bcut:", rank
	PRINT *, "p1=", pi(0,1)
	PRINT *, "   ", pi(1,1)
	PRINT *, "   ", pi(2,1)
	PRINT *, "   ", pi(3,1)
	PRINT *, "m1=", m1
	PRINT *, "m2=", m2

c	call ctsxcut(2, num, mpnum, rank, pi, mi, Bcut)
	call ctsxcut(2, num, mpnum, 2, pi, mi, Bcut)
	PRINT *, "Bcut=", Bcut
	end

* SInvariant.F
* calculates an s-type invariant, i.e. s_{ij} = (k_i + k_j)^2
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


	RealType function SInvariant(i, j)
	implicit none
	integer i, j

	ComplexType vec(2,2, 8, 0:1)
	common /vectors/ vec

#define Ki(x,y) vec(x,y, 1, i)
#define Kj(x,y) vec(x,y, 1, j)

	RealType S11, S22
	ComplexType S12

	S11 = Re(Ki(1,1)) + Re(Kj(1,1))
	S22 = Re(Ki(2,2)) + Re(Kj(2,2))
	S12 = Ki(1,2) + Kj(1,2)

	SInvariant = S11*S22 - Sq(S12)
	end

* model_thdm.F
* all parameters for the THDM are initialized here
* this file is part of FormCalc
* Abdesslam Arhrib, 2 Jun 03
* last modified 30 Nov 11 th


* The input parameters for model_thdm are:

* SA = sin alpha
* TB = tan beta
* Mh0 = Mass(H1)
* MHH = Mass(H2)
* MA0 = Mass(H3)
* MHp = Mass(Hp)
* Lambda5

* The following preprocessor variables can be defined
* (they are usually set in run.F):

* MODEL_TYPE_I, MODEL_TYPE_II
*   Which type of two-higgs-doublet model to select.

* NO_EXCLUSION_LIMITS
*   If defined, the experimental exclusion limits are ignored.


* Exclusion limits (only checked if NO_EXCLUSION_LIMITS is not set):

* PDG
#define DeltaRho_UPPERBOUND .003D0


#define ModelConstIni SMConstIni
#define ModelDigest SMDigest
#include "model_sm.F"
#undef ModelConstIni
#undef ModelDigest


************************************************************************

	subroutine ModelConstIni(fail)
	implicit none
	integer fail

#include "decl.h"

	RealType Lambda1, Lambda2, Lambda3, Lambda4, Lambda6
	RealType DeltaRho

#if !defined(MODEL_TYPE_I) && !defined(MODEL_TYPE_II)
	stop "Neither MODEL_TYPE_I nor MODEL_TYPE_II defined"
#elif defined(MODEL_TYPE_I) && defined(MODEL_TYPE_II)
	stop "Both MODEL_TYPE_I and MODEL_TYPE_II defined"
#endif

	call SMConstIni(fail)
	if( fail .ne. 0 ) return

	TB2 = TB**2
	CB2 = 1/(1 + TB2)
	SB2 = CB2*TB2
	CB = sqrt(CB2)
	SB = CB*TB
	S2B = 2*TB*CB2
	C2B = (CB - SB)*(CB + SB)

	SA2 = SA**2
	CA2 = (1 - SA)*(1 + SA)
	CA = sqrt(CA2)
	S2A = 2*SA*CA
	C2A = (CA - SA)*(CA + SA)
	SAB = SA*CB + CA*SB
	CAB = CA*CB - SA*SB
	SBA = SB*CA - CB*SA
	CBA = CB*CA + SB*SA

#ifdef MODEL_TYPE_I
	Yuk1 = CA/SB
	Yuk2 = SA/SB
	Yuk3 = -1/TB
#else
	Yuk1 = -SA/CB
	Yuk2 = CA/CB
	Yuk3 = TB
#endif

	Mh02 = Mh0**2
	MH = Mh0
	MH2 = Mh02
	MHH2 = MHH**2
	MA02 = MA0**2
	MHp2 = MHp**2

#ifndef NO_EXCLUSION_LIMITS
	Lambda1 = .25D0*Lambda5*(1 - TB2) +
     &    Alfa*Pi/(2*MW2*SW2)/CB2*
     &      (MHH2*CA2 + Mh02*SA2 - .5D0*(MHH2 - Mh02)*S2A/TB)
	Lambda2 = .25D0*Lambda5*(1 - 1/TB2) +
     &    Alfa*Pi/(2*MW2*SW2)/SB2*
     &      (Mh02*CA2 + MHH2*SA2 - .5D0*(MHH2 - Mh02)*S2A*TB)
        Lambda3 = -.25D0*Lambda5 +
     &    Alfa*Pi/(2*MW2*SW2)*(MHH2 - Mh02)*S2A/S2B
        Lambda4 = (2*Alfa*Pi)/(MW2*SW2)*MHp2
        Lambda6 = (2*Alfa*Pi)/(MW2*SW2)*MA02

	if( max(abs(Lambda1), abs(Lambda2), abs(Lambda3),
     &          Lambda4, abs(Lambda5), Lambda6) .gt. 8*pi ) then
	  Error(fail, "Perturbativity violated")
	  return
	endif

	if( abs(MA02 - MHH2) .gt. 1D-13 .and.
     &      abs(MHp2 - MHH2) .gt. 1D-13 ) then
	  DeltaRho = GF/(8*sqrt2*pi**2)*(
     &      MHp2*(1 - MA02/(MHp2 - MA02)*log(MHp2/MA02)) +
     &      CBA**2*Mh02*(MA02/(MA02 - Mh02)*log(MA02/Mh02) -
     &                   MHp2/(MHp2 - Mh02)*log(MHp2/Mh02)) +
     &      SBA**2*MHH2*(MA02/(MA02 - MHH2)*log(MA02/MHH2) -
     &                   MHp2/(MHp2 - MHH2)*log(MHp2/MHH2)) )

	  if( DeltaRho .gt. DeltaRho_UPPERBOUND ) then
	    Error(fail, "DeltaRho > DeltaRho_UPPERBOUND")
	    return
	  endif
	endif
#endif
	end


************************************************************************

	subroutine ModelDigest
	implicit none

#include "model_thdm.h"

	call SMDigest

	INFO "THDM parameters"
	INFO "----------------------------"
#ifdef MODEL_TYPE_I
	INFO "using type-I model"
#else
	INFO "using type-II model"
#endif
	INFO "TB =", TB
	INFO "SA =", SA
	INFO "Mh0 =", Mh0
	INFO "MHH =", MHH
	INFO "MA0 =", MA0
	INFO "MHp =", MHp
	INFO "Lambda5 =", Lambda5
	INFO "============================"
	end

* Pair.F
* calculates the scalar product of two four-vectors
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


* Note: the arguments a, b specify the vector's position in
* the array vec, NOT the vector itself.  The macros k, e, ec, s
* (defined in util.h) convert from 1...LEGS to a, b.

	ComplexType function Pair(a, b)
	implicit none
	integer a, b

	ComplexType vec(2,2, 1)
	common /vectors/ vec

#define A(x,y) vec(x,y, a)
#define B(x,y) vec(x,y, b)

	Pair = .5D0*(
     &    A(1,1)*B(2,2) + A(2,2)*B(1,1) -
     &    A(1,2)*B(2,1) - A(2,1)*B(1,2) )
	end

* SACcut.F
* the FormCalc wrapper for the Samurai three-point function
* this file is part of FormCalc
* last modified 31 Mar 11 th


	double complex function SACcut(rank, num, numeps,
     &    p1, p2, m1, m2, m3)
	implicit none
	integer rank
	double complex num, numeps
	external num, numeps
	integer*8 p1, p2
	double precision m1, m2, m3

#include "SA.h"

	double precision pj(3,4), mj(3)
	double complex tot(-2:0), totr
	logical ok

	pj(1,1) = 0
	pj(1,2) = 0
	pj(1,3) = 0
	pj(1,4) = 0
	call SAMomDecode(p1, pj(2,1), 3)
	call SAMomDecode(p2, pj(3,1), 3)

	mj(1) = m1
	mj(2) = m2
	mj(3) = m3

	PRINT *, "SACcut:", rank
	PRINT *, "p1=", pj(2,4)
	PRINT *, "   ", pj(2,1)
	PRINT *, "   ", pj(2,2)
	PRINT *, "   ", pj(2,3)
	PRINT *, "p2=", pj(3,4)
	PRINT *, "   ", pj(3,1)
	PRINT *, "   ", pj(3,2)
	PRINT *, "   ", pj(3,3)
	PRINT *, "m1=", m1
	PRINT *, "m2=", m2
	PRINT *, "m3=", m3

	call samurai(num, tot, totr, pj, mj, 3, rank, 1, mudim, ok)
	SACcut = tot(epscoeff)
	PRINT *, "SACcut=", SACcut
	end

* CTEcut.F
* the FormCalc wrapper for the CutTools five-point function
* this file is part of FormCalc
* last modified 4 Aug 11 th


	double complex function CTEcut(rank, num, numeps,
     &    p1, p2, p3, p4, m1, m2, m3, m4, m5)
	implicit none
	integer rank
	external num, numeps
	integer*8 p1, p2, p3, p4
	double precision m1, m2, m3, m4, m5

	double precision pj(0:3,5), mj(5)
	logical stable, forcemp
	double complex res(0:2), res1
	external CTmpnum

	double precision rootsvalue, muscale
	common /cuttools_para/ rootsvalue, muscale

	pj(0,1) = 0
	pj(1,1) = 0
	pj(2,1) = 0
	pj(3,1) = 0
	call CTMomDecode(p1, pj(0,2))
	call CTMomDecode(p2, pj(0,3))
	call CTMomDecode(p3, pj(0,4))
	call CTMomDecode(p4, pj(0,5))

	mj(1) = m1
	mj(2) = m2
	mj(3) = m3
	mj(4) = m4
	mj(5) = m5

	call ctsxcut(rootsvalue, muscale, 5, num, CTmpnum,
     &    rank, pj, mj, res, res1, stable, forcemp)
	CTEcut = res(0)
	PRINT *, "CTEcut=", CTEcut
	end

* SVD.F
* singular value decomposition of an m-by-n matrix
* this file is part of the Diag library
* last modified 30 Nov 11 th

#include "diag-f.h"


************************************************************************
** SVD performs a singular value decomposition.
** Input: m, n, A = m-by-n matrix.
** Output: d = nm-vector of singular values,
** V = nm-by-m left transformation matrix,
** W = nm-by-n right transformation matrix, nm = min(m, n),
** these fulfill diag(d) = V^* A W^+.

	subroutine SVD(m, n, Ao,ldA, d, Vo,ldV, Wo,ldW, sort)
	implicit none
	integer m, n, ldA, ldV, ldW, sort
	ComplexType Ao(ldA,*), Vo(ldV,*), Wo(ldW,*)
	RealType d(*)

	integer nx, nm, p, q, px, qx, j, rev, pi(MAXDIM)
	RealType red, off, thresh
	RealType t, dv, dw, xv, xw, invc
	ComplexType App, Apq, Aqp, Aqq
	ComplexType x, y, sv, sw, tv, tw, f
	ComplexType VW(MAXDIM,MAXDIM,0:2)

* note: for better cache efficiency, the Vx, Wx arrays
* contain the *transpose* of the transformation matrices
	ComplexType V(MAXDIM,MAXDIM)
	ComplexType W(MAXDIM,MAXDIM)
	ComplexType A(MAXDIM,MAXDIM)
	equivalence (VW(1,1,0), V)
	equivalence (VW(1,1,1), W)
	equivalence (VW(1,1,2), A)

	integer sweep
	common /nsweeps/ sweep

	nx = max(m, n)

	if( nx .gt. MAXDIM ) then
	  print *, "Dimension too large"
	  d(1) = -999
	  return
	endif

	do p = 1, nx
	  do q = 1, nx
	    V(q,p) = 0
	    W(q,p) = 0
	    A(q,p) = 0
	  enddo
	  V(p,p) = 1
	  W(p,p) = 1
	enddo

	rev = ibits(m - n, 15, 1)
	if( rev .eq. 1 ) then
	  do p = 1, n
	    do q = 1, m
	      A(p,q) = Ao(q,p)
	    enddo
	  enddo
	else
	  do p = 1, n
	    do q = 1, m
	      A(q,p) = Ao(q,p)
	    enddo
	  enddo
	endif

	red = .01D0/nx**4

	do sweep = 1, 50
	  off = 0
	  do q = 2, nx
	    do p = 1, q - 1
	      off = off + Sq(A(p,q)) + Sq(A(q,p))
	    enddo
	  enddo
	  if( .not. off .gt. EPS ) goto 1

	  thresh = 0
	  if( sweep .lt. 4 ) thresh = off*red

	  do q = 2, nx
	    do p = 1, q - 1
	      px = p
	      qx = q
	      if( Sq(A(p,p)) + Sq(A(q,q)) .lt.
     &            Sq(A(p,q)) + Sq(A(q,p)) ) then
	        px = q
	        qx = p
	      endif

	      App = A(px,p)
	      Aqq = A(qx,q)
	      Apq = A(px,q)
	      Aqp = A(qx,p)
	      off = Sq(Apq) + Sq(Aqp)
	      if( sweep .gt. 4 .and.
     &            off .lt. EPS*(Sq(App) + Sq(Aqq)) ) then
	        A(px,q) = 0
	        A(qx,p) = 0
	      else if( off .gt. thresh ) then
	        xv = Re((App - Aqq)*Conjugate(App + Aqq))
	        xw = Re((Apq - Aqp)*Conjugate(Apq + Aqp))
	        dv = .5D0*(xv + xw)
	        dw = .5D0*(xv - xw)

	        tv = Conjugate(App)*Aqp + Aqq*Conjugate(Apq)
	        tw = Conjugate(App)*Apq + Aqq*Conjugate(Aqp)
c	        t = sqrt(dv**2 + Sq(tv))
	        t = sqrt(dw**2 + Sq(tw))

	        xv = min(abs(dv + t), abs(dw + t))
	        xw = min(abs(dv - t), abs(dw - t))
	        if( xv + xw .gt. DBL_EPS ) then
	          t = sign(t, xv - xw)
	          tv = tv/(dv + t)
	          tw = tw/(dw + t)
	        else
	          tv = 0
	          tw = Apq/App
	        endif

	        invc = sqrt(1 + Sq(tv))
	        sv = tv/invc
	        tv = tv/(invc + 1)

	        invc = sqrt(1 + Sq(tw))
	        sw = tw/invc
	        tw = tw/(invc + 1)

	        do j = 1, nx
	          x = A(j,p)
	          y = A(j,q)
	          A(j,p) = x + Conjugate(sw)*(y - tw*x)
	          A(j,q) = y - sw*(x + Conjugate(tw)*y)
	          x = A(px,j)
	          y = A(qx,j)
	          A(p,j) = x + Conjugate(sv)*(y - tv*x)
	          A(q,j) = y - sv*(x + Conjugate(tv)*y)
	        enddo

	        A(p,p) = invc*(App + Conjugate(sv)*(Aqp - tv*App))
	        A(q,p) = 0
	        A(p,q) = 0
	        A(q,q) = invc*(Aqq - sv*(Apq + Conjugate(tv)*Aqq))

	        do j = 1, nx
	          x = V(j,px)
	          y = V(j,qx)
	          V(j,p) = x + sv*(y - Conjugate(tv)*x)
	          V(j,q) = y - Conjugate(sv)*(x + tv*y)
	        enddo

	        do j = 1, nx
	          x = W(j,p)
	          y = W(j,q)
	          W(j,p) = x + sw*(y - Conjugate(tw)*x)
	          W(j,q) = y - Conjugate(sw)*(x + tw*y)
	        enddo
	        goto 2
	      endif

	      if( p .ne. px ) then
	        do j = 1, nx
	          x = A(p,j)
	          A(p,j) = A(q,j)
	          A(q,j) = x
	        enddo

	        do j = 1, nx
	          x = V(j,p)
	          V(j,p) = V(j,q)
	          V(j,q) = x
	        enddo
	      endif

2	      continue
	    enddo
	  enddo
	enddo

	print *, "Bad convergence in SVD"

1	continue

	nm = min(m, n)

* make the diagonal elements nonnegative

	do p = 1, nm
	  d(p) = abs(A(p,p))
	  if( d(p) .gt. DBL_EPS .and. d(p) .ne. Re(A(p,p)) ) then
	    f = A(p,p)/d(p)
	    do q = 1, nm
	      W(q,p) = W(q,p)*f
	    enddo
	  endif
	enddo

* sort the singular values

	do p = 1, nm
	  pi(p) = p
	enddo

	do p = 1, nm
	  j = p
	  t = d(p)
	  if( sort .ne. 0 ) then
	    do q = p + 1, nm
	      if( sort*(t - d(q)) .gt. 0 ) then
	        j = q
	        t = d(q)
	      endif
	    enddo
	  endif

	  d(j) = d(p)
	  d(p) = t

	  q = pi(j)
	  pi(j) = pi(p)

	  do j = 1, m
	    Vo(p,j) = VW(j,q,rev)
	  enddo
	  do j = 1, n
	    Wo(p,j) = VW(j,q,1-rev)
	  enddo
	enddo
	end

* model_fh.F
* parameter initialization via FeynHiggs
* this file is part of FormCalc
* last modified 30 Nov 11 th


* NO_EXCLUSION_LIMITS
*   If defined, the experimental exclusion limits are ignored.


* Exclusion limits (only checked if NO_EXCLUSION_LIMITS is not set):

* hep-ex/9910020 (L3)
#define MStop_LOWERBOUND 80

* hep-ex/9910020 (L3)
#define MSbottom_LOWERBOUND 70

* hep-ex/9910020 (L3)
#define MSquark_LOWERBOUND 150

* hep-ex/9910006 (L3)
#define MSlepton_LOWERBOUND 70

* PDG
#define DeltaRho_UPPERBOUND .003D0

#ifdef COMPLEX_PARAMETERS
* Kane & Wang, Phys Lett B488 (2000) 383
#define Mh0_LOWERBOUND 85
#else
* http://lephiggs.web.cern.ch/LEPHIGGS/papers/osaka_note.ps
#define Mh0_LOWERBOUND 91
#endif

* hep-ex/9910007 (L3) and hep-ex/9909051 (OPAL)
#define MNeu_LOWERBOUND 30

* hep-ex/9910007 (L3) and hep-ex/9909051 (OPAL)
#define MCha_LOWERBOUND 90

* hep-ex/9910020 (L3) and PDG
#define MGl_LOWERBOUND 175


************************************************************************

	subroutine ModelDefaults(argc, argv)
	implicit none
	integer argc
	character*128 argv(*)

#include "decl.h"
#include "SLHA.h"

	ComplexType slhadata(nslhadata)
	integer error

	character*16 flags
	data flags /"400202113"/

	if( argc .lt. 1 .or. argc .gt. 2 )
     &    stop "model_fh: need arguments <file> [<flags>]"

	if( argc .ge. 2 ) flags = argv(2)
	call FHSetFlagsString(error, flags)
	if( error .ne. 0 ) stop

	call FHReadRecord(error, record, slhadata, argv(1))
* 0 = SLHA, 2 = FH file, all others are true errors
	if( ibclr(error, 1) .ne. 0 ) stop

* turn on verbose mode:   
	record(iAdmin,iStep) = 1
	end


************************************************************************

	subroutine ModelConstIni(fail)
	implicit none
	integer fail

#include "decl.h"

	RealType invAlfaMZ, scalefactor, asMB
	integer i, nf
#ifndef NO_EXCLUSION_LIMITS
	RealType gm2, DeltaRho
	RealType MWMSSM, MWSM, SW2MSSM, SW2SM
	RealType edmeTh, edmn, edmHg
#endif

	call FHLoopRecord(fail, record)
	if( fail .ne. 0 ) return

	call FHSetRecord(fail, record)
	if( fail .ne. 0 ) return

	call FHRetrieveSMPara(fail,
     &    invAlfaMZ, AlfasMZ, GF,
     &    ME, MU, MD, MM, MC, MS, ML, MBatMB,
     &    MW, MZ,
     &    CKMlambda, CKMA, CKMrhobar, CKMetabar)
	if( fail .ne. 0 ) return

	call FHGetSMPara(fail, CKM)
	if( fail .ne. 0 ) return

	call FHRetrieveOSPara(fail, scalefactor,
     &    MT, TB, MA0, MHp,
     &    MSS(1,3), MSS(2,3), MSS(3,3), MSS(4,3), MSS(5,3),
     &    MSS(1,2), MSS(2,2), MSS(3,2), MSS(4,2), MSS(5,2),
     &    MSS(1,1), MSS(2,1), MSS(3,1), MSS(4,1), MSS(5,1),
     &    MUE,
     &    Afd(2,3), Afd(3,3), Afd(4,3),
     &    Afd(2,2), Afd(3,2), Afd(4,2),
     &    Afd(2,1), Afd(3,1), Afd(4,1),
     &    Mino1, Mino2, Mino3)
	if( fail .ne. 0 ) return

	call FHGetPara(fail, nmfv, MASf, UASf,
     &    MCha, UCha, VCha, MNeu, ZNeu, Deltab, MGl,
     &    MHtree, SA)
	if( fail .ne. 0 ) return

	call FHGetNMFV(fail, MSS2, Kf)
	if( fail .ne. 0 ) return

#ifndef NO_EXCLUSION_LIMITS
	if( MSf(1,4,3) .lt. MSbottom_LOWERBOUND ) then
	  Error(fail, "MSf(1,4,3) < MSbottom_LOWERBOUND")
	  return
	endif

	if( MSf(1,3,3) .lt. MStop_LOWERBOUND ) then
	  Error(fail, "MSf(1,3,3) < MStop_LOWERBOUND")
	  return
	endif

	if( MSf(1,2,1) .lt. MSlepton_LOWERBOUND ) then
	  Error(fail, "MSf(1,2,1) < MSlepton_LOWERBOUND")
	  return
	endif

	if( MSf(1,3,1) .lt. MSquark_LOWERBOUND ) then
	  Error(fail, "MSf(1,3,1) < MSquark_LOWERBOUND")
	  return
	endif

	if( MCha(1) .lt. MCha_LOWERBOUND ) then
	  Error(fail, "MCha(1) < MCha_LOWERBOUND")
	  return
	endif

	if( MNeu(1) .lt. MNeu_LOWERBOUND ) then
	  Error(fail, "MNeu(1) < MNeu_LOWERBOUND")
	  return
	endif
#endif

	call FHHiggsCorr(fail, MHiggs, SAeff, UHiggs, ZHiggs)
	if( fail .ne. 0 ) return

#ifndef NO_EXCLUSION_LIMITS
	if( Mh0 .lt. Mh0_LOWERBOUND ) then
	  Error(fail, "Mh0 < Mh0_LOWERBOUND")
	  return
	endif

	call FHConstraints(fail, gm2, DeltaRho,
     &    MWMSSM, MWSM, SW2MSSM, SW2SM,
     &    edmeTh, edmn, edmHg)

	if( DeltaRho .gt. DeltaRho_UPPERBOUND ) then
	  Error(fail, "DeltaRho > DeltaRho_UPPERBOUND")
	  return
	endif
#endif

	ME2 = ME**2
	MM2 = MM**2
	ML2 = ML**2
	MU2 = MU**2
	MC2 = MC**2
	MT2 = MT**2
	MD2 = MD**2
	MS2 = MS**2

	call AlphaS(asMB, nf, MBatMB)
	MB = MBatMB*sqrt(1 + 4*2/(3*pi)*asMB)
	MB2 = MB**2

	PRINT *, "MBatMB=", MBatMB
	PRINT *, "MBosMS=", MB
	PRINT *, "MBosDR=", MBatMB*sqrt(1 + 5*2/(3*pi)*asMB)
	PRINT *, "MBosDR=", MBatMB*(1 + 4/(3*pi)*asMB)

	MW2 = MW**2
	MZ2 = MZ**2
	CW = MW/MZ
	CW2 = CW**2
	SW2 = (1 - CW)*(1 + CW)
	SW = sqrt(SW2)

	AlfaGF = sqrt2/pi*GF*MW2*SW2

	AlfaMZ = 1/invAlfaMZ
	ELMZ = sqrt(4*pi*AlfaMZ)

	Alfa = Alfa0
	Alfa2 = Alfa**2
	EL = sqrt(4*pi*Alfa)

	Mh0tree2 = Mh0tree**2
	MHHtree2 = MHHtree**2
	MA0tree2 = MA0tree**2
	MHptree2 = MHptree**2

	MH = Mh0
	MH2 = MH**2

	Mh02 = Mh0**2
	MHH2 = MHH**2
	MA02 = MA0**2
	MHp2 = MHp**2

	do i = 1, 6*4
	  MASf2_flat(i) = MASf_flat(i)**2
	enddo

	MCha2(1) = MCha(1)**2
	MCha2(2) = MCha(2)**2

	MNeu2(1) = MNeu(1)**2
	MNeu2(2) = MNeu(2)**2
	MNeu2(3) = MNeu(3)**2
	MNeu2(4) = MNeu(4)**2

	TB2 = TB**2
	CB2 = 1/(1 + TB2)
	SB2 = CB2*TB2
	CB = sqrt(CB2)
	SB = CB*TB
	S2B = 2*TB*CB2
	C2B = (CB - SB)*(CB + SB)

	SA2 = SA**2  
	CA2 = (1 - SA)*(1 + SA)
	CA  = sqrt(CA2)
	S2A = 2*SA*CA
	C2A = (CA - SA)*(CA + SA)
	SAB = SA*CB + CA*SB
	CAB = CA*CB - SA*SB
	SBA = SB*CA - CB*SA
	SBA2 = SBA**2 
	CBA = CB*CA + SB*SA
	CBA2 = CBA**2
	end


************************************************************************

	subroutine ModelVarIni(fail, scale)
	implicit none
	integer fail
	RealType scale

#include "decl.h"

	integer nf

	fail = 0

	call AlphaS(Alfas, nf, scale)
	Alfas2 = Alfas**2
	GS = sqrt(4*pi*Alfas)
	end

#include "AlphaS.F"


************************************************************************

	subroutine ModelDigest
	implicit none

#include "decl.h"

	integer error

	call FHOutput(error, "stdout", 7, -1D0)
	end

* lumi_photon.F
* parton luminosity for a photon collider
* this file is part of FormCalc
* last modified 30 Nov 11 th


#define PARTON_T -1
#define PARTON_X -2
#define MINVAR PARTON_X


************************************************************************

	subroutine LumiDefaults(argc, argv)
	implicit none
	integer argc
	character*128 argv(*)

#include "xsection.h"

	if( Lower(SQRTS) .ne. Upper(SQRTS) )
     &    stop "Cannot handle a range of beam energies"
	end


************************************************************************

	subroutine LumiIni(fail)
	implicit none
	integer fail

#include "xsection.h"

	call SetEnergy(fail, Var(SQRTS))
	if( fail .ne. 0 ) return

	Lower(PARTON_T) = threshold/sqrtS
	Upper(PARTON_T) = 1
	Step(PARTON_T) = 0

	Lower(PARTON_X) = 0
	Upper(PARTON_X) = 1
	Step(PARTON_X) = 0
	end


************************************************************************

	subroutine Luminosity(fac)
	implicit none
	RealType fac

#include "xsection.h"

	integer fail
	RealType tau, x, xrange, beamenergy

	RealType CompAZ
	external CompAZ

	call SetEnergy(fail, Var(PARTON_T)*Var(SQRTS))
	if( fail .ne. 0 ) then
	  fac = 0
	  return
	endif

	tau = Var(PARTON_T)**2
	xrange = 1 - tau
	x = tau + xrange*Var(PARTON_X)

	beamenergy = .5D0*Var(SQRTS)

	fac = 2*fac*Var(PARTON_T)*xrange/x*
     &    CompAZ(x, beamenergy, 0)*
     &    CompAZ(tau/x, beamenergy, 0)
	end

* TInvariant.F
* calculates an t-type invariant, i.e. t_{ij} = (k_i - k_j)^2
* this file is part of FormCalc
* last modified 30 Nov 11 th

#include "types.h"


	RealType function TInvariant(i, j)
	implicit none
	integer i, j

	ComplexType vec(2,2, 8, 0:1)
	common /vectors/ vec

#define Ki(x,y) vec(x,y, 1, i)
#define Kj(x,y) vec(x,y, 1, j)

	RealType T11, T22
	ComplexType T12

	T11 = Re(Ki(1,1)) - Re(Kj(1,1))
	T22 = Re(Ki(2,2)) - Re(Kj(2,2))
	T12 = Ki(1,2) - Kj(1,2)

        TInvariant = T11*T22 - Sq(T12)
	end

* run.F
* defines parameter settings for one run, then includes main.F
* this file is part of FormCalc
* last modified 3 Mar 11 th


* Whether to run in debugging mode

#define DEBUG


* Uncomment the following to check UV- and IR-finiteness

c#define DELTA 1D7
c#define MUDIM 1D100
c#define LAMBDA 1D10

* The following sets all ren. constants to zero for debugging
* or if calculating a tree-level reaction.

c#define NO_RENCONST


* The model initialization code is included here.  Options for the
* model_XXX.F file (e.g. NO_SQUARK_MIXING for model_mssm.F) must be
* defined before the #include line.

* options for model_sm.F:
c#define NO_CKM

* options for model_mssm.F:
c#define NO_SQUARK_MIXING
c#define HIGGS_MASSES TREE
c#define HIGGS_MASSES SIMPLE
c#define HIGGS_MASSES FEYNHIGGS
c#define SM_HIGGS
c#define NMFV
c#define NO_EXCLUSION_LIMITS
c#define NO_GUT_RELATION

* options for model_thdm.F:
c#define MODEL_TYPE_I
c#define MODEL_TYPE_II
c#define NO_EXCLUSION_LIMITS

#define MODEL "model_sm.F"


* The LOOPn set up the model parameters for the calculation, either
* - as fixed declarations, e.g.
*       MH = 115
* - or as do-loops terminating on label 1, e.g.
*       do 1 MH = 100, 500, 10

#define LOOP1 MH = 120
#define LOOP2
#define LOOP3 TB = 5
#define LOOP4 MA0 = 500
#define LOOP5 MSusy = 1000
#define LOOP6 MUE = 200
#define LOOP7 Mino2 = 200
#define LOOP8 MGl = .8D0*MSusy
#define LOOP9 At = MUE/TB + 2*MSusy
#define LOOP10 Ab = At
#define LOOP11 Atau = At
#define LOOP12
#define LOOP13
#define LOOP14
#define LOOP15
#define LOOP16
#define LOOP17
#define LOOP18
#define LOOP19
#define LOOP20


* The PRINTn definitions contain output statements with which changes
* in parameters (typically the ones included in the scan) can be
* written to the output file and screen.  For example,
*       SHOW "MH", MH
* writes out the values of MH and MT in each pass of the loop.

#define PRINT1 SHOW "MH", MH
#define PRINT2
#define PRINT3
#define PRINT4
#define PRINT5
#define PRINT6
#define PRINT7
#define PRINT8
#define PRINT9
#define PRINT10
#define PRINT11
#define PRINT12
#define PRINT13
#define PRINT14
#define PRINT15
#define PRINT16
#define PRINT17
#define PRINT18
#define PRINT19
#define PRINT20


* Cuts and increments.  May be defined in terms of sqrtS, the CMS energy.
* Note: cuts are numbered by the integration they belong to, which is
* from the last particle downward, e.g. COSTH1CUT refers to cos(th) of
* the *last* particle.

#define SQRTSSTEP 10

#define COSTH1CUT .01D0
#ifdef DEBUG
#define XCOSTH1STEP 1/3D0
#else
#define XCOSTH1STEP .02D0
#endif

#define XMREM1STEP .1D0
#define E1MIN ESOFTMAX


* The integration parameters:
* - the desired relative and absolute accuracy

#define RELACCURACY 1D-3
#define ABSACCURACY 1D-10

* The multidimensional integration routines also need

#define METHOD DIVONNE
#define USERDATA bogus
#define VERBOSE 1
#define SEED 0
#define MINEVAL 0
#define MAXEVAL 50000

* for Vegas:
#define NSTART 1000
#define NINCREASE 500
#define NBATCH 1000
#define GRIDNO 0
#define STATEFILE ""

* for Suave:
#define NNEW 1000
#define FLATNESS 50

* for Divonne:
#define KEY1 47
#define KEY2 1
#define KEY3 1
#define MAXPASS 5
#define BORDER 1D-6
#define MAXCHISQ 10
#define MINDEVIATION .25D0

* for Cuhre:
#define KEY 0

* Now go for it:

#include "main.F"

* 2to2.F
* the kinematics for a 2 -> 2 process
* this file is part of FormCalc
* last modified 30 Nov 11 th


* some definitions for xsection.F
#define LEGS 4
#define LEGS_IN 2
#define LEGS_OUT 2
#define MASS_IN MASS1 + MASS2
#define MASS_OUT MASS3 + MASS4
#define TYPES TYPE1, TYPE2, TYPE3, TYPE4

* this defines the order of integrations:
#define XCOSTH1 1
#define MAXVAR XCOSTH1

#include LUMI


************************************************************************

	subroutine KinIni(fail)
	implicit none
	integer fail

#include "xsection.h"

	Lower(XCOSTH1) = 0
	Upper(XCOSTH1) = 1
	if( Lower(SQRTS) .gt. Upper(SQRTS) ) then
	  Step(XCOSTH1) = XCOSTH1STEP
	else
	  Step(XCOSTH1) = 0
	endif

	fail = 0
	end


************************************************************************

	subroutine InitialState
	implicit none

#include "xsection.h"

	RealType p

	p = ThreeMom(sqrtS, Re(MASS1), Re(MASS2))

	call VecSet(1, Re(MASS1), p, 0D0, 0D0, 1D0)
	call VecSet(2, Re(MASS2), p, 0D0, 0D0, -1D0)
	end


************************************************************************

	subroutine FinalState(fac)
	implicit none
	RealType fac

#include "xsection.h"

	RealType p, ex,ey,ez, msum, minv
	integer key

	p = 0
	ex = 0
	ey = 0
	ez = 1
	minv = sqrtS
	msum = MASS_OUT

	key = 0
#ifdef COSTH1CUT
	CutMin(XCOSTH1) = -(1 - COSTH1CUT)
	CutMax(XCOSTH1) = +(1 - COSTH1CUT)
	key = key + Cut(CUT_COSTH, CUT_MIN + CUT_MAX)
#endif

	call Split(3, Re(MASS3), p, ex,ey,ez, minv, msum,
     &    fac, key, Var(FIXED), Var(XCOSTH1), Var(TRIVIAL))

	call VecSet(4, Re(MASS4), p, ex,ey,ez)
	end
